
(* The type of tokens. *)

type token = 
  | WITH
  | WHILE
  | WHERE
  | WHEN
  | VAR
  | UNTIL
  | UNKNOWN
  | TYPE
  | TRY
  | TO
  | THROW
  | THEN
  | SUBTYPES
  | STRING_LIT of (string)
  | STRING
  | STAR_COLON
  | SLICING
  | SHR
  | SHL
  | SETTER
  | SEMI_COLON
  | RPAR
  | RETURN
  | REPEAT
  | RECORD
  | REAL_LIT of (Q.t)
  | REAL
  | RDIV
  | RBRACKET
  | RBRACE
  | PRINT
  | PRAGMA
  | POW
  | PLUS_COLON
  | PLUS
  | PASS
  | OTHERWISE
  | OR
  | OF
  | NOT
  | NEQ
  | MUL
  | MOD
  | MINUS
  | MASK_LIT of (Bitvector.mask)
  | LT
  | LPAR
  | LET
  | LEQ
  | LBRACKET
  | LBRACE
  | INT_LIT of (Z.t)
  | INTEGER
  | IN
  | IMPL
  | IF
  | IDENTIFIER of (string)
  | GT
  | GETTER
  | GEQ
  | FUNC
  | FOR
  | EXCEPTION
  | EQ_OP
  | EQ
  | EOR
  | EOF
  | ENUMERATION
  | END
  | ELSIF
  | ELSE
  | DOWNTO
  | DOT
  | DO
  | DIVRM
  | DIV
  | DEBUG
  | CONSTANT
  | CONFIG
  | CONCAT
  | COMMA
  | COLON_COLON
  | COLON
  | CATCH
  | CASE
  | BOR
  | BOOL_LIT of (bool)
  | BOOLEAN
  | BNOT
  | BITVECTOR_LIT of (Bitvector.t)
  | BITS
  | BIT
  | BEQ
  | BEGIN
  | BAND
  | ASSERT
  | AS
  | ARROW
  | ARRAY
  | AND

(* This exception is raised by the monolithic API functions. *)

exception Error

(* The monolithic API. *)

val stmts: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (AST.stmt)

val opn: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (AST.t)

val ast: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (AST.t)
