
(* This generated code requires the following version of MenhirLib: *)

let () =
  MenhirLib.StaticVersion.require_20231231

module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | WHILE
    | WHEN
    | UU_WRITE
    | UU_UNPREDICTABLE_UNLESS
    | UU_UNPREDICTABLE
    | UU_UNALLOCATED
    | UU_REGISTER
    | UU_READWRITE
    | UU_POSTDECODE
    | UU_OPERATOR_TWO
    | UU_OPERATOR_ONE
    | UU_OPCODE
    | UU_NOP
    | UU_NEWMAP
    | UU_NEWEVENT
    | UU_MAP
    | UU_INSTRUCTION_SET
    | UU_INSTRUCTION
    | UU_GUARD
    | UU_FUNCTION
    | UU_FIELD
    | UU_EXECUTE
    | UU_EXCEPTIONTAKEN
    | UU_EVENT
    | UU_ENCODING
    | UU_DECODE
    | UU_CONFIG
    | UU_CONDITIONAL
    | UU_BUILTIN
    | UU_ARRAY
    | UNTIL
    | UNPREDICTABLE
    | UNKNOWN
    | UNDEFINED
    | TYPEOF
    | TYPE
    | TRY
    | TO
    | THROW
    | THEN
    | STRING_LIT of (
# 59 "asllib/Parser0.mly"
       (string)
# 60 "asllib/Parser0.ml"
  )
    | STAR
    | SLASH
    | SEMICOLON
    | SEE
    | RPAREN
    | RETURN
    | REPEAT
    | REM
    | RECORD
    | REAL_LIT of (
# 63 "asllib/Parser0.mly"
       (Q.t)
# 74 "asllib/Parser0.ml"
  )
    | REAL
    | RBRACK
    | RBRACE_RBRACE
    | RBRACE
    | QUOT
    | QUALIFIER of (
# 65 "asllib/Parser0.mly"
       (string)
# 84 "asllib/Parser0.ml"
  )
    | PLUS_PLUS
    | PLUS_COLON
    | PLUS
    | OTHERWISE
    | OR
    | OF
    | NOT
    | MOD
    | MINUS
    | MASK_LIT of (
# 60 "asllib/Parser0.mly"
       (Bitvector.mask)
# 98 "asllib/Parser0.ml"
  )
    | LT_LT
    | LT_EQ
    | LT
    | LPAREN
    | LET
    | LBRACK
    | LBRACE_LBRACE
    | LBRACE
    | IS
    | INT_LIT of (
# 62 "asllib/Parser0.mly"
       (Z.t)
# 112 "asllib/Parser0.ml"
  )
    | INTEGER
    | INDENT
    | IN
    | IMPLIES
    | IMPLEM_DEFINED
    | IFF
    | IF
    | IDENTIFIER of (
# 59 "asllib/Parser0.mly"
       (string)
# 124 "asllib/Parser0.ml"
  )
    | GT_GT
    | GT_EQ
    | GT
    | FOR
    | EQ_GT
    | EQ_EQ
    | EQ
    | EOR
    | EOL
    | EOF
    | ENUMERATION
    | ELSIF
    | ELSE
    | DOWNTO
    | DOT_DOT
    | DOT
    | DO
    | DIV
    | DEDENT
    | DEBUG
    | CONSTRAINED_UNPRED
    | CONSTANT
    | COMMA
    | COLON
    | CATCH
    | CASE
    | CARET
    | BOOL_LIT of (
# 64 "asllib/Parser0.mly"
       (bool)
# 156 "asllib/Parser0.ml"
  )
    | BOOLEAN
    | BITS_LIT of (
# 61 "asllib/Parser0.mly"
       (Bitvector.t)
# 162 "asllib/Parser0.ml"
  )
    | BITS
    | BIT
    | BAR_BAR
    | BANG_EQ
    | BANG
    | ASSERT
    | ARRAY
    | AND
    | AMP_AMP
    | AMP
  
end

include MenhirBasics

# 23 "asllib/Parser0.mly"
  

  module Prelude = struct
    open AST
    open ASTUtils

    let build_expr_conds =
      let make_cond { desc = c, e_then; _ } e_else =
        E_Cond (c, e_then, e_else)
      in
      fun (elseifs, e) -> List.fold_right (map2_desc make_cond) elseifs e

    let build_stmt_conds (s_elsifs, s_else) =
      let s_else = match s_else with Some s -> s | None -> s_pass in
      let folder { desc = c, s_then; _ } s_else = S_Cond (c, s_then, s_else) in
      List.fold_right (map2_desc folder) s_elsifs s_else

    let t_bit = T_Bits (E_Literal (L_Int Z.one) |> add_dummy_pos, [])

    let make_ldi_vars (ty, xs) =
      let make_one x =
        S_Decl (LDK_Var, LDI_Typed (LDI_Var x, ty), None) |> add_dummy_pos
      in
      List.map make_one xs |> stmt_from_list |> desc

    let make_func name args return_type body =
      let subprogram_type =
        match return_type with | Some _ -> ST_Function | None -> ST_Procedure
      and parameters = [] in
      D_Func { name; args; return_type; body; parameters; subprogram_type }
  end

  open Prelude


# 215 "asllib/Parser0.ml"

module Tables = struct
  
  include MenhirBasics
  
  let token2terminal : token -> int =
    fun _tok ->
      match _tok with
      | AMP ->
          125
      | AMP_AMP ->
          124
      | AND ->
          123
      | ARRAY ->
          122
      | ASSERT ->
          121
      | BANG ->
          120
      | BANG_EQ ->
          119
      | BAR_BAR ->
          118
      | BIT ->
          117
      | BITS ->
          116
      | BITS_LIT _ ->
          115
      | BOOLEAN ->
          114
      | BOOL_LIT _ ->
          113
      | CARET ->
          112
      | CASE ->
          111
      | CATCH ->
          110
      | COLON ->
          109
      | COMMA ->
          108
      | CONSTANT ->
          107
      | CONSTRAINED_UNPRED ->
          106
      | DEBUG ->
          105
      | DEDENT ->
          104
      | DIV ->
          103
      | DO ->
          102
      | DOT ->
          101
      | DOT_DOT ->
          100
      | DOWNTO ->
          99
      | ELSE ->
          98
      | ELSIF ->
          97
      | ENUMERATION ->
          96
      | EOF ->
          95
      | EOL ->
          94
      | EOR ->
          93
      | EQ ->
          92
      | EQ_EQ ->
          91
      | EQ_GT ->
          90
      | FOR ->
          89
      | GT ->
          88
      | GT_EQ ->
          87
      | GT_GT ->
          86
      | IDENTIFIER _ ->
          85
      | IF ->
          84
      | IFF ->
          83
      | IMPLEM_DEFINED ->
          82
      | IMPLIES ->
          81
      | IN ->
          80
      | INDENT ->
          79
      | INTEGER ->
          78
      | INT_LIT _ ->
          77
      | IS ->
          76
      | LBRACE ->
          75
      | LBRACE_LBRACE ->
          74
      | LBRACK ->
          73
      | LET ->
          72
      | LPAREN ->
          71
      | LT ->
          70
      | LT_EQ ->
          69
      | LT_LT ->
          68
      | MASK_LIT _ ->
          67
      | MINUS ->
          66
      | MOD ->
          65
      | NOT ->
          64
      | OF ->
          63
      | OR ->
          62
      | OTHERWISE ->
          61
      | PLUS ->
          60
      | PLUS_COLON ->
          59
      | PLUS_PLUS ->
          58
      | QUALIFIER _ ->
          57
      | QUOT ->
          56
      | RBRACE ->
          55
      | RBRACE_RBRACE ->
          54
      | RBRACK ->
          53
      | REAL ->
          52
      | REAL_LIT _ ->
          51
      | RECORD ->
          50
      | REM ->
          49
      | REPEAT ->
          48
      | RETURN ->
          47
      | RPAREN ->
          46
      | SEE ->
          45
      | SEMICOLON ->
          44
      | SLASH ->
          43
      | STAR ->
          42
      | STRING_LIT _ ->
          41
      | THEN ->
          40
      | THROW ->
          39
      | TO ->
          38
      | TRY ->
          37
      | TYPE ->
          36
      | TYPEOF ->
          35
      | UNDEFINED ->
          34
      | UNKNOWN ->
          33
      | UNPREDICTABLE ->
          32
      | UNTIL ->
          31
      | UU_ARRAY ->
          30
      | UU_BUILTIN ->
          29
      | UU_CONDITIONAL ->
          28
      | UU_CONFIG ->
          27
      | UU_DECODE ->
          26
      | UU_ENCODING ->
          25
      | UU_EVENT ->
          24
      | UU_EXCEPTIONTAKEN ->
          23
      | UU_EXECUTE ->
          22
      | UU_FIELD ->
          21
      | UU_FUNCTION ->
          20
      | UU_GUARD ->
          19
      | UU_INSTRUCTION ->
          18
      | UU_INSTRUCTION_SET ->
          17
      | UU_MAP ->
          16
      | UU_NEWEVENT ->
          15
      | UU_NEWMAP ->
          14
      | UU_NOP ->
          13
      | UU_OPCODE ->
          12
      | UU_OPERATOR_ONE ->
          11
      | UU_OPERATOR_TWO ->
          10
      | UU_POSTDECODE ->
          9
      | UU_READWRITE ->
          8
      | UU_REGISTER ->
          7
      | UU_UNALLOCATED ->
          6
      | UU_UNPREDICTABLE ->
          5
      | UU_UNPREDICTABLE_UNLESS ->
          4
      | UU_WRITE ->
          3
      | WHEN ->
          2
      | WHILE ->
          1
  
  and error_terminal =
    0
  
  and token2value : token -> Obj.t =
    fun _tok ->
      match _tok with
      | AMP ->
          Obj.repr ()
      | AMP_AMP ->
          Obj.repr ()
      | AND ->
          Obj.repr ()
      | ARRAY ->
          Obj.repr ()
      | ASSERT ->
          Obj.repr ()
      | BANG ->
          Obj.repr ()
      | BANG_EQ ->
          Obj.repr ()
      | BAR_BAR ->
          Obj.repr ()
      | BIT ->
          Obj.repr ()
      | BITS ->
          Obj.repr ()
      | BITS_LIT _v ->
          Obj.repr _v
      | BOOLEAN ->
          Obj.repr ()
      | BOOL_LIT _v ->
          Obj.repr _v
      | CARET ->
          Obj.repr ()
      | CASE ->
          Obj.repr ()
      | CATCH ->
          Obj.repr ()
      | COLON ->
          Obj.repr ()
      | COMMA ->
          Obj.repr ()
      | CONSTANT ->
          Obj.repr ()
      | CONSTRAINED_UNPRED ->
          Obj.repr ()
      | DEBUG ->
          Obj.repr ()
      | DEDENT ->
          Obj.repr ()
      | DIV ->
          Obj.repr ()
      | DO ->
          Obj.repr ()
      | DOT ->
          Obj.repr ()
      | DOT_DOT ->
          Obj.repr ()
      | DOWNTO ->
          Obj.repr ()
      | ELSE ->
          Obj.repr ()
      | ELSIF ->
          Obj.repr ()
      | ENUMERATION ->
          Obj.repr ()
      | EOF ->
          Obj.repr ()
      | EOL ->
          Obj.repr ()
      | EOR ->
          Obj.repr ()
      | EQ ->
          Obj.repr ()
      | EQ_EQ ->
          Obj.repr ()
      | EQ_GT ->
          Obj.repr ()
      | FOR ->
          Obj.repr ()
      | GT ->
          Obj.repr ()
      | GT_EQ ->
          Obj.repr ()
      | GT_GT ->
          Obj.repr ()
      | IDENTIFIER _v ->
          Obj.repr _v
      | IF ->
          Obj.repr ()
      | IFF ->
          Obj.repr ()
      | IMPLEM_DEFINED ->
          Obj.repr ()
      | IMPLIES ->
          Obj.repr ()
      | IN ->
          Obj.repr ()
      | INDENT ->
          Obj.repr ()
      | INTEGER ->
          Obj.repr ()
      | INT_LIT _v ->
          Obj.repr _v
      | IS ->
          Obj.repr ()
      | LBRACE ->
          Obj.repr ()
      | LBRACE_LBRACE ->
          Obj.repr ()
      | LBRACK ->
          Obj.repr ()
      | LET ->
          Obj.repr ()
      | LPAREN ->
          Obj.repr ()
      | LT ->
          Obj.repr ()
      | LT_EQ ->
          Obj.repr ()
      | LT_LT ->
          Obj.repr ()
      | MASK_LIT _v ->
          Obj.repr _v
      | MINUS ->
          Obj.repr ()
      | MOD ->
          Obj.repr ()
      | NOT ->
          Obj.repr ()
      | OF ->
          Obj.repr ()
      | OR ->
          Obj.repr ()
      | OTHERWISE ->
          Obj.repr ()
      | PLUS ->
          Obj.repr ()
      | PLUS_COLON ->
          Obj.repr ()
      | PLUS_PLUS ->
          Obj.repr ()
      | QUALIFIER _v ->
          Obj.repr _v
      | QUOT ->
          Obj.repr ()
      | RBRACE ->
          Obj.repr ()
      | RBRACE_RBRACE ->
          Obj.repr ()
      | RBRACK ->
          Obj.repr ()
      | REAL ->
          Obj.repr ()
      | REAL_LIT _v ->
          Obj.repr _v
      | RECORD ->
          Obj.repr ()
      | REM ->
          Obj.repr ()
      | REPEAT ->
          Obj.repr ()
      | RETURN ->
          Obj.repr ()
      | RPAREN ->
          Obj.repr ()
      | SEE ->
          Obj.repr ()
      | SEMICOLON ->
          Obj.repr ()
      | SLASH ->
          Obj.repr ()
      | STAR ->
          Obj.repr ()
      | STRING_LIT _v ->
          Obj.repr _v
      | THEN ->
          Obj.repr ()
      | THROW ->
          Obj.repr ()
      | TO ->
          Obj.repr ()
      | TRY ->
          Obj.repr ()
      | TYPE ->
          Obj.repr ()
      | TYPEOF ->
          Obj.repr ()
      | UNDEFINED ->
          Obj.repr ()
      | UNKNOWN ->
          Obj.repr ()
      | UNPREDICTABLE ->
          Obj.repr ()
      | UNTIL ->
          Obj.repr ()
      | UU_ARRAY ->
          Obj.repr ()
      | UU_BUILTIN ->
          Obj.repr ()
      | UU_CONDITIONAL ->
          Obj.repr ()
      | UU_CONFIG ->
          Obj.repr ()
      | UU_DECODE ->
          Obj.repr ()
      | UU_ENCODING ->
          Obj.repr ()
      | UU_EVENT ->
          Obj.repr ()
      | UU_EXCEPTIONTAKEN ->
          Obj.repr ()
      | UU_EXECUTE ->
          Obj.repr ()
      | UU_FIELD ->
          Obj.repr ()
      | UU_FUNCTION ->
          Obj.repr ()
      | UU_GUARD ->
          Obj.repr ()
      | UU_INSTRUCTION ->
          Obj.repr ()
      | UU_INSTRUCTION_SET ->
          Obj.repr ()
      | UU_MAP ->
          Obj.repr ()
      | UU_NEWEVENT ->
          Obj.repr ()
      | UU_NEWMAP ->
          Obj.repr ()
      | UU_NOP ->
          Obj.repr ()
      | UU_OPCODE ->
          Obj.repr ()
      | UU_OPERATOR_ONE ->
          Obj.repr ()
      | UU_OPERATOR_TWO ->
          Obj.repr ()
      | UU_POSTDECODE ->
          Obj.repr ()
      | UU_READWRITE ->
          Obj.repr ()
      | UU_REGISTER ->
          Obj.repr ()
      | UU_UNALLOCATED ->
          Obj.repr ()
      | UU_UNPREDICTABLE ->
          Obj.repr ()
      | UU_UNPREDICTABLE_UNLESS ->
          Obj.repr ()
      | UU_WRITE ->
          Obj.repr ()
      | WHEN ->
          Obj.repr ()
      | WHILE ->
          Obj.repr ()
  
  and default_reduction =
    (16, "\000\000\000\000\000v\000\000\000\000\000\000\000\000\000\000\000\t\000\000\000\000\000\017\000\007\000\000\000@\000\000\000N\000\000\000\000\000\000\000C\000\000\000\r\000\000\000\000\000\000\000\000\0002\000\006\000\000\000?\000\000\000L\000\000\000\000\000B\000\000\000\015\000\005\000\000\000A\000\000\000P\000\b\000\000\000\000\000\000\000D\000\000\000V\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\221\000\000\000\000\002\224\000\000\002\220\002\223\002\222\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000.\000\000\000\000\002X\000\000\000/\000-\000\000\000\000\000\000\002\192\000\000\002\213\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000:\000=\0008\000\000\000\000\000;\0004\0005\000\000\000\000\000\000\000\000\000\000\002R\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002P\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002O\002Q\000\000\000\000\000>\0007\000<\0006\0009\002\132\000\000\000\000\002\140\000\000\002\141\000\000\000\000\002T\002\130\000\000\002\185\000\000\002\199\0000\000\000\000\000\000\000\002\188\000\000\002\136\000\000\002\137\000\000\002\205\000\000\000\000\000\000\000\000\002\127\000\000\000\000\002\164\000\000\002\171\000\000\002\172\002\129\000\000\002\184\000\000\002\197\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\251\000\000\000\000\000\000\000\000\002\187\000\000\002\138\000\000\002\139\000\000\002\203\002\128\000\000\002\186\000\000\002\201\002\131\000\000\000\000\000\000\000\000\002\190\000\000\000\000\002\189\000\000\002\207\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\225\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\230\000\000\000T\000\000\000\000\000\000\002\229\000\000\000R\000\000\000\000\000\000\000\000\000\000\002\231\000\000\002\194\000\000\002\217\000\000\000\000\000\000\000\000\002\193\000\000\002\215\000\000\000\000\000\000\000\000\000\000\000\000\002\195\000\000\002\219\000\000\000\000\002\169\000\000\000\000\000\000\000\000\000\000\002\167\000\000\002\168\002\166\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\179\002\182\002\177\000\000\000\000\002\180\002\173\002\174\000\000\000\000\002\183\002\176\002\181\002\175\002\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002|\000\000\000\000\000\000\000\000\000\000\002z\000\000\000\000\000\000\002{\000\000\002\170\000\000\000\000\000\000\002C\0016\000\000\000\000\002\191\000\000\002\211\000\000\002\209\000\000\000\000\000\000\0001\000\000\000\000\000\000\002\227\000\000\000\000\000\000\000\000\002~\000\000\002\232\000\000\000I\000\000\000`\000\000\000\000\000\000\000\000\000H\000\000\000^\000\000\000\000\000\000\000\000\000\000\000\000\000J\000\000\000b\000\000\000\000\000\000\000E\000\000\000\000\000\000\000F\000\000\000Z\000\000\000X\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0003\000\000\000\004\000\000\000\000\000+\000\000\000\000\000\014\000\000\000\018\000\000\000\000\000G\000\000\000\\\000\000\002\228\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001<\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000h\000\000\000k\000\000\000\000\000i\000\000\000j\000\000\000t\000\000\000\000\000n\000\000\000o\000\000\000l\000\000\000m\000\000\000\000\000r\000\000\000s\000q\000\000\002\\\000\000\000p\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\168\000\000\000\000\000\000\000\000\001\146\000\000\000\000\000\000\000\000\001\167\000\000\000\000\001\207\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\166\000\000\000\000\000\000\000\000\001\165\000\000\000\000\001\206\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\000\000\000\000\000\000\000\001\169\000\000\000\000\001\208\001\217\001\158\000\000\000\000\000\000\000\000\001\157\000\000\000\000\001\202\001\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\162\000\000\000\000\000\000\000\000\001\161\000\000\000\000\001\204\000\000\000\000\000\000\000\000\001\159\000\000\000\000\001\203\001\152\000\000\000\000\000\000\000\000\001\151\000\000\000\000\001\199\001\188\000\000\000\000\000\000\000\000\001\187\000\000\000\000\000\000\000\000\000\000\001\174\000\000\000\000\000\000\000\000\001\173\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\180\000\000\000\000\000\000\000\000\001\179\000\000\000f\000d\000\000\000e\000\000\000\000\000\000\000g\000\000\000\000\002Z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\196\000\000\000\000\000\000\000\000\000\000\001\172\000\000\000\000\000\000\000\000\001\171\000\000\000\000\000\000\000\000\000\000\001\178\000\000\000\000\000\000\000\000\001\177\000\000\000\000\000\000\001\195\000\000\000\000\000\000\000\000\000\000\001\176\000\000\000\000\000\000\000\000\001\175\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\184\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\186\000\000\000\000\000\000\000\000\001\185\000\000\000\000\000\000\000\000\001\183\000\000\000\000\000\000\000\000\000\000\001\182\000\000\000\000\000\000\000\000\001\181\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\192\000\000\000\000\000\000\000\000\001\191\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\190\000\000\000\000\000\000\000\000\001\189\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\194\000\000\000\000\000\000\000\000\001\193\001\221\001\218\001\154\000\000\000\000\000\000\001\211\000\000\000\000\000\000\001\212\000\000\000\000\000\000\000\000\001\153\000\000\000\000\001\200\001\226\000\000\001\225\000\000\000\000\000\000\000\000\001\222\001\148\000\000\000\000\000\000\000\000\001\147\000\000\000\000\001\197\001\156\000\000\000\000\000\000\001\209\000\000\000\000\000\000\001\210\000\000\000\000\000\000\000\000\001\155\000\000\000\000\001\201\001\150\000\000\000\000\000\000\000\000\001\149\000\000\000\000\001\198\001\213\000\000\000\000\000\000\001\214\001\215\000\000\000\000\001\216\001\228\000\000\000\000\000\000\000\000\001\227\000\000\000\000\001\229\001\230\001\164\000\000\000\000\000\000\000\000\001\163\000\000\000\000\001\205\001\223\000\000\000\000\000\000\001\224\001\219\000\000\000\000\000\000\001\220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002m\002j\002p\002k\002r\002i\002h\002o\002l\002q\002n\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\020\000\000\000\000\000\000\002\021\000\000\002\022\000\145\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\142\000\000\000\000\000\000\000\143\000\000\000\144\000\135\000\000\000\000\000\000\000\136\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\137\000\000\000\000\000\000\000\138\000\000\000\000\000\000\000\000\000}\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000~\000\000\000\000\000\000\000\127\000\000\000\128\000\000\000\000\000\000\000\000\000x\000|\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\139\000\000\000\000\000\000\000\140\000\000\000\000\000\000\000\000\000\130\000\134\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\131\000\000\000\000\000\000\000\132\000\000\000\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000y\000\000\000\000\000\000\000z\000\000\000{\000\000\000\000\0026\000\000\000\000\0027\000\000\000\000\000\000\000\000\000\000\000\000\0028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\253\001\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000\255\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\002\024\002\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\025\000\000\000\000\000\000\002\026\000\000\002\027\002\023\000\000\000\000\000\000\000\000\000\000\000\000\0020\0024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0021\000\000\000\000\000\000\0022\000\000\0023\002/\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\030\002\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\031\000\000\000\000\000\000\002 \000\000\002!\002\029\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002$\002(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002%\000\000\000\000\000\000\002&\000\000\002'\002#\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002*\002.\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002+\000\000\000\000\000\000\002,\000\000\002-\002)\000\000\000\000\000\000\000\000\0025\000\000\000\000\000\000\000\000\000\000\000\000\002:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0019\001:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002<\000\000\002@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002=\000\000\000\000\000\000\000\000\002>\000\000\000\000\002?\000\000\002;\000\000\000\000\0029\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002I\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\155\000\000\000\000\000\000\000\000\000\183\000\000\000\000\000\000\000\000\000\166\000\182\000\000\000\000\000\000\002V\000\000\000\000\000\000\000\000\000\185\000\000\000\000\000\000\000\000\000\167\000\184\000\000\000\000\000\000\000\000\000\228\000\000\000\000\000\000\000\000\000\217\000\227\000\000\000\000\000\000\000\000\000\230\000\000\000\000\000\000\000\000\000\218\000\229\000\000\000\000\000\000\000\000\000\149\000\000\000\000\000\000\000\212\000\000\000\000\000\000\000\000\000\000\000\211\000\206\000\000\000\000\000\000\000\000\000\000\000\153\000\000\000\000\000\000\000\000\000\175\000\000\000\000\000\000\000\000\000\162\000\174\000\000\000\000\000\000\000\000\000\177\000\000\000\000\000\000\000\000\000\163\000\176\000\000\000\000\000\000\000\000\000\220\000\000\000\000\000\000\000\000\000\213\000\219\000\000\000\000\000\000\000\000\000\222\000\000\000\000\000\000\000\000\000\214\000\221\000\000\000\000\000\000\000\000\000\147\000\000\000\000\000\000\000\208\000\000\000\000\000\000\000\000\000\000\000\207\000\204\000\000\000\000\000\000\000\154\000\000\000\000\000\000\000\000\000\179\000\000\000\000\000\000\000\000\000\164\000\178\000\000\000\000\000\000\000\000\000\181\000\000\000\000\000\000\000\000\000\165\000\180\000\000\000\000\000\000\000\000\000\224\000\000\000\000\000\000\000\000\000\215\000\223\000\000\000\000\000\000\000\000\000\226\000\000\000\000\000\000\000\000\000\216\000\225\000\000\000\000\000\000\000\000\000\148\000\000\000\000\000\000\000\210\000\000\000\000\000\000\000\000\000\000\000\209\000\205\000\160\000\000\000\000\000\000\000\000\000\000\000\161\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\156\000\000\000\000\000\000\000\000\000\000\000\157\000\000\000\000\000\000\000\000\000\000\000\000\000\158\000\000\000\000\000\000\000\000\000\000\000\159\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000\000\000\000\000\151\000\245\000\000\000\000\000\000\000\000\000\000\000\000\000\244\000\197\000\000\000\000\000\000\000\000\000\188\000\196\000\000\000\000\000\000\000\000\000\199\000\000\000\000\000\000\000\000\000\189\000\198\000\000\0013\000\000\000\000\000\000\002u\000\000\000\000\000\000\002v\000\000\0014\000\000\000\000\000\000\000\000\000\000\000\000\000\237\000\000\000\000\000\000\000\000\000\232\000\236\000\172\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\168\000\000\000\000\000\000\000\000\000\000\000\000\000\169\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\170\000\000\000\000\000\000\000\000\000\000\000\000\000\171\000\193\000\000\000\000\000\000\000\000\000\186\000\192\000\000\000\000\000\000\000\000\000\195\000\000\000\000\000\000\000\000\000\187\000\194\000\000\000\000\000\000\000\000\000\000\000\000\000\235\000\000\000\000\000\000\000\000\000\231\000\234\000\243\000\000\000\000\000\000\000\000\000\201\000\000\000\000\000\000\000\000\000\190\000\200\000\000\000\000\000\000\000\000\000\203\000\000\000\000\000\000\000\000\000\191\000\202\000\000\000\000\000\000\000\000\000\000\000\000\000\242\000\000\000\000\000\000\000\000\000\000\000\000\000\239\000\000\000\000\000\000\000\000\000\233\000\238\000\247\000\000\000\000\000\000\000\000\000\000\002F\000\000\000\000\000\000\000\249\000\000\000\000\000\000\000\000\000\241\000\000\000\000\000\000\000\246\000\000\000\000\000\000\000\000\000\000\000\248\000\000\000\000\000\000\000\000\000\240\000\000\000\003\000\001\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\005\000\000\000\000\000\000\001\006\000\000\001\007\001'\001(\000\000\000\000\000\000\000\000\000\000\000\000\001)\000\000\000\000\000\000\000\000\000\000\001\t\001\r\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\n\000\000\000\000\000\000\001\011\000\000\001\012\001\b\000\000\000\000\000\000\000\000\000\000\000\000\001!\001%\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\000\000\000\000\000\000\001#\000\000\001$\001 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\015\001\019\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\001\017\000\000\001\018\001\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\021\001\025\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\022\000\000\000\000\000\000\001\023\000\000\001\024\001\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\027\001\031\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\028\000\000\000\000\000\000\001\029\000\000\001\030\001\026\000\000\000\000\000\000\000\000\001&\001+\001-\000\000\0011\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001.\000\000\000\000\000\000\000\000\001/\000\000\000\000\0010\000\000\001,\001*\000\000\002J")
  
  and error =
    (126, "\000\000\000\000\024\000(@\001\002\004\003\128\016,!\000\000\000\002\244\022\161\000\133\b\177\014\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\232\020m\189\003\030\217\2522\012`\000\000\000\001\004#\132\n\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\190\129F\219\1441\237\159\195 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\016\174\129F\219\2089\237\159\195 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\b\225\002\133\0240\000\000\001\242\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\001\004\003\196\n\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\190\129F\219\1441\237\159\195 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\004+\160Q\182\244\014{g\240\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161F\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\232\020m\185\003\030\217\2522\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\004\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n@\199\182\127\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\016\012\001\002\155\2088\229\003A \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016 @\000\000\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0002\000\nn@\195\148\005\004\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000+\160Q\182\228\012{g\240\2001\128\000\000\000\004\016\015\016(Q\131\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003 \000\166\228\0129@PH1\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\002\186\005\027n@\199\182\127\012\131\024\000\000\000\000\000\000\000\000\001\000\016\000\000\000\000\000\000\000\000\000\000\000@\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\004\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000@\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\000A\166\196\012y@P\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\218\016\017\141\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\161\001\024\217\2522\012`\000\000\000\000\004\003\004\003\001@@\000\000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016,Q\131\000\000\000\031(\000\000\000\000\016@9@\161F\012\000\000\b|\160\000\000\000\000A\000\225\002\197\0240\000\000\001\242\128\000\000\000\000\000\000\016\000\000\000\000\000\000\128\000\000\000\000\000\004\016\014\016,Q\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\004)\185\003\014P42\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\161\001\024\217\2522\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\218\016\017\141\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\004)\185\003\014P\0202\012`\000\000\000\001\004\003\132\011\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\001\004\003\132\011\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\232\020m\185\003\030\217\2522\012`\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\016i\181\003\030P\0202\012`\000\000\000\001\004#\132\n\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003 @\166\228\0129@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l@\199\148\005\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\001\000\192\016i\181\003\158P\0202\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\142\016(Q\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\001\006\155\0161\229\001C \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0002\000\nn@\195\148\005\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\241\002\133\0240\000\000\001\242\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l@\199\148\005\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\000)\185\003\014Q\148\018\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\000)\185\003\014Q\148\018\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\016i\185\003\030P\0202\012`\000\000\000\004\003\000A\166\212\014y@P\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161F\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l@\199\148\005\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\192\016i\177\003\030P\0202\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003 \000\166\228\0129@PH1\128\000\000\000\016\000\000\000\000\004\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\229\002\133\0240\000\000\001\242\128\000\000\000\004\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l@\199\148\005\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\016\012\001\002\155\2088\229\003A \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\016\012\001\002\155\2088\229\003A \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\190\129F\219\1441\237\159\195 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\192\016)\189\003\142P4\018\012`\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\004\000\002\016\000@\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\232\020m\185\003\030\217\2522\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\000\002\155\1440\229\003A \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\016)\185\003\014P\020\018\012`\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\004\000\002\016\000@\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\001\006\155\0161\229\001C \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\192\016)\189\003\142P4\018\012`\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\004\000\002\016\000@\129\000\000\000\011\b\000\000\000\000@\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\000A\166\196\012y@P\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn@\195\148\r\004\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000@\166\228\0129@PH1\128\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\001\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\001\006\155\0161\229\001C \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\016i\177\003\030P\0202\012`\000\000\000\001\004\003\196\n\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\000\000\000\000\000\016\001\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000@\166\196\012y@P\1361\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\132\004i@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\000\016\012\016\012\005\001\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\177F\012\000\000\000|\160\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\132\004i@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\026l@\199\148\005\012\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\nl@\199\148\005\b\131\024\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\128\000\000\000\000\000\004\016\014P(Q\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\192\016i\177\003\030P\0202\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\001\006\155\0161\229\001C \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\016i\177\003\030P\0202\012`\000\000\000\000\003\000A\166\196\012y@P\2001\128\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000(\129\000\000@\144\000\000 \000\016\000\000\000\001\004\003\148\n\020`\192\000\000\007\202\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\001\000\000\132\000\016 @\000\000\002\194\000\000\000\000\000\000\128\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000/\160Q\182\228\012{g\240\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no@\227\148\r\004\131\024\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016 @\000\000\002\194\000\000\000\000\016\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\232\020m\185\003\030\217\2522\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\000\002\155\1440\229\003A \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\016)\185\003\014P\020\018\012`\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\004\000\002\016\000@\129\000\000\000\011\b\000\000\000\000@\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000/\160Q\182\228\012{g\240\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n@\199\182\127\012\131\024\000\000\000\000\000\200\000)\185\003\014P\020\018\012`\000\000\000\004\000\000\000\000\001\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161F\012\000\000\000|\160\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n@\199\182\127\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000/\160Q\182\228\012{g\240\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\000\000\166\228\0129@PH1\128\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\000\nn@\195\148e\004\131\024\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003 \000\166\228\0129@P\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\174\129F\219\1441\237\159\195 \198\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn@\195\148\005\004\131\024\000\000\000\001\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\190\129F\219\1441\237\159\195 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\200\000)\185\003\014P\020\018\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\128\000\000\000\128\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\001\000\005\000\016 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\t@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000 @\001@\004\b\000\000\000\000\000\000\000\000@\b!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000@\b!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\002\004\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\000)\185\003\014P\028\018\012`\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000 \000\000\004\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\002\000\000\000@\000\000\000\000\000\000\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\012\128\002\155\1440\229\001A \198\000\000\000\000\000\000 \000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000@\000\000\001\000\004\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\004\018\014\016(Q\131\000\000\000\031(\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\r\000\000 \016\000\000\000\000\000\000\001\004#\132\n\020`\192\000\000\007\202\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\128\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000 \000\003@\004\b\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\004\002\020\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\016\bP\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\144\000\000\001\002\000\000\000\000\000\000\016@8@\161F\012\128\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@<@\161F\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\004\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\004\002\020\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\018\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\002\000\0004\000@\128@\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\012\128\002\155\1440\229\001A \198\000\000\000\000\000\000 \000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\128\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0002\000\nn@\195\148\005\004\131\024\000\000\000\000\000\000\128\000\000@\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\004\003\000@\166\244\0149@\208H1\128\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\000\000\000\128\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\144\000\002\001\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\b\000\b\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no@\227\148\r\004\131\024\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016 @\000\000\002\194\000\000\000\000\000\000\b\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000 \000 \000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\000)\185\003\014P4\018\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\012\001\002\155\1440\229\001A \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\b\000\b\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\128\000\128\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014P(Q\131\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\002\000\002\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\002\000\002\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\b\000\b\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\b\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\002\016\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\132\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000!\000\004\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000!\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\b\000\b@\001\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\016 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\200\000)\185\003\014P\020\018\012`\000\000\000\000\000\002\000\000\001\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161F\012\000\000\000|\160\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\001\000\192\016)\189\003\142P4\018\012`\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\004\000\002\016\000@\129\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\012\001\002\155\2088\229\003A \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\000)\185\003\014P4\018\012`\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\012\001\002\155\1440\229\001A \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161F\012\000\000\000|\160\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\b\000\b\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000 \000 \000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004#\132\n\020`\192\000\000\007\202\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\128\000\128\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\002\000\002\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003 \000\166\228\0129@PH1\128\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B,\002`p,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\002\000\002\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\176\t\129\192\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\192&\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\139\000\152\028\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\176\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\144\b\001\192\177\132\000\000\000\011PZ\132\002\0202\196\006\015\018\198\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\140\000\002\155\1440\229\005A \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\000)\185\003\014X\020\018\012`\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\000-\185\003\014P\020\018\012`\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000\128\000\000\000\000\000\000\001\000\193\000\192P\016\000\000\001@\000\000\000\000\011\016R\132\002\020\"\194 \007\130\199\000\000\000\000\000\016\012\016\012\005\001\000\000\000\020\000\000\000\000\000\177\005(@!B,\"\000x,p\000\000\000\000\001\000\193\000\192P\016\000\000\001@\000\000\000\000\011\016R\132\002\020\"\194 \007\130\199\000\000\000\000\000\016\012\016\012\005\001\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\194 \007\130\199\000\000\000\000\000\016\012\016\012\005\001\000\000\000\020\000\000\000\000\000\177\005(@!B,\"\000x,p\000\000\000\000\001\000\193\000\192P\016\000\000\001@\000\000\000\000\011\016R\132\002\020\"\194 \007\130\199\000\000\000\000\000\016\012\016\012\005\001\000\000\000\020\000\000\000\000\000\016@8@\177F\012\000\000\000|\160\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"\194 \007\130\199\000\000\000\000\000\016\012\016\012\005\001\000\000\000\020\000\000\000\000\000\177\005(@!B,\"\000x,p\000\000\000\000\001\000\193\000\192P\016\000\000\001@\000\000\000\000\011\016R\132\002\020\"\194 \007\130\199\000\000\000\000\000\016\012\016\012\005\001\000\000\000\020\000\000\000\000\000\177\005(@!B,\"\000x,p\000\000\000\000\001\000\193\000\192P\016\000\000\001@\000\000\000\000\011\016R\132\002\020\"\194 \007\130\199\000\000\000\000\000\016\012\016\012\005\001\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\139\b\128\028\011\028\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\128\000\000\002\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000,AJ\016\bP\137\000\128\028\011\024 \000\000\000\000\000\000\004\000\001\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\b\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \b\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\016\000\000\000-Aj\016\bP\139\016\000<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\016\000\000\000-Aj\016\bP\139\016\000<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\003\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\002\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\011\000\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\128\000\000\002\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\002\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\139\000\128\028\011\024\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\001\000\000@\000\000 \000\000@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\002\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \b\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\b\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\b\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\001\000\000@\000\000 \000\000@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\002\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000\000\166\228\012;@PH1\128\000\000\000,AJ\016\bP\139\000\128\028\011\024\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\001\000\000@\000\000 \000\000@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\002\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \b\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\b\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\b\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\128\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\128\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\000\003\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\000\nn@\195\150\005\004\131\024\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\016\000\000\000-Aj\016\bP\139\016\024<K\024\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@ \007\002\198\016\000\000\000-Aj\016\bP\203\016X<K\024@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\022\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \b\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\016\000\000\000-Aj\016\bP\139\016X<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\016\000\000\000-Aj\016\bP\139\016X<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\005\131\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\b<K\024\000\000\000\000\177\005(@!B$\002\000p,a\000\000\000\002\212\022\161\000\133\012\177\000\003\196\177\132\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\128\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\003\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\003\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\000<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\002\015\018\198\000\000\000\000,AJ\016\bP\137\000\128\028\011\024@\000\000\000\181\005\168@!C,@\000\241,a\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\016\000\000\000-Aj\016\bP\139\016\000<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128 \000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\176\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \t\128\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\016\000\000\000-Aj\016\bP\139\016\024<K\024@\000\000\000\181\005\168@!B,@ \241,`\000\000\000\002\196\020\161\000\133\b\144\b\001\192\177\132\000\000\000\011PZ\132\002\0202\196\000\015\018\198\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\000\003\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\002\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\011\000\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\128\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\001\131\196\177\132\000\000\000\011PZ\132\002\020\"\196\002\015\018\198\000\000\000\000,AJ\016\bP\137\000\128\028\011\024@\000\000\000\181\005\168@!C,@\000\241,a\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\016\000\000\000-Aj\016\bP\139\016\000<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128 \000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\176\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\001\131\196\177\132\000\000\000\011PZ\132\002\020\"\196\002\015\018\198\000\000\000\000,AJ\016\bP\137\000\128\028\011\024@\000\000\000\181\005\168@!C,@\000\241,a\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\016\000\000\000-Aj\016\bP\139\016\000<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128 \000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\176\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\016\000\000\000-Aj\016\bP\139\016\000<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\000\nn@\195\150\005\004\131\024\128\000\000\000\000\000\000\016\000\004\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000 \000\000\000\000\000\000\004\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\177\005(@!B$\002\000p,`\000\000\000\000\000\000\000\000\000\004\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\000\003\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\000<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \b\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\000\003\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000@\000\000\000\181\005\168@!B,@\000\241,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\000\003\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\129\000\005\000\016 \000\000\000\000\000\000\000\001\000 \132\000\016 @\000\000\002\194\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\004\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\002\000\000\000\000\000\000\000\000\001\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\001\000\000\132\000\016 @\000\000\002\194\000\000\000\000\000\000\b\016\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000@\000!\000\005\b\016\000\000\000\176\128\000\000\000\000\000\002\004\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\016)\185\003\014P4\018\012`\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\129\000\000\000\016\000\000\000\000\000\000\000\000\000\000\128\000\000\020\000\000\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000 \132\000\016 @\000\000\002\194\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@\193\000`\004\011\b@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000 @\000\000\000\000\000\000\128\000\000\000\000\000\004\000\002\016\000@\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\0160@\024\001\002\194\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\002\004\000\000\000, \000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\012\016\006\000@\176\132\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\003\004\001\128\016,!\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\014\000\002\155\1440\229\001A \198\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000` \161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\b\000\000\001@\000\n\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\002\004\000\000\000, \000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\012\016\006\000@\176\132\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\003\004\001\128\016,!\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\196\000\016 @\000\000\002\194\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@\193\000`\004\011\b@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\0160@\024\001\002\194\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\006\002\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\001@\000\n\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\002\004\000\000\000, \000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\012\016\006\000@\176\132\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\003\004\001\128\016,!\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\196\000\016 @\000\000\002\194\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@\193\000`\004\011\b@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\0160@\024\001\002\194\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\006\002\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000@\166\228\0129@PH1\128\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\012\001\002\155\1440\229\003A \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\016)\185\003\014P\020\018\012`\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0000\004\nn@\195\148\r\004\131\024\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000@\166\228\0129@PH1\128\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\0008\000\nn@\195\148\005\004\131\024\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\128\000\166\228\0129@PH1\128\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@\193\000`\004\011\b@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\0160@\024\001\002\194\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000@\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@\193\000`\004\011\b@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\001\128\002\132\000\016 @\024\001\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\004\000\130\016\000@\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\0160@\024\001\002\194\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\012\016\006\000@\176\132\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\0160@\024\001\002\194\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\b!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\0160@\024\001\002\194\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\012\016\006\000@\176\132\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\004\000\002\016\000@\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\012\016\006\000@\176\132\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\002\000\000\000\000\000\000\016\002\b@\001\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016 @\000\000\002\194\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\002\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000`\000\161\000\004\b\016\006\000@\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\002\004\000\000\000, \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\006\000\n\016\000@\129\000`\004\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\b\016\000\000\000\176\128\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\024\000(@\001\002\004\001\128\016, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\012\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\000)\185\003\014P\028\018\012`\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\128\000\000\000\000\000\002\196\020\161\000\133\b\144\b\001\192\177\128\000\000\000\000\000\000\000\000\000\016\000\000\b\000\000\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\224\000)\185\003\014P\020\018\012`\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@ \007\002\198\016\000\000\000-Aj\016\bP\203\016X\028K\024@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\022\007\018\198\016\000\000\000-Aj\016\bP\139\016H\028K\024\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\140\000\002\155\1440\229\005A \198\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\000\192\000)\185\003\014X\020\018\012`\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\004\001\196\177\128\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000\012\000\002\219\1440\229\001A \198\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\002\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000 \b\000\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\004\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\003\000\000\166\228\0129`PH1\128\000\000\000\000\000\000\000\000\000@\000\000\000\000\000@\000\000\000\181\005\168@!B,@\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B$\002\000p,a\000\000\000\002\212\022\161\000\133\012\177\004\001\196\177\132\000\000\000\011PZ\132\002\020\"\196\000\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\128\000\000\000\000\000\000\000\016@8@\161F\012\000\000\000|\160\000\000\000\000\002\192\000)\185\003\014P\020\018\012`\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\001\000\000\000\002\212\022\161\000\133\b\177\004\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\004\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\018\007\018\198\000\000\000\000,AJ\016\bP\137\000\128\028\011\024@\000\000\000\181\005\168@!C,A\000q,a\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128 \000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\176\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \t\128\000\000\000\000\000\000\001\004\003\132\n\020`\192\000\000\007\202\000\000\000\000\000,\000\002\155\1440\229\001A \198\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\016\000\000\000-Aj\016\bP\139\016X\028K\024@\000\000\000\181\005\168@!B,A q,`\000\000\000\002\196\020\161\000\133\b\144\b\001\192\177\132\000\000\000\011PZ\132\002\0202\196\016\007\018\198\016\000\000\000-Aj\016\bP\139\016\000\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\004\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\002\000\000\000\000\000\000\000\000A\000\225\002\133\0240\000\000\001\242\128\000\000\000\000\011\000\000\166\228\0129@PH1\128\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\128\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!B$\000\000p,`\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\005\129\196\177\132\000\000\000\011PZ\132\002\020\"\196\018\007\018\198\000\000\000\000,AJ\016\bP\137\000\128\028\011\024@\000\000\000\181\005\168@!C,A\000q,a\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128 \000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\176\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\002\212\022\161\000\133\b\177\005\129\196\177\132\000\000\000\011PZ\132\002\020\"\196\018\007\018\198\000\000\000\000,AJ\016\bP\137\000\128\028\011\024@\000\000\000\181\005\168@!C,A\000q,a\000\000\000\002\212\022\161\000\133\b\177\000\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128 \000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\176\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\011\016R\132\002\020\"@\000\007\002\198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!B,A\000q,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128 \000\000\000\000\000\000\000\004\016\014\016(Q\131\000\000\000\031(\000\000\000\000\000\176\000\nn@\195\148\005\004\131\024\000\000\000\002\196\020\161\000\133\b\144\000\001\192\177\128\000\000\000\000\000\000\000\000\000\000\000&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\004\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000,AJ\016\bP\137\000\000\028\011\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\004\000\000\000\011PZ\132\002\020\"\196\016\007\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\001\000\000\000\002\212\022\161\000\133\b\177\004\001\196\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000-Aj\016\bP\139\016@\028K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")
  
  and start =
    2
  
  and action =
    ((16, "\028\030\028`\000\000c\228\000\141\201<\000\127\201<\000\000\001\026\201\170\000\000\000\000\000d\000\000\001\200\000\000\000\155\000\007\000C\000\000\202\024\000\000\201<\201<\201<\202\024\000\000\000\000\001\020\000\000\002v\000\000\201<\000l\000\000\202\134\000\000\000\000\001^\000\000\003$\000\000\000\000\000$\201<\001\204\000\000\003\210\000\000\201<\000<\206\230\000\136\000\210)r\001\000\024\226\000\000\0016\001\130\000\000\024\226\000\000\000\000\000\000\001\192\201<IN\201<\t\240\202\244\002J\201<N\\\201<\n\158\000\170\000h\000\000\000$\000h\000\000\002t\000\000\000\000\201<\011L\002\006\000\000F\142\000\000\201<\011\250\201<\012\168\201<\rV\201<\014\004\201<\014\178\201<\015`\201<\016\014\201<\024\228\201<\016\188\201<\017j\201<\025\146\030\172\000\000\000\000\000\000\002:\002h\000\000\000\000\000\000\203\142\201<\203\142\001R\203\142\000\000N\\\201<\018\024\201<\026@\201<\026\238\201<\018\198\201<\019t\201<bh\203\142\000\000\201<\020\"\201<\020\208\201<\021~\203\142\000\000\000\000\022,\002\240\000\000\000\000\000\000\000\000\000\000\000\000G\022\203\190\000\000\003^\000\000N\228\201<\000\000\000\000\002X\000\000G\166\000\000\000\000\003N\004:\029\176\000\000\204X\000\000\004\192\000\000H6\000\000\202\244\202\244\201<b\240\000\000\201<\005\012\000\000\202\134\000\000\005\150\000\000\000\000\002p\000\000H\198\000\000\201<N\\\201<IN\201<bh\201<IN\000\000\005@\201<IN\030@\000\000\204\136\000\000\005\174\000\000I\222\000\000\000\000\003b\000\000Jn\000\000\000\000\005\148\201<bh\000\012\000\000\202\244\003h\000\000J\254\000\000\202\244\005\174\207\128\005\166\005\242)\162\0064\024\226\000\000\006.\207\176\006\002\006P)\252\006\140\024\226\000\000\004\128\000\000*\140\006\166\024\226\000\000\005.\000\000IN\201<\161\148\006\178\024\226\000\000\003|\000\000K\142\000\000*\186\006\180\024\226\003\136\000\000L\030\000\000N\228\201<\162\028\006\190\024\226\003\148\000\000L\174\000\000Ol\205\"\000\000O\244\202\244P|\001@\000\216\000\000\006\240\000\000\000\000\202\244Q\004\202\244Q\140\202\244\162\164\202\244R\020\202\244R\156\202\244S$\202\244S\172\202\244T4\202\244T\188\202\244UD\202\244\199\012\202\244U\204\202\244VT\031b\000\000\000\000\000\000\006\148\006\182\000\000\000\000\000\000\203\142\006\248\000\000\000\000\000\000\000\000\000\000\202\244V\220\202\244\199\148\202\244Wd\202\244W\236\202\244\000\000\202\244Xt\202\244X\252\202\244\000\000\202\244\163*\202\244\000\000\006\254\000\000\006\194\002\172\205\"\000\000\000\000\007\000\003\160\000\000M>\000\000M\206\000\000Y\132Z\012\007\006\000\000!\198\202\244\007\004\000\000\006\156\024\226\000x\024\226\000\000\007\030\000\000\003\162\000\000\005\220\000\000*\202\006\254\024\226\003\190\000\000\006\138\000\000bh\201<\163\176\007\000\024\226\003\198\000\000\0078\000\000\022\218\161\012\000\200\000\000\202\244\007\024\003\200\000\000\007\230\000\000\b\148\000\000\0076\000\000\161\148\201<IN\006\210\201<\023\136\007.\000\000cx\000\000\201<\007>\000\000\0246\007@\000\000\007B\000\000\161\148\003\204\000\000\tB\000\000\162\028\000\000\003\024\006\214\006\250\000\002\006\236c\228\002\216\006\224\007\002\007\028\024\226\007\014\007f\024\226\000\000\007X\007p\007\016c\228\007\004\007&\001\"\024\226\001\226\007\022c\228\026>\000Z\007FZ@\007\026\007>\030\250\201<IN\007\"\007B\030\250\000Pd\026\002\142d\208\007\\\201<\163\176\002`\0078\201<N\\e\134\007L\007\160f<\000B\007\176f\242\201<g\168\000\135\205R\007\178h^\002\226\007T\201<bhi\020\007D\007j\000;\007^\201<\161\012i\202\000\000\025\154\000\000\007P\007r\000\000\025\154\000\000\007\180\000\000\001\162\202\244\000\000\007p\000\000\205\236\000\000\007\184\000\000\003\"\003\030\000\000\007\190\000\000\000\000\025\154\000\000\007\206\000\000\003\014\007t\201<\163\176j\128\000\004\007\220k6\000t\007\136\201<\164>k\236\201<\164\204l\162\007\236mX^v\007\184\201<\164>\003\204\007\144\201<\165Zn\014\003\206\007\146\201<\165\232n\196\007\190\201<\164\204\000\228\007\150\201<\166voz\003\208\007\154\201<\167\004p0\201<\167\146p\230\007\196\208J\007\142\007\176+r\007\226\024\226\003\218\007\174\201<\168 q\156\000\000\000U\201<\168\174rR\000\000\000$\201<\169<s\b\000\000\b\020s\190\000\000,\002\007\246\024\226\003\232\007\190\201<\169\202tt\000\000\000\136\201<\170Xu*\000\000\b\"u\224\000\000\161\148\201<\170\224\007\254\024\226\003\252\007\198\201<\171nv\150\000\000\000\210\201<\171\252wL\000\000\b(x\002\000\000\000\000\000\000\001\128\201<\172\138x\184\000\000\b*yn\000\000\000\000\202\244\b\022\004\004\007\210\201<\173\024z$\000\000\001\228\201<\173\166z\218\000\000\b4{\144\000\000\002V\201<\1744|F\000\000\b6|\252\000\000\000\000\002|\201<\174\194}\178\000\000\b@~h\000\000\000\000\007\230\201<\175P\127\030\000\000\004\n\007\236\201<\175\222\127\212\000\000\007\238\201<\176l\128\138\000\000\007\236\b\014\004>\b\002\201<\176\250\129@\000\000\b\004\201<\177\136\129\246\000\000\002L\000\000\000\000\002L\000\000\007\234\002L\bh\000\000\003*\002L\000\000\007\240\002L\bn\b\020\201<\178\022\130\172\000\000\004V\b\022\201<\178\164\131b\000\000\b\024\201<\1792\132\024\000\000\002\162\b\030\201<\179\192\132\206\000\000\b \201<\180N\133\132\000\000\201<\180\220\134:\000\000\004j\b\"\201<\181j\134\240\000\000\b*\201<\181\248\135\166\000\000\b`\201<\165Z\002\002\b:\201<\182\134\136\\\000\000\202\244\b\134\004z\b>\201<\183\020\137\018\000\000\b@\201<\183\162\137\200\000\000\bB\201<\1840\138~\000\000\004|\bD\201<\184\190\1394\000\000\bH\201<\185L\139\234\000\000\br\208z\b<\b^,\146\b\144\024\226\004~\b\\\201<\185\218\140\160\000\000\bb\201<\186h\141V\000\000-\"\b\164\024\226\004\136\bl\201<\186\246\142\012\000\000\bp\201<\187\132\142\194\000\000\162\028\201<\188\012\b\172\024\226\004\142\bt\201<\188\154\143x\000\000\bv\201<\189(\144.\000\000\000\000\000\000\000\000\206\028\b\216\144\228\000\000\b\214\b\224\145\154\000\000\002\144\201<\189\182\146P\000\000\b\226\147\006\000\000\000\000\147\188\000\000\b\146\b\234\b\244\148r\000\000\000\000\002\198\201<\190D\149(\000\000\b\250\149\222\000\000\000\000\206\182\b\252\150\148\000\000\t\b\t\014\151J\000\000\003\004\201<\190\210\152\000\000\000\t\016\152\182\000\000\000\000\003<\201<\191`\153l\000\000\t\018\154\"\000\000\000\000\t\020\t\026\154\216\000\000\000\000\191\238\155\142\000\000\000\000\201<\165\232\t\030\156D\000\000\t \156\250\000\000\000\000\000\000\003>\201<\192|\157\176\000\000\t\"\158f\000\000\000\000\t \t&\159\028\000\000\000\000\t(\t.\159\210\000\000\b\204\b\242\030\250\b\224\t\002\030\250\201<\162\028\030\250\029\022\030\250\b\248\b\236\201<IN\201<IN\t\b\030\250\201<IN\b\236\t\012\000\226 \024Z\174 \024[f \024\\\030 \024\b\228\t\b\\\214 \024]\142 \024^F \024\203\142\tF^\254 \024_\182 \024`n \024a& \024a\222 \024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\160\136\201<\163\176\030\250\000\161\201<\164>\030\250\000\161\000\000\000\151\000\226\031\176\000\226\030\250\b\230\000\226\000\000\003\170\201<\164\204\030\250\000\161\001l-\220\000\000\030\250\t\000.\146\000\000/H\000\000\000\000\003\232\201<\165Z\030\250\000\161\003~\000\226\000\000\030\250\t\006\000\226\000\000\000\226\000\000\000\000\030\250\t\012\000\226\000\000\2006\201<\165\232\030\250\000\161\003\236\000\226\000\000\030\250\t\020\000\226\000\000\000\238\030\250\t\002\000\226\000\000\000\000\004\030\201<\166v\030\250\000\161\004\000\000\226\000\000\030\250\t\026\000\226\000\000\000\226\000\000\001\232\030\250\t\b\000\226\000\000\000\000\201<IN\200\180\201<\167\004\030\250\000\161\004J\000\226\000\000\030\250\t\030\000\226\000\000\001\234\030\250\t\012\000\226\000\000\000\000\004>\201<\167\146\030\250\000\161\004T\000\226\000\000\030\250\t\"\000\226\000\000\000\226\000\000\004\150\201<\168 \030\250\000\161\004Z\000\226\000\000\030\250\t$\000\226\000\000\000\226\000\000\t\022/\254\000\000\t\0240\180\000\000\201<N\\\tL\030\250\t$1j\000\000\t*\027\170\201<\168\174 f\027\170\030\250\t0\027\170\000\000\000\000\004\152\201<\169<\030\250\000\161\004\154\027\170\000\000\030\250\tF\027\170\000\000\027\170\000\000\030\250!\028\031\176\030\250\tB2 \000\000\000\000\004\168\201<\169\202\030\250\000\161\004\1662\214\000\000\030\250\tX3\140\000\0004B\000\000\000\000 f!\210!\028\030\250\tF4\248\000\000\000\000\004\180\201<\170X\030\250\000\161\004\1845\174\000\000\030\250\t\\6d\000\0007\026\000\000\000\000\000\165\201<\170\224\030\250\000\161\004\204\027\170!\210\"\136\"\136\030\250\tN7\208\000\000\000\000\004\228\201<\171n\030\250\000\161\004\2108\134\000\000\030\250\td9<\000\0009\242\000\000\000\000\030\250\th\027\170#>#>#\244\030\250\tV:\168\000\000\000\000\004\236\201<\171\252\030\250\000\161\004\214;^\000\000\030\250\tl<\020\000\000<\202\000\000\000\000\027\170$\170#\244%`\030\250\tZ=\128\000\000\000\000\005\006\201<\172\138\030\250\000\161\004\248>6\000\000\030\250\tp>\236\000\000?\162\000\000\000\000\tn\030\250\tx@X\000\000\tf\n\000\201<\193\n\t\134A\014\000\000\tz\tr\t\166\t\150\t\182\001 \201<N\228\002\006\030\250\t\134\001 \000\000\000\000\0014$\170\003\186\030\250\t\136\t\140A\196\000\000Bz\000\000\005\022\201<\173\024\030\250\000\161\005\b\t\144C0\000\000\030\250\t\166\t\148C\230\000\000\t\154D\156\000\000ER\000\000\t\160F\b\000\000\t\166c\228\002~Z\210\004^\t\194c\228\004F\t\182\t\218\t\240\003\140\0054\003\140\000\000\n\026\n2\t\208c\228\024\226\001\252\t\214\201<\193\152\t\216c\228\024\226\002\238\n\004\201<b\240\n@\t\230c\228\003N\000\014\t\236c\228\000\000[\138\005\014\t\242c\228\000\000\208\216\030\250\t\224c\228\000\000\000\000\n\022\002\128\024\226\000\000\nf\005\026\n\bc\228\000\000\209*\030\250\t\246c\228\000\000\000\000\024\226\005F\n\016c\228\000\000\209D\030\250\t\254c\228\000\000\000\000\nh\005n\n\024c\228\000\000\209\136\030\250\n\006c\228\000\000\000\000\201<\194&\n\028c\228\000\000\005\166\n\030c\228\000\000\030\250\n\016c\228\n&c\228\000\000\000\000\n\026\nB\000\188\n4c\228\000\000\\B\005\148\n<c\228\000\000\209\218\030\250\n,c\228\000\000\000\000\n\162\005\184\nDc\228\000\000\209\244\030\250\n2c\228\000\000\000\000\026>\005\186\nHc\228\000\000\2108\030\250\n6c\228\000\000\000\000\n\160\005\188\nRc\228\000\000\210\138\030\250\n@c\228\000\000\000\000\201<\194\180\nVc\228\000\000\005\190\n\\c\228\000\000\030\250\nN\203\164\nhc\228\000\000\000\000\001j\npc\228\000\000\\\250\005\198\nrc\228\000\000\210\164\030\250\nbc\228\000\000\000\000\n\216\005\200\nzc\228\000\000\210\232\030\250\nhc\228\000\000\000\000Z@\005\222\n~c\228\000\000\211:\030\250\nlc\228\000\000\000\000\n\216\005\240\n\136c\228\000\000\211T\030\250\nvc\228\000\000\000\000\201<\195B\n\148c\228\000\000\005\226\n\154c\228\000\000\030\250\n\140\206\002\n\162c\228\000\000\000\000\000\000\201<\195\202\011\022\n\180c\228\000\000\n\168\n\202\n\232\201<cx\011$\n\196c\228\000\000\201<\196R\011*\n\200c\228\000\000\n\244\201<\161\012\0110\n\210c\228\000\000\201<\196\218\0118\n\214c\228\000\000\000\000\n\208\n\244\n\238\201<\197h\n\238c\228\000\000\n\244\201<\197\246\n\242c\228\000\000\000\000\011\026\003\140\011D\011\\\n\252c\228\000\000\000\000\211\152\030\250\n\236c\228\000\000\000\000\011b\005\244\011\004c\228\000\000\211\234\030\250\n\246c\228\000\000\000\000]\190\000\000\005\030\005j\024\226\000\000\011\"\005v\024\226\000\000\011h\000\000\011\"\024\226\0112\005\254\011$c\228\000\000\212\004\030\250\011\018c\228\000\000\000\000\000\000\011\136\011*\011J\030\250\011\026c\228\000\000\011&\011H\011f]\190\011B\011f\030\250\011:c\228\000\000\011\176\011`\011\128\030\250\011Pc\228\000\000\011\148]\222\011l\011\140\030\250\011^c\228\000\000\011\212\011v\011\150\030\250\011fc\228\000\000\000\000\212H\030\250\011lc\228\000\000\000\000\011\226\006\n\011\132c\228\000\000\212\154\030\250\011xc\228\000\000\000\000\011\148\024\226\011\170\006\018\011\156c\228\000\000\212\180\030\250\011\138c\228\000\000\000\000\000\000^\150\006\020\011\160c\228\000\000\212\248\030\250\011\142c\228\000\000\000\000\012\004\0066\011\166c\228\000\000\213J\030\250\011\150c\228\000\000\000\000\011\212\024\226\011\254\012\022\011\184c\228\000\000\011\194\024\226\011\214\006f\011\204c\228\000\000\213d\030\250\011\186c\228\000\000\000\000\000\000\012\000\024\226\011\230\005\224_N\000\000\0126\011\216c\228\000\000\024\226\012>\011\220c\228\000\000\001^\011\226c\228\000\000\012\018\024\226\012F\011\240c\228\000\000\024\226\012Z\011\252c\228\000\000\011\252\000\000\000\000\028`\000\000&\022\201<N\\\012\014\012.\030\250\011\254&\022\012\020\0128\030\250\012\b\012\000\0124\012$\012D\001 \005\196%`\004$\030\250\012\020\012\026&\022\0120\012P\030\250\012&\012\188\201<\198\132\012F&\022\201<\173\166&\022\029,\030\250\0126\027\170&\022\012^\012R\201<N\228\201<bh\012n\030\250\012>&\022\201<N\\\012T\012v\000\226\012H&\022\006\006\201<\1744\030\250\000\161\005*&\022\000\000\030\250\012^&\022\000\000&\022\000\000\000\000\000\000\201<b\240\012~\030\250\012R&\022\000\000&\204&\022\030\250\012X&\022\000\000\000\000\006\028\201<\174\194\030\250\000\161\005\182&\022\000\000\030\250\012r&\022\000\000&\022\000\000\000\000&\204'\130&\204\030\250\012f&\022\000\000\000\000\006@\201<\175P\030\250\000\161\006(&\022\000\000\030\250\012|&\022\000\000&\022\000\000\000\000\001\154\201<\175\222\030\250\000\161\0062\027\170'\130(8'\130\030\250\012l&\022\000\000\000\000\006B\201<\176l\030\250\000\161\006T&\022\000\000\030\250\012\130&\022\000\000&\022\000\000\000\000\030\250\012\132\027\170(8(\238(8\030\250\012r&\022\000\000\000\000\006H\201<\176\250\030\250\000\161\006b&\022\000\000\030\250\012\136&\022\000\000&\022\000\000\000\000\027\170(\238-\220(\238\030\250\012v&\022\000\000\000\000\006r\201<\177\136\030\250\000\161\006d&\022\000\000\030\250\012\144&\022\000\000&\022\000\000\000\000\012\138\030\250\012\148&\022\000\000\000\000\000\000&\022\000\000\006\160\201<\178\022\030\250\000\161\006\134\012\138&\022\000\000\030\250\012\164\012\150&\022\000\000\012\152&\022\000\000&\022\000\000\000\000\012\186\000\000"), (16, "\000R\000\022\019\202\001\169\007\250\000%\001\169\000%\000\030\000%\000%\000%\020\166\000%\004\005\016b\004\005\016b\004\005\016z\000%\b&\000%\017\014\000J\001\169\000%\000%\bb\000%\000%\br\000%\000%\001\169\000%\000%\000%\000V\003\162\000%\001\161\014Z\b\194\001\161\007\030\014\022\000%\000%\003\254\t\162\022~\000%\000%\000%\000%\014z\000%\000%\b\130\000%\000%\tY\001\161\000%\000%\000%\000%\000%\000%\000%\tY\001\161\014\030\007\230\000%\000%\028\242\022\138\000%\022\242\003\166\000N\000:\007\170\000%\000%\000\142\005\222\000\182\000%\000%\000)\029\026\000)\007~\000)\000)\000)\023J\000)\023^\027F\000\210\014\230\001>\t\241\000)\b\206\000)\t\182\015F\tY\000)\000)\015\182\000)\000)\014\250\000)\000)\015\182\000)\000)\000)\000\146\001F\000)\001\165\r\210\027\138\001\165\000>\006~\000)\000)\004\022\001B\023\150\000)\000)\000)\000)\r\242\000)\000)\021N\000)\000)\tY\001\165\000)\000)\000)\000)\000)\000)\000)\001:\001\165\t\250\004\166\000)\000)\t:\023\162\000)\023\250\006\018\000\218\001V\000z\000)\000)\016~\006\130\001F\000)\000)\000-\016~\000-\006\154\000-\000-\000-\024R\000-\024f\n\142\000\222\000\230\016\134\001B\000-\011}\000-\nF\017R\n\206\000-\000-\011}\000-\000-\004\217\000-\000-\000\162\000-\000-\000-\000*\001F\000-\021r\007f\001\217\026\194\0292\000~\000-\000-\001\217\t5\024\150\000-\000-\000-\000-\011}\000-\000-\004\162\000-\000-\tY\004\197\000-\000-\000-\000-\000-\000-\000-\004\178\015\182\015\182\004\217\000-\000-\029>\024\162\000-\024\250\ti\000\242\000\166\021\218\000-\000-\021N\ti\000\190\000-\000-\0011\029V\0011\000B\0011\0011\0011\025R\0011\025f\016\174\001\254\000\246\bb\016\182\0011\br\0011\nn\007n\tY\0011\0011\031z\0011\0011\001f\0011\0011\001\014\0011\0011\0011 V\001F\0011\016b\004\005\022B\016~\016~\012~\0011\0011\b\130\026\"\000\194\0011\0011\0011\0011\b\154\0011\0011\004\221\0011\0011\017\162\017\242\0011\0011\0011\0011\0011\0011\0011\012\146\002\174\n\178\027\202\0011\0011\021Z\026B\0011\001j\012\198\tY\011\142\003\030\0011\0011\001\217\001\217\001F\0011\0011\001)\007\198\001)\000\130\001)\001)\001)\011\146\001)\tY\004\221\001&\011\150\tQ\001R\001)\011y\001)\007\178\tY\tQ\001)\001)\011y\001)\001)\011\154\001)\001)\002\178\001)\001)\001)\001\222\012\n\001)\015\014\021\250\n\210\026\194\001\226\003\"\001)\001)\t\001\0152\tY\001)\001)\001)\001)\011y\001)\001)\001F\001)\001)\n\246\004\197\001)\001)\001)\001)\001)\001)\001)\b\n\r\246\007*\012\030\001)\001)\022^\001F\001)\022\190\0122\tY\002n\025\174\001)\001)\028F\001F\026\194\001)\001)\0019\b\174\0019\000\170\0019\0019\0019\014:\0019\028\158\005\190\ta\b\138\007\018\014\158\0019\004\197\0019\tY\tY\025\234\0019\0019\001F\0019\0019\003\130\0019\0019\003\174\0019\0019\0019\022z\b\134\0019\0146\002\150\014~\004:\023\138\029.\0019\0019\001B\004V\b\150\0019\0019\0019\0019\004z\0019\0019\001F\0019\0019\005\210\006&\0019\0019\0019\0019\0019\0019\0019\014\162\015\018\024\146\t\029\0019\0019\006B\011\178\0019\003\134\006f\006\142\003\178\006\250\0019\0019\001F\001F\002\194\0019\0019\001Q\004>\001Q\000\198\001Q\001Q\001Q\004Z\001Q\t\006\t\026\tN\022\030\004~\016\234\001Q\t\138\001Q\016\242\005\214\006*\001Q\001Q\t\226\001Q\001Q\016\154\001Q\001Q\021z\001Q\001Q\001Q\n.\006F\001Q\016\198\n\154\006j\006\146\011.\006\254\001Q\001Q\011\022\n\242\nj\001Q\001Q\001Q\001Q\t\178\001Q\001Q\021\142\001Q\001Q\016\214\t\246\001Q\001Q\001Q\001Q\001Q\001Q\001Q\011b\017\002\nB\0176\001Q\001Q\n\174\017>\001Q\011B\022\002\022\014\011\222\017~\001Q\001Q\029\206\017\134\017j\001Q\001Q\001I\012F\001I\004\002\001I\001I\001I\017\150\001I\012\158\012\222\r&\002\198\018\n\011v\001I\r^\001I\026^\r\158 \210\001I\001I\0186\001I\001I\011\242\001I\001I\017\214\001I\001I\001I\017\222\018\030\001I\012Z\018V\018&\026~\002\218\018^\001I\001I\012\178\012\242\r:\001I\001I\001I\001I\rr\001I\001I\r\178\001I\001I\018B\018\218\001I\001I\001I\001I\001I\001I\001I\0192\018n\019\006\018\238\001I\001I\019\142\018\246\001I\019F\019^\022\146\003\002\019N\001I\001I\019\186\022\206\019\162\001I\001I\001A\019\170\001A\004\026\001A\001A\001A\019\222\001A\020\006\020\026\020>\020\130\020n\020\"\001A\020\138\001A\022\250\0202\t\025\001A\001A\020\154\001A\001A\020\206\001A\001A\020\226\001A\001A\001A\020\234\021\154\001A\020\250\021\174\023&\026\206\022\158\021\186\001A\001A\021\206\t\201\022\218\001A\001A\001A\001A\t\205\001A\001A\030~\001A\001A\023\170\030\134\001A\001A\001A\001A\001A\001A\001A\023b\003\018\023\006\003R\001A\001A\003n\022\"\001A\023\214\024\002\024.\024j\026\218\001A\001A\024\170\024\214\003\150\001A\001A\001y\0232\001y\006.\001y\001y\001y\025\002\001y\025j\t\r\029\198\003\194\026\210\023n\001y\025.\001y\026\158\026\226\023\182\001y\001y\027\002\001y\001y\024v\001y\001y\027\234\001y\001y\001y\028\030\028N\001y\003\202\030\246\023\226\024\014\024:\030\254\001y\001y\025v\024\182\024\226\001y\001y\001y\001y\028z\001y\001y!\030\001y\001y\025\014\003\206\001y\001y\001y\001y\001y\001y\001y\025:\030j\026\170\003\214\001y\001y\029\002\027\014\001y\028\202\003\226\030\150\030\226\027\246\001y\001y\003\234\028*\028Z\001y\001y\001q\031\014\001q\006J\001q\001q\001q\031R\001q\031>\031\182\031Z\031\142 \030\028\134\001q\031\238\001q\003\238\031j\031\226\001q\001q J\001q\001q\003\246\001q\001q\031\202\001q\001q\001q\031\210 ~\001q 2 \146\028\214\004\014 : \154\001q\001q \170\004.\004N\001q\001q\001q\001q\004r\001q\001q \242\001q\001q \222 \254\001q\001q\001q\001q\001q\001q\001q\004\174!\018\0052\0056\001q\001q\005J\005\178\001q\005\186\005\206\005\242\006\002\006\n\001q\001q\006\030\006:\006^\001q\001q\001\129\006\138\001\129\006n\001\129\001\129\001\129\006\166\001\129\006\186\006\198\006\218\006\230\006\238\007\022\001\129\007\026\001\129\007\"\007.\0072\001\129\001\129\0076\001\129\001\129\007>\001\129\001\129\007B\001\129\001\129\001\129\007N\007R\001\129\007V\007^\007b\007r\007\130\007\138\001\129\001\129\007\142\007\158\007\162\001\129\001\129\001\129\001\129\007\186\001\129\001\129\007\202\001\129\001\129\007\218\007\222\001\129\001\129\001\129\001\129\001\129\001\129\001\129\007\234\b\002\b\014\b\030\001\129\001\129\b\"\b*\001\129\bF\bJ\bZ\bn\b~\001\129\001\129\b\146\b\166\b\178\001\129\001\129\001a\b\198\001a\006\150\001a\001a\001a\b\210\001a\b\238\b\250\t\n\t\030\t.\t>\001a\tR\001a\tn\tv\tz\001a\001a\t\130\001a\001a\t\142\001a\001a\t\202\001a\001a\001a\t\218\t\230\001a\n\014\n&\n2\nZ\n\130\n\150\001a\001a\n\158\n\198\n\230\001a\001a\001a\001a\011\n\001a\001a\011\026\001a\001a\0112\011F\001a\001a\001a\001a\001a\001a\001a\011Z\011^\011f\011z\001a\001a\011\162\011\170\001a\011\190\011\198\011\202\011\226\011\246\001a\001a\012\014\012\"\012J\001a\001a\001Y\012^\001Y\006\158\001Y\001Y\001Y\012r\001Y\012\130\012\154\012\162\012\182\012\202\012\226\001Y\012\246\001Y\r\n\r\018\r\022\001Y\001Y\r\030\001Y\001Y\r*\001Y\001Y\r>\001Y\001Y\001Y\rV\rb\001Y\rv\r\150\r\162\r\182\r\218\r\230\001Y\001Y\r\234\014\n\014\"\001Y\001Y\001Y\001Y\014&\001Y\001Y\014*\001Y\001Y\014N\014b\001Y\001Y\001Y\001Y\001Y\001Y\001Y\014n\014r\014\146\014\182\001Y\001Y\014\198\014\202\001Y\014\242\014\254\015&\0156\015:\001Y\001Y\015J\015N\015Z\001Y\001Y\001i\015^\001i\007\002\001i\001i\001i\015f\001i\015j\015\134\015\138\015\158\015\174\015\178\001i\015\214\001i\015\218\015\250\016\142\001i\001i\016\190\001i\001i\016\250\001i\001i\017\022\001i\001i\001i\017F\017Z\001i\017\142\017\170\017\230\017\250\018.\018f\001i\001i\018z\018\134\018\154\001i\001i\001i\001i\018\162\001i\001i\018\174\001i\001i\018\202\018\254\001i\001i\001i\001i\001i\001i\001i\019\"\019V\019~\019\178\001i\001i\019\246\020*\001i\020F\020^\020\146\020\190\020\242\001i\001i\021\n\021\018\021\030\001i\001i\000\137\021\"\000\137\021.\000\137\000\137\000\137\021:\000\137\021>\021B\021F\021J\021b\021\130\000\137\021\134\000\137\021\178\021\194\021\198\000\137\000\137\021\210\000\137\000\137\021\230\000\137\000\137\021\242\000\137\000\137\000\137\022\006\022\018\001\030\022\022\022\026\022.\0222\0226\022F\000\137\000\137\022R\022b\022n\000\137\000\137\000\137\000\137\022r\000\137\000\137\022\130\000\137\000\137\022\150\022\170\000\137\000\137\000\137\000\137\0016\000\137\000\137\022\186\022\202\022\210\022\230\000\137\000\137\022\254\023\018\001Z\023\"\023*\023>\023V\023f\000\137\000\137\023v\023~\023\142\000\137\000\137\000\145\023\146\000\145\023\154\000\145\000\145\000\145\023\174\000\145\023\194\023\210\023\218\023\238\024\006\024\026\000\145\024*\000\145\0242\024F\024^\000\145\000\145\024n\000\145\000\145\024~\000\145\000\145\024\134\000\145\000\145\000\145\024\154\024\174\001\030\024\194\024\210\024\218\024\238\025\006\025\026\000\145\000\145\025*\0252\025F\000\145\000\145\000\145\000\145\025^\000\145\000\145\025n\000\145\000\145\025~\025\134\000\145\000\145\000\145\000\145\0016\000\145\000\145\025\162\025\166\025\178\025\182\000\145\000\145\025\186\025\198\001Z\025\202\025\222\025\226\025\238\025\250\000\145\000\145\025\254\026\018\026\022\000\145\000\145\000\157\026&\000\157\026*\000\157\000\157\000\157\026.\000\157\026:\026F\026R\026b\026j\026n\000\157\026r\000\157\026\138\026\154\026\162\000\157\000\157\026\182\000\157\000\157\026\222\000\157\000\157\026\238\000\157\000\157\000\157\026\246\026\254\001\030\027\006\027\026\027.\0272\0276\027>\000\157\000\157\027J\027N\027R\000\157\000\157\000\157\000\157\027Z\000\157\000\157\027^\000\157\000\157\027f\027r\000\157\000\157\000\157\000\157\0016\000\157\000\157\027v\027z\027\130\027\142\000\157\000\157\027\150\027\154\000\157\027\162\027\174\027\178\027\182\027\190\000\157\000\157\027\214\027\230\027\238\000\157\000\157\000}\028\002\000}\028\018\001\022\001.\000}\028\026\000}\028\"\0286\028R\028f\028v\028~\000}\028\146\000}\028\162\028\170\028\174\000}\000}\028\178\000}\000}\028\190\001z\000}\028\198\001\130\000}\000}\028\206\028\226\001\030\028\246\028\254\029\014\029\018\029\"\029&\000}\000}\0296\029B\029J\000}\001\138\000}\000}\029N\000}\000}\029^\000}\000}\029b\029o\000}\000}\000}\000}\0016\000}\001\146\029\142\029\146\029\154\029\162\000}\000}\029\166\029\174\001Z\029\178\029\182\029\186\029\190\029\214\000}\000}\029\218\029\226\029\230\000}\000}\000\133\029\238\000\133\029\242\000\133\000\133\000\133\029\254\000\133\030\026\030&\030*\030>\030F\030V\000\133\030Z\000\133\030b\030\142\030\178\000\133\000\133\030\186\000\133\000\133\030\210\000\133\000\133\031\006\000\133\000\133\000\133\031.\031b\001\030\031\166\031\218\031\246 \014 B n\000\133\000\133 \162 \186 \194\000\133\000\133\000\133\000\133 \246\000\133\000\133!\006\000\133\000\133!\n!\022\000\133\000\133\000\133\000\133\0016\000\133\000\133!/\000\000\000\000\000\000\000\133\000\133\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\133\000\133\000\000\000\000\000\000\000\133\000\133\000\149\000\000\000\149\000\000\000\149\000\149\000\149\000\000\000\149\000\000\000\000\000\000\000\000\000\000\000\000\000\149\000\000\000\149\000\000\000\000\000\000\000\149\000\149\000\000\000\149\000\149\000\000\000\149\000\149\000\000\000\149\000\149\000\149\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\000\000\000\149\000\149\000\149\000\149\000\000\000\149\000\149\000\000\000\149\000\149\000\000\000\000\000\149\000\149\000\149\000\149\0016\000\149\000\149\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\000\000\000\149\000\149\000\153\000\000\000\153\000\000\000\153\000\153\000\153\000\000\000\153\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\000\000\153\000\000\000\000\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\153\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\000\000\000\153\000\153\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\000\000\153\000\153\000\153\000\153\0016\000\153\000\153\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\000\000\000\153\000\153\000a\000\000\000a\000\000\000a\000a\000a\000\000\000a\000\000\000\000\000\000\000\000\000\000\000\000\000a\000\000\000a\000\000\000\000\000\000\000a\000a\000\000\000a\000a\000\000\000a\000a\000\000\000a\000a\000a\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\000\000\000a\000a\000a\000a\000\000\000a\000a\000\000\000a\000a\000\000\000\000\000a\000a\000a\000a\0016\000a\000a\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\000\000\000a\000a\000\141\000\000\000\141\000\000\001\022\001.\000\141\000\000\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\000\000\141\000\000\000\000\000\000\000\141\000\141\000\000\000\141\000\141\000\000\001z\000\141\000\000\001\130\000\141\000\141\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\001\138\000\141\000\141\000\000\000\141\000\141\000\000\000\141\000\141\000\000\000\000\000\141\000\141\000\141\000\141\0016\000\141\001\146\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\000\141\000\129\000\000\000\129\000\000\001\022\001.\000\129\000\000\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\000\129\000\000\000\000\000\000\000\129\000\129\000\000\000\129\000\129\000\000\001z\000\129\000\000\001\130\000\129\000\129\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\001\138\000\129\000\129\000\000\000\129\000\129\000\000\000\129\000\129\000\000\000\000\000\129\000\129\000\129\000\129\0016\000\129\001\146\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\000\129\000e\000\000\000e\000\000\001\022\001.\000e\000\000\000e\000\000\000\000\000\000\000\000\000\000\000\000\000e\000\000\000e\000\000\000\000\000\000\000e\000e\000\000\000e\000e\000\000\001z\000e\000\000\001\130\000e\000e\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\000\000\000e\001\138\000e\000e\000\000\000e\000e\000\000\000e\000e\000\000\000\000\000e\000e\000e\000e\0016\000e\001\146\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\000\000\000e\000e\000U\000\000\000U\000\000\001\022\001.\000U\000\000\000U\000\000\000\000\000\000\000\000\000\000\000\000\000U\000\000\000U\000\000\000\000\000\000\000U\000U\000\000\000U\000U\000\000\001z\000U\000\000\001\130\000U\000U\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\000\000\000U\001\138\000U\000U\000\000\000U\000U\000\000\000U\000U\000\000\000\000\000U\000U\000U\000U\0016\000U\001\146\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\000\000\000U\000U\000u\000\000\000u\000\000\001\022\001.\000u\000\000\000u\000\000\000\000\000\000\000\000\000\000\000\000\000u\000\000\000u\000\000\000\000\000\000\000u\001r\000\000\001\154\000u\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000u\000\000\000\000\000\000\000u\001\138\002\018\002\026\000\000\000u\002\"\000\000\001\178\000u\000\000\000\000\000u\000u\000u\000u\0016\000u\001\146\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000u\002*\000\000\000\000\000\000\001\186\000u\000i\000\000\000i\000\000\001\022\001.\000i\000\000\000i\000\000\000\000\000\000\000\000\000\000\000\000\000i\000\000\000i\000\000\000\000\000\000\000i\001r\000\000\001\154\000i\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000i\000\000\000\000\000\000\000i\001\138\002\018\002\026\000\000\000i\000i\000\000\001\178\000i\000\000\000\000\000i\000i\000i\000i\0016\000i\001\146\000\000\000\000\000\000\000\000\000i\000i\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000i\000i\000\000\000\000\000\000\001\186\000i\000m\000\000\000m\000\000\001\022\001.\000m\000\000\000m\000\000\000\000\000\000\000\000\000\000\000\000\000m\000\000\000m\000\000\000\000\000\000\000m\001r\000\000\001\154\000m\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000m\000\000\000\000\000\000\000m\001\138\002\018\002\026\000\000\000m\000m\000\000\001\178\000m\000\000\000\000\000m\000m\000m\000m\0016\000m\001\146\000\000\000\000\000\000\000\000\000m\000m\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000m\000m\000\000\000\000\000\000\001\186\000m\001\137\000\000\001\137\000\000\001\022\001.\001\137\000\000\001\137\000\000\000\000\000\000\000\000\000\000\000\000\001\137\000\000\001\137\000\000\000\000\000\000\001\137\001r\000\000\001\154\001\137\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\001\137\001\138\002\018\002\026\000\000\001\137\002\"\000\000\001\178\001\137\000\000\000\000\001\137\001\137\001\137\001\137\0016\001\137\001\146\000\000\000\000\000\000\000\000\001\137\001\137\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000]\000\000\000]\000\000\001\022\001.\000]\000\000\000]\000\000\000\000\000\000\000\000\000\000\000\000\000]\000\000\000]\000\000\000\000\000\000\000]\001r\000\000\001\154\000]\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000]\000\000\000\000\000\000\000]\001\138\002\018\002\026\000\000\000]\002\"\000\000\001\178\000]\000\000\000\000\000]\000]\000]\000]\0016\000]\001\146\000\000\000\000\000\000\000\000\000]\000]\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000]\002*\000\000\000\000\000\000\001\186\000]\000Y\000\000\000Y\000\000\001\022\001.\000Y\000\000\000Y\000\000\000\000\000\000\000\000\000\000\000\000\000Y\000\000\000Y\000\000\000\000\000\000\000Y\001r\000\000\001\154\000Y\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000Y\000\000\000\000\000\000\000Y\001\138\002\018\002\026\000\000\000Y\002\"\000\000\001\178\000Y\000\000\000\000\000Y\000Y\000Y\000Y\0016\000Y\001\146\000\000\000\000\000\000\000\000\000Y\000Y\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000Y\002*\000\000\000\000\000\000\001\186\000Y\000M\000\000\000M\000\000\001\022\001.\000M\000\000\000M\000\000\000\000\000\000\000\000\000\000\000\000\000M\000\000\000M\000\000\000\000\000\000\000M\000M\000\000\000M\000M\000\000\001z\000M\000\000\001\130\000M\000M\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\000\000\000M\001\138\000M\000M\000\000\000M\000M\000\000\000M\000M\000\000\000\000\000M\000M\000M\000M\0016\000M\001\146\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\000\000\000M\000M\000I\000\000\000I\000\000\000I\000I\000I\000\000\000I\000\000\000\000\000\000\000\000\000\000\000\000\000I\000\000\000I\000\000\000\000\000\000\000I\000I\000\000\000I\000I\000\000\000I\000I\000\000\000I\000I\000I\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000\000\000I\000I\000I\000I\000\000\000I\000I\000\000\000I\000I\000\000\000\000\000I\000I\000I\000I\0016\000I\000I\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000I\000\000\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000\000\000I\000I\000\173\000\000\000\173\000\000\001\022\001.\000\173\000\000\000\173\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\000\000\173\000\000\000\000\000\000\000\173\001r\000\000\001\154\000\173\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\173\001\138\002\018\002\026\000\000\000\173\002\"\000\000\001\178\000\173\000\000\000\000\000\173\000\173\000\173\000\173\0016\000\173\001\146\000\000\000\000\000\000\000\000\000\173\002B\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000Q\000\000\000Q\000\000\000Q\000Q\000Q\000\000\000Q\000\000\000\000\000\000\000\000\000\000\000\000\000Q\000\000\000Q\000\000\000\000\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000Q\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\000\000\000\000Q\000Q\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000\000\000Q\000Q\000Q\000Q\0016\000Q\000Q\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\000\000Q\000\000\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\018\000\000\000Q\000Q\000y\000\000\000y\000\000\001\022\001.\000y\007j\000y\000\000\000\000\000\000\000\000\000\234\022\246\000y\004\233\000y\000\238\000\000\000\000\000y\001r\000\000\001\154\000y\000\000\001z\001\162\000\000\001\130\000\000\000\250\000\000\003\226\001\030\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000y\000\000\000\000\001\002\000y\001\138\000\000\000\000\000\000\000y\000y\000\000\001\178\000y\000\000\000\000\000y\000y\000y\000y\0016\000y\001\146\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\001Z\001\006\000\000\001\n\003\218\000\000\000y\000y\000\000\003\222\000\000\001\186\000y\000\161\000\000\000\161\000\000\001\022\001.\000\161\000\000\000\161\000\000\000\000\000\000\000\000\000\000\000\000\000\161\b>\000\161\000\000\000\000\000\000\000\161\001r\bB\001\154\000\161\000\000\001z\001\162\000\000\001\130\000\000\b6\000\000\000\000\001\030\000\000\b:\000\000\bN\000\000\000\000\000\000\000\161\000\000\000\000\000\000\000\161\001\138\000\000\000\000\bR\000\161\000\161\000\000\001\178\000\161\000\000\000\000\000\161\000\161\000\161\000\161\0016\000\161\001\146\000\000\000\000\000\000\000\000\000\161\000\161\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\161\000\161\000\000\000\018\000\000\001\186\000\161\000q\000\000\000q\000\000\001\022\001.\000q\007z\000q\000\000\000\000\000\000\000\000\000\234\023\254\000q\000\000\000q\000\238\000\000\000\000\000q\001r\000\000\001\154\000q\000\000\001z\001\162\000\000\001\130\000\000\000\250\000\000\000\000\001\030\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000q\000\000\000\000\001\002\000q\001\138\000\000\000\000\000\000\000q\000q\000\000\001\178\000q\000\000\000\000\000q\000q\000q\000q\0016\000q\001\146\000\000\000\000\000\000\000\000\000q\000q\000\000\000\000\001Z\001\006\000\000\001\n\003\218\000\000\000q\000q\000\000\003\222\000\000\001\186\000q\000\165\000\000\000\165\000\000\001\022\001.\000\165\000\000\000\165\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\165\000\000\000\000\000\000\000\165\001r\000\000\001\154\000\165\000\000\001z\001\162\000\000\001\130\000\000\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\000\000\000\000\165\001\138\000\000\000\000\000\000\000\165\000\165\000\000\001\178\000\165\003\237\000\000\000\165\000\165\000\165\000\165\0016\000\165\001\146\000\000\000\000\000\000\000\000\000\165\000\165\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\165\000\165\000\000\000\000\000\000\001\186\000\165\000\000\003\237\000\000\003\237\003\237\000\000\003\237\000\000\003\237\000\000\000\000\000\000\000\000\000\000\003\237\000\000\003\237\003\237\000\000\003\237\000\000\003\237\000\000\000\000\000\000\000\000\003\237\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003\237\000\000\000\000\000\000\000\000\003\237\000\000\003\237\000\000\000\000\000\000\000\000\003\237\018\194\000\000\000\000\003\237\000\000\003\237\003\237\000\000\000\000\000\000\003\237\000\000\000\000\001\209\001\209\001\209\003\237\000\000\018\178\003\237\000\000\000\000\000\000\000\000\000\000\003\237\003\237\003\237\003\237\001\209\000\000\001\209\003\237\000\000\000\000\003\237\001\209\003\237\003\237\000\000\000\000\000\000\003\237\003\237\001\209\000\000\001\209\001\209\001\209\001\209\001\209\001\209\000\000\000\000\000\000\000\000\000\000\001\209\000\000\001\209\001\209\000\000\001\209\000\000\001\209\000\000\000\000\000\000\000\000\001\209\000\000\000\000\000\000\000\006\001\209\001\209\000\000\000\000\001\209\000\000\000\000\000\000\000\000\001\209\000\000\001\209\001\209\000\000\000\000\000\000\001\209\000\000\000\000\001\209\001\209\001\209\001\209\001\209\000\000\000\000\000\000\001\209\000\000\000\000\003\237\000\000\000\006\001\209\001\209\000\000\000\000\000\000\000\000\000\000\000\000\003\237\000\000\001\209\001\209\001\209\000\000\000\000\000\000\001\209\000\000\000\000\001\209\000\000\001\209\001\209\000\000\000\000\000\000\001\209\001\209\003\237\000\000\003\237\003\237\000\000\003\237\000\000\003\237\000\000\000\000\000\000\003\237\000\000\003\237\003\237\003\237\003\237\000\000\003\237\000\000\003\237\000\000\000\000\000\000\003\237\003\237\003\237\003\237\000\000\003\237\000\000\003\237\000\000\000\000\003\237\000\000\003\237\000\000\000\000\003\237\000\000\003\237\000\000\000\000\000\000\003\237\003\237\015~\000\000\000\000\003\237\000\000\003\237\003\237\000\000\000\000\000\000\003\237\030\018\000\000\000\000\003\237\000\000\003\237\003\237\018\178\003\237\000\000\003\237\000\000\000\000\000\000\003\237\003\237\003\237\003\237\018\178\003\237\002\202\003\237\000\000\000\000\003\237\000\000\003\237\003\237\003\237\n\017\n\017\003\237\003\237\000\000\000\000\003\237\000\000\003\237\003\237\000\000\n\017\000\000\003\237\003\237\000\000\000\000\n\017\n\017\000\000\n\017\000\000\000\000\n\017\n\017\000\000\n\017\n\017\000\000\002\206\000\000\n\017\000\000\000\000\000\000\000\000\000\000\000\000\n\017\n\017\002\222\000\000\000\000\n\017\n\017\n\017\n\017\000\000\000\000\n\017\000\000\n\017\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\017\000\000\n\017\000\000\003^\000\000\000\000\n\017\n\017\000\000\000\000\n\017\000\000\n\021\n\021\000\000\000\000\n\017\n\017\000\000\000\000\000\000\n\017\n\017\n\021\000\000\000\000\000\000\000\000\000\000\n\021\n\021\000\000\n\021\000\000\000\000\n\021\n\021\000\000\n\021\n\021\000\000\003b\000\000\n\021\000\000\000\000\000\000\000\000\000\000\000\000\n\021\n\021\003r\000\000\000\000\n\021\n\021\n\021\n\021\000\000\000\000\n\021\000\000\n\021\007\146\001\206\000\000\000\000\000\000\000\000\000\000\n\021\000\000\n\021\001\210\001\214\000\000\000\000\n\021\n\021\000\000\001\218\n\021\000\000\000\000\000\000\000\000\000\000\n\021\n\021\001\230\001\234\000\000\n\021\n\021\007\166\000\000\007\174\007\182\001\238\015V\002r\007\214\000\000\000\000\000\000\000\000\000\000\007\226\002v\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\002z\000\000\002~\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\005\"\015z\000\000\000\000\000\000\019\018\000\000\000\000\000\000\005&\005*\007\165\b\222\b\234\b\242\000\000\005.\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\005:\005>\000\000\t^\tj\007\166\000\000\007\174\007\182\005B\015V\005N\007\214\000\000\000\000\000\000\000\000\000\000\007\226\005R\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\005V\000\000\005Z\000\000\b\170\019\026\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\015\186\016\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\015\194\015\202\007\185\b\222\b\234\b\242\000\000\015\210\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\015\226\015\234\000\000\t^\tj\007\166\000\000\007\174\007\182\015\242\015V\016\002\007\214\000\000\000\000\000\000\000\000\000\000\007\226\016\n\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\016\018\000\000\016\026\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\018\190\000\000\000\000\000\000\019n\000\000\000\000\000\000\000\000\000\000\b\005\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\019v\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\019\022\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\025\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\011\133\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\011\133\007\214\011\133\000\000\000\000\000\000\011\133\007\226\000\000\007\238\015b\000\000\007\246\011\133\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\005\250\000\000\b:\000\000\bN\000\000\000\000\011\133\000\000\b\170\011\133\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\019r\000\000\000\000\000\000\019\230\000\000\000\000\000\000\011\133\000\000\007\189\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\011\133\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\019\238\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\019\234\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\209\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\020R\000\000\000\000\000\000\020N\000\000\000\000\000\000\000\000\000\000\007\213\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\020V\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\020\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\233\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\021v\000\000\000\000\000\000\020\174\000\000\000\000\000\000\000\000\000\000\007\237\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\020\182\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\029\130\000\000\029\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\001\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\029\158\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\029\222\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\030\202\000\000\000\000\b\190\000\000\030\002\b\202\000\000\000\000\000\000\030\"\000\000\000\000\029\130\000\000\030\014\004\r\000\000\000\000\030\194\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\030J\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\029\158\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\029\222\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\031&\000\000\000\000\b\190\000\000\030\002\b\202\000\000\000\000\000\000\030\"\000\000\000\000\029\130\000\000\030\198\004\r\000\000\000\000\031\030\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\030J\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\029\158\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\029\222\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\031\158\000\000\000\000\b\190\000\000\030\002\b\202\000\000\000\000\000\000\030\"\000\000\000\000\029\130\000\000\031\"\004\r\000\000\000\000\031\150\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\030J\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\029\158\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\029\222\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170 \006\000\000\000\000\b\190\000\000\030\002\b\202\000\000\000\000\000\000\030\"\000\000\000\000\029\130\000\000\031\154\004\r\000\000\000\000\031\254\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\030J\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\029\158\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\029\222\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170 f\000\000\000\000\b\190\000\000\030\002\b\202\000\000\000\000\000\000\030\"\000\000\000\000\000\000\000\000 \002\004\r\000\000\000\000 ^\000R\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000%\000%\000\000\030J\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\226\000\000\t^\tj\000R\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000%\000%\000%\000%\000V\000\000\000%\000\000\000\000\000\000\003\210\000\000\000\000\000%\000%\003\254\000\000\000%\000\000\000%\000%\000%\000%\000%\000%\000%\000%\000%\000V\000\000\000%\000\000\000\000\000%\000%\000R\000%\000%\000%\003\254\000\000\000\000\000%\000%\000%\000%\000\000\000\000\000%\000\000\000%\000%\000%\000\000\000\000\003\242\000%\000%\000%\000\000\000%\000\000\000%\000\000\000%\000\000\000%\000%\000%\000%\000%\000%\000%\000V\000\000\000%\000%\000\000\000\000\000\000\000%\000%\000%\000%\003\254\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\000%\000\000\000\142\000\000\000\000\000\000\000%\000\000\000\000\000%\000\000\000)\000)\000\000\000\000\000%\000%\000\000\000\000\000\000\000%\000%\004\n\000\000\000\000\000\142\000\000\000\000\000\000\000)\000\000\000)\000\000\000\142\000)\000)\000\000\000)\000)\000)\000\146\000\000\000)\000)\000\000\004J\000\000\000\000\000\000\000)\000)\004\022\000)\0066\000)\000)\000)\000)\000)\000\000\000)\000)\000)\000\146\000\000\000)\000)\000\000\000)\000)\000)\000\146\000)\000)\004\022\000\000\000\000\000\000\000)\000)\000)\000)\004\022\000)\000\000\000)\000)\000)\000)\000\000\000\000\000)\000)\000)\000\000\000)\000\000\000\000\000\000\000\000\000)\000)\000\000\000)\000)\000\000\000\000\000\000\000\000\000)\000)\000)\000)\000\000\000\000\000)\000)\000R\000)\000)\000\000\000\000\000\000\000)\000)\000\000\000%\000%\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t~\000\000\000\000\000\000\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000V\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\003\254\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\000%\000\000\000\142\000\000\000\000\000\000\000%\000\000\000\000\000%\000\000\000)\000)\000\000\000\000\000%\000%\000\000\000\000\000\000\000%\000%\t\214\000\000\000\000\000\000\000\000\000\000\000\000\000)\000\000\000)\000\000\000\000\000)\000)\000\000\000)\000)\000)\000\146\000\000\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\004\022\000\000\000\000\000\000\000)\000)\000)\000\000\000\000\000)\000\000\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\000\000\000)\000\000\000R\000\000\000\000\000\000\000)\000\000\000\000\000)\000\000\000%\000%\000\000\000\000\000)\000)\000\000\000\000\000\000\000)\000)\r\026\000\000\000\000\000\000\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000V\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\003\254\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\000%\000\000\000\142\000\000\000\000\000\000\000%\000\000\000\000\000%\000\000\000)\000)\000\000\000\000\000%\000%\000\000\000\000\000\000\000%\000%\rR\000\000\000\000\000\000\000\000\000\000\000\000\000)\000\000\000)\000\000\000\000\000)\000)\000\000\000)\000)\000)\000\146\000\000\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\004\022\000\000\000\000\000\000\000)\000)\000)\000\000\000\000\000)\000\000\000)\007\146\000\000\000\000\000\000\000\000\000\000\000)\000)\000\000\000)\000\000\000\000\000\000\000\000\000\000\000)\000\000\000\000\000)\000\000\000\000\000\000\000\000\000\000\000)\000)\000\000\000\000\000\000\000)\000)\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000 b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\153\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\157\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\161\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b!\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b%\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b)\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\169\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\173\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\177\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\181\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\t\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\r\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\017\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\021\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\193\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\197\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\201\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\205\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\217\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\221\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\225\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\229\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\241\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\245\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\249\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\253\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\029\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b1\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b9\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bI\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b=\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bA\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bE\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\007\146\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b5\b\222\b\234\b\242\000\000\000\000\000\000\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\015V\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\015b\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\015n\b\202\000\000\000\000\000\000\015\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b-\b\222\b\234\b\242\001n\011M\011M\015\162\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\011M\t^\tj\000\000\000\000\000\000\011M\011M\000\000\011M\000\000\000\000\011M\011M\000\000\011M\011M\000\000\000\000\000\000\011M\000\000\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\000\000\000\000\011M\011M\011M\011M\000\000\000\000\011M\000\000\011M\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011M\000\000\011M\000\000\000\000\000\000\000\000\011M\011M\n\025\n\025\011M\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\n\025\000\000\011M\011M\000\000\000\000\n\025\n\025\000\000\n\025\000\000\000\000\n\025\n\025\000\000\n\025\n\025\000\000\002\138\000\000\n\025\000\000\000\000\000\000\000\000\000\000\000\000\n\025\n\025\000\000\000\000\000\000\n\025\n\025\n\025\n\025\000\000\000\000\n\025\000\000\n\025\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\025\000\000\n\025\000\000\000\000\000\000\000\000\n\025\n\025\000\000\000\000\n\025\002\182\011\021\011\021\000\000\000\000\n\025\n\025\000\000\000\000\000\000\n\025\n\025\011\021\000\000\000\000\000\000\000\000\000\000\011\021\011\021\000\000\011\021\000\000\000\000\011\021\011\021\000\000\011\021\011\021\000\000\000\000\000\000\011\021\000\000\000\000\000\000\000\000\000\000\000\000\011\021\011\021\000\000\000\000\000\000\011\021\011\021\011\021\011\021\000\000\000\000\011\021\000\000\011\021\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\021\000\000\011\021\000\000\000\000\000\000\000\000\011\021\011\021\000\000\000\000\011\021\002\226\011-\011-\000\000\000\000\011\021\011\021\000\000\000\000\000\000\011\021\011\021\011-\000\000\000\000\000\000\000\000\000\000\011-\011-\000\000\011-\000\000\000\000\011-\011-\000\000\011-\011-\000\000\000\000\000\000\011-\000\000\000\000\000\000\000\000\000\000\000\000\011-\011-\000\000\000\000\000\000\011-\011-\011-\011-\000\000\000\000\011-\000\000\011-\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011-\000\000\011-\000\000\000\000\000\000\000\000\011-\011-\000\000\000\000\011-\003&\011\r\011\r\000\000\000\000\011-\011-\000\000\000\000\000\000\011-\011-\011\r\000\000\000\000\000\000\000\000\000\000\011\r\011\r\000\000\011\r\000\000\000\000\011\r\011\r\000\000\011\r\011\r\000\000\000\000\000\000\011\r\000\000\000\000\000\000\000\000\000\000\000\000\011\r\011\r\000\000\000\000\000\000\011\r\011\r\011\r\011\r\000\000\000\000\011\r\000\000\011\r\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\r\000\000\011\r\000\000\000\000\015\146\000\000\011\r\011\r\001\022\001.\011\r\000\000\005\246\000\000\000\000\000\000\011\r\011\r\000\000\n\145\000\000\011\r\011\r\000\000\000\000\n\145\001r\000\000\001\154\015\170\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\n\145\001\138\002\018\002\026\000\000\017\190\002\"\000\000\001\178\015\154\000\000\000\000\003:\003\229\018\142\004\"\0016\007\154\001\146\000\000\000\000\000\000\000\000\n\145\002B\000\000\000\000\001Z\003v\011%\011%\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\011%\000\000\000\000\000\000\000\000\000\000\011%\011%\000\000\011%\000\000\000\000\011%\011%\000\000\011%\011%\000\000\000\000\000\000\011%\000\000\000\000\000\000\000\000\000\000\000\000\011%\011%\000\000\000\000\000\000\011%\011%\011%\011%\000\000\000\000\011%\000\000\011%\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011%\000\000\011%\000\000\000\000\000\000\000\000\011%\011%\000\000\000\000\011%\003\138\011\029\011\029\000\000\000\000\011%\011%\000\000\000\000\000\000\011%\011%\011\029\000\000\000\000\000\000\000\000\000\000\011\029\011\029\000\000\011\029\000\000\000\000\011\029\011\029\000\000\011\029\011\029\000\000\000\000\000\000\011\029\000\000\000\000\000\000\000\000\000\000\000\000\011\029\011\029\000\000\000\000\000\000\011\029\011\029\011\029\011\029\000\000\000\000\011\029\000\000\011\029\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\029\000\000\011\029\000\000\000\000\000\000\000\000\011\029\011\029\000\000\000\000\011\029\003\182\0115\0115\000\000\000\000\011\029\011\029\000\000\000\000\000\000\011\029\011\029\0115\000\000\000\000\000\000\000\000\000\000\0115\0115\000\000\0115\000\000\000\000\0115\0115\000\000\0115\0115\000\000\000\000\000\000\0115\000\000\000\000\000\000\000\000\000\000\000\000\0115\0115\000\000\000\000\000\000\0115\0115\0115\0115\000\000\000\000\0115\000\000\0115\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0115\000\000\0115\000\000\000\000\000\000\000\000\0115\0115\000\000\000\000\0115\004B\011]\011]\000\000\000\000\0115\0115\000\000\000\000\000\000\0115\0115\011]\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\011]\000\000\000\000\011]\011]\000\000\011]\011]\000\000\000\000\000\000\011]\000\000\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\000\000\000\000\011]\011]\011]\011]\000\000\000\000\011]\000\000\011]\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011]\000\000\011]\000\000\000\000\000\000\000\000\011]\011]\000\000\000\000\011]\004^\011U\011U\000\000\000\000\011]\011]\000\000\000\000\000\000\011]\011]\011U\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\011U\000\000\000\000\011U\011U\000\000\011U\011U\000\000\000\000\000\000\011U\000\000\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\000\000\000\000\011U\011U\011U\011U\000\000\000\000\011U\000\000\011U\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011U\000\000\011U\000\000\000\000\000\000\000\000\011U\011U\000\000\000\000\011U\004\130\011e\011e\000\000\000\000\011U\011U\000\000\000\000\000\000\011U\011U\011e\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\011e\000\000\000\000\011e\011e\000\000\011e\011e\000\000\000\000\000\000\011e\000\000\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\011e\011e\011e\000\000\000\000\011e\000\000\011e\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011e\000\000\011e\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\011e\005\218\011E\011E\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\011e\011E\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\011E\000\000\000\000\011E\011E\000\000\011E\011E\000\000\000\000\000\000\011E\000\000\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\000\000\000\000\011E\011E\011E\011E\000\000\000\000\011E\000\000\011E\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011E\000\000\011E\000\000\000\000\000\000\000\000\011E\011E\000\000\000\000\011E\005\226\011=\011=\000\000\000\000\011E\011E\000\000\000\000\000\000\011E\011E\011=\000\000\000\000\000\000\000\000\000\000\011=\011=\000\000\011=\000\000\000\000\011=\011=\000\000\011=\011=\000\000\000\000\000\000\011=\000\000\000\000\000\000\000\000\000\000\000\000\011=\011=\000\000\000\000\000\000\011=\011=\011=\011=\000\000\000\000\011=\000\000\011=\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011=\000\000\011=\000\000\000\000\000\000\000\000\011=\011=\000\000\0032\011=\001\022\001.\007\210\000\000\001b\011=\011=\000\000\000\000\000\000\011=\011=\000\000\t)\000\000\000\000\000\000\000\000\001r\000\000\001\154\030R\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\018\150\000\000\000\000\000\000\000\000\000\000\0022\0016\029\138\001\146\000\000\000\000\0302\000\000\002Z\002B\001\022\001.\001Z\000\000\tI\000\000\000\000\000\000\002J\002*\000\000\tI\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\021V\000\000\000\000\000\000\000\000\030\166\004f\0016\000\000\001\146\000\000\000\000\000\000\000\000\002\158\002B\n5\n5\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\n5\000\000\001\186\002R\000\000\000\000\n5\n5\000\000\n5\000\000\000\000\n5\n5\000\000\n5\n5\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\n5\n5\000\000\000\000\000\000\n5\n5\n5\n5\000\000\000\000\n5\000\000\n5\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\n5\000\000\000\000\000\000\000\000\n5\n5\004\150\004\190\n5\000\000\000\000\000\000\000\000\000\000\n5\n5\000\000\t\217\000\000\n5\n5\000\000\000\000\004\198\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\005\006\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\005\030\005^\000\000\000\000\000\000\t\217\004\230\005f\t\217\000\000\000\000\005n\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\005\150\005\158\nu\nu\004\182\000\000\000\000\000\000\000\000\000\000\005\134\005v\000\000\nu\000\000\005\022\005\142\000\000\000\000\nu\nu\000\000\nu\000\000\000\000\nu\nu\000\000\nu\nu\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\nu\nu\000\000\000\000\000\000\nu\nu\nu\nu\000\000\000\000\nu\000\000\nu\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\nu\000\000\000\000\000\000\000\000\nu\nu\n\137\n\137\004\182\000\000\000\000\000\000\000\000\000\000\nu\nu\000\000\n\137\000\000\nu\nu\000\000\000\000\n\137\n\137\000\000\n\137\000\000\000\000\n\137\n\137\000\000\n\137\n\137\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\n\137\n\137\000\000\000\000\000\000\n\137\n\137\n\137\n\137\000\000\000\000\n\137\000\000\n\137\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\n\137\000\000\000\000\000\000\000\000\n\137\n\137\n}\n}\n\137\000\000\000\000\000\000\000\000\000\000\n\137\n\137\000\000\n}\000\000\n\137\n\137\000\000\000\000\n}\n}\000\000\n}\000\000\000\000\n}\n}\000\000\n}\n}\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\n}\n}\000\000\000\000\000\000\n}\n}\n}\n}\000\000\000\000\n}\000\000\n}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\n}\000\000\000\000\000\000\000\000\n}\n}\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\n}\n}\000\000\ni\000\000\n}\n}\000\000\000\000\ni\ni\000\000\ni\000\000\000\000\004\214\ni\000\000\004\222\ni\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\ni\ni\000\000\000\000\000\000\ni\004\230\ni\ni\000\000\000\000\ni\000\000\ni\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\ni\ni\nq\nq\004\182\000\000\000\000\000\000\000\000\000\000\ni\ni\000\000\nq\000\000\ni\ni\000\000\000\000\nq\nq\000\000\nq\000\000\000\000\nq\nq\000\000\nq\nq\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\nq\nq\000\000\000\000\000\000\nq\nq\nq\nq\000\000\000\000\nq\000\000\nq\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\nq\000\000\000\000\000\000\000\000\nq\nq\n\129\n\129\004\182\000\000\000\000\000\000\000\000\000\000\nq\nq\000\000\n\129\000\000\nq\nq\000\000\000\000\n\129\n\129\000\000\n\129\000\000\000\000\n\129\n\129\000\000\n\129\n\129\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\n\129\n\129\000\000\000\000\000\000\n\129\n\129\n\129\n\129\000\000\000\000\n\129\000\000\n\129\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\n\129\000\000\000\000\000\000\000\000\n\129\n\129\n\133\n\133\004\182\000\000\000\000\000\000\000\000\000\000\n\129\n\129\000\000\n\133\000\000\n\129\n\129\000\000\000\000\n\133\n\133\000\000\n\133\000\000\000\000\n\133\n\133\000\000\n\133\n\133\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\n\133\n\133\000\000\000\000\000\000\n\133\n\133\n\133\n\133\000\000\000\000\n\133\000\000\n\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\n\133\000\000\000\000\000\000\000\000\n\133\n\133\nM\nM\004\182\000\000\000\000\000\000\000\000\000\000\n\133\n\133\000\000\nM\000\000\n\133\n\133\000\000\000\000\nM\nM\000\000\nM\000\000\000\000\nM\nM\000\000\nM\nM\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\nM\nM\000\000\000\000\000\000\nM\nM\nM\nM\000\000\000\000\nM\000\000\nM\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\nM\000\000\000\000\000\000\000\000\nM\nM\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\nM\nM\000\000\ny\000\000\nM\nM\000\000\000\000\ny\ny\000\000\ny\000\000\000\000\004\214\ny\000\000\004\222\ny\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\ny\ny\000\000\000\000\000\000\ny\004\230\ny\ny\000\000\000\000\ny\000\000\ny\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\ny\ny\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\ny\ny\000\000\nm\000\000\ny\ny\000\000\000\000\nm\nm\000\000\nm\000\000\000\000\004\214\nm\000\000\004\222\nm\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\nm\nm\000\000\000\000\000\000\nm\004\230\nm\nm\000\000\000\000\nm\000\000\nm\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\nm\nm\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\nm\nm\000\000\nQ\000\000\nm\nm\000\000\000\000\nQ\nQ\000\000\nQ\000\000\000\000\004\214\nQ\000\000\004\222\nQ\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\nQ\nQ\000\000\000\000\000\000\nQ\004\230\nQ\nQ\000\000\000\000\nQ\000\000\nQ\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\nQ\nQ\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\nQ\nQ\000\000\nA\000\000\nQ\nQ\000\000\000\000\nA\nA\000\000\nA\000\000\000\000\004\214\nA\000\000\004\222\nA\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\nA\nA\000\000\000\000\000\000\nA\004\230\nA\nA\000\000\000\000\nA\000\000\nA\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\nA\nA\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\nA\nA\000\000\na\000\000\nA\nA\000\000\000\000\na\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\005\006\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\005\030\na\000\000\000\000\000\000\na\004\230\005f\na\000\000\000\000\005n\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\na\na\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\na\005v\000\000\nU\000\000\005\022\na\000\000\000\000\nU\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\005\006\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\005\030\nU\000\000\000\000\000\000\nU\004\230\005f\nU\000\000\000\000\nU\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\nU\nU\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\nU\nU\000\000\nY\000\000\005\022\nU\000\000\000\000\nY\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\005\006\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\005\030\nY\000\000\000\000\000\000\nY\004\230\005f\nY\000\000\000\000\nY\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\nY\nY\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\nY\nY\000\000\nI\000\000\005\022\nY\000\000\000\000\nI\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\005\006\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\005\030\nI\000\000\000\000\000\000\nI\004\230\005f\nI\000\000\000\000\005n\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\nI\nI\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\nI\005v\000\000\nE\000\000\005\022\nI\000\000\000\000\nE\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\005\006\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\005\030\nE\000\000\000\000\000\000\nE\004\230\005f\nE\000\000\000\000\005n\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\nE\nE\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\nE\005v\000\000\n9\000\000\005\022\nE\000\000\000\000\n9\n9\000\000\n9\000\000\000\000\004\214\n9\000\000\004\222\n9\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\n9\n9\000\000\000\000\000\000\n9\004\230\n9\n9\000\000\000\000\n9\000\000\n9\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\n9\n9\n=\n=\004\182\000\000\000\000\000\000\000\000\000\000\n9\n9\000\000\n=\000\000\n9\n9\000\000\000\000\n=\n=\000\018\n=\000\000\000\000\n=\n=\000\000\n=\n=\000\000\000\000\007\134\004\138\000\000\000\000\000\000\000\000\000\234\024\254\n=\n=\000\000\000\238\000\000\n=\n=\n=\n=\000\000\000\000\n=\000\000\n=\000\000\000\000\000\000\000\250\000\000\000\000\000\000\004\158\000\000\n=\000\254\000\000\000\000\000\000\n=\n=\000\000\001\002\n=\t\137\000\000\t\137\t\137\000\000\n=\n=\t\137\000\000\000\000\n=\n=\000\000\t\137\000\000\t\137\000\000\000\000\t\137\000\000\t\137\000\018\000\000\000\000\000\000\t\137\000\000\001\006\000\000\001\n\003\218\000\000\021\254\000\000\t\137\003\222\000\000\000\000\000\234\t\137\000\000\t\137\000\000\000\238\000\000\000\000\t\137\000\000\000\000\000\000\t\137\000\000\t\137\t\137\000\000\000\000\000\000\000\250\t\137\000\000\000\000\000\000\t\137\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\000\000\t\137\t\137\t\137\015\190\000\000\000\000\000\000\000\000\000\000\t\137\000\000\t\137\t\137\000\000\000\000\000\000\t\137\t\137\t\137\t\149\000\000\t\149\t\149\000\000\000\000\000\000\t\149\001\006\000\000\001\n\003\218\000\000\t\149\000\000\t\149\003\222\000\000\t\149\000\000\t\149\000\018\000\000\000\000\000\000\t\149\000\000\000\000\000\000\000\000\000\000\000\000\022\142\000\000\t\149\000\000\000\000\000\000\000\234\t\149\000\000\t\149\000\000\000\238\000\000\000\000\t\149\000\000\000\000\000\000\t\149\000\000\t\149\t\149\000\000\000\000\000\000\000\250\t\149\000\000\000\000\000\000\t\149\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\000\000\t\149\t\149\t\149\015\198\000\000\000\000\000\000\000\000\000\000\t\149\000\000\t\149\t\149\000\000\000\000\000\000\t\149\t\149\t\149\t\129\000\000\t\129\t\129\000\000\000\000\000\000\t\129\001\006\000\000\001\n\003\218\000\000\t\129\000\000\t\129\003\222\000\000\t\129\000\000\t\129\000\018\000\000\000\000\000\000\t\129\000\000\000\000\000\000\000\000\000\000\000\000\023\166\000\000\t\129\000\000\000\000\000\000\000\234\t\129\000\000\t\129\000\000\000\238\000\000\000\000\t\129\000\000\000\000\000\000\t\129\000\000\t\129\t\129\000\000\000\000\000\000\000\250\t\129\000\000\000\000\000\000\t\129\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\000\000\t\129\t\129\t\129\015\206\000\000\000\000\000\000\000\000\000\000\t\129\000\000\t\129\t\129\000\000\000\000\000\000\t\129\t\129\t\129\t\141\000\000\t\141\t\141\000\000\000\000\000\000\t\141\001\006\000\000\001\n\003\218\000\000\t\141\000\000\t\141\003\222\000\000\t\141\000\000\t\141\000\018\000\000\000\000\000\000\t\141\000\000\000\000\000\000\000\000\000\000\000\000\024\166\000\000\t\141\000\000\000\000\000\000\000\234\t\141\000\000\t\141\000\000\000\238\000\000\000\000\t\141\000\000\000\000\000\000\t\141\000\000\t\141\t\141\000\000\000\000\000\000\000\250\t\141\000\000\000\000\000\000\t\141\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\000\000\t\141\t\141\t\141\015\222\000\000\000\000\000\000\000\000\000\000\t\141\000\000\t\141\t\141\000\000\000\000\000\000\t\141\t\141\t\141\tq\000\000\tq\tq\000\000\000\000\000\000\tq\001\006\000\000\001\n\003\218\000\000\tq\000\000\tq\003\222\000\000\tq\000\000\tq\000\000\000\000\000\000\000\000\tq\000\000\000\018\000\000\000\000\000\000\000\000\000\000\000\000\tq\000\000\000\000\000\000\027V\tq\000\000\tq\000\000\000\018\000\234\026\198\tq\000\000\000\000\000\238\tq\000\000\tq\tq\027\146\000\000\000\000\000\000\tq\000\000\000\234\000\000\tq\000\250\000\000\000\238\000\000\000\000\000\000\000\000\000\254\000\000\000\000\tq\tq\tq\015\230\001\002\000\000\000\250\000\000\000\000\tq\000\000\tq\tq\000\254\000\000\000\000\tq\tq\tq\tu\001\002\tu\tu\000\000\000\000\000\000\tu\000\000\000\000\000\000\000\000\000\000\tu\001\006\tu\001\n\003\218\tu\000\000\tu\000\000\003\222\000\000\000\000\tu\000\000\b\246\000\000\000\000\001\006\000\000\001\n\003\218\tu\000\000\000\000\000\000\003\222\tu\000\000\tu\000\000\000\018\011*\000\000\tu\000\000\000\000\011V\tu\000\000\tu\tu\028J\000\000\000\000\000\000\tu\000\000\000\234\000\000\tu\011\138\000\000\000\238\000\000\000\000\000\000\000\000\011\218\000\000\000\000\tu\tu\tu\015\238\012\006\000\000\000\250\000\000\000\000\tu\000\000\tu\tu\000\254\000\000\000\000\tu\tu\tu\t\153\001\002\t\153\t\153\000\000\000\000\000\000\t\153\000\000\000\000\000\000\000\000\000\000\t\153\012B\t\153\012n\012\218\t\153\000\000\t\153\000\000\r\006\000\000\000\000\t\153\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\t\153\000\000\000\000\000\000\003\222\t\153\000\000\t\153\000\000\000\018\000\000\000\000\t\153\000\000\000\000\000\000\t\153\000\000\t\153\t\153\t\017\000\000\000\000\000\000\t\153\000\000\000\234\000\000\t\153\000\000\000\000\000\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\153\t\153\t\153\015\254\000\000\000\000\000\250\000\000\000\000\t\153\000\000\t\153\t\153\000\254\000\000\000\000\t\153\t\153\t\153\t}\001\002\t}\t}\000\000\000\000\000\000\t}\000\000\000\000\000\000\000\000\000\000\t}\000\000\t}\000\000\000\000\t}\000\000\t}\000\000\000\000\000\000\000\000\t}\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\t}\000\000\000\000\000\000\003\222\t}\000\000\t}\000\000\000\000\000\000\000\000\t}\000\000\000\000\000\000\t}\000\000\t}\t}\000\000\000\000\000\000\000\000\t}\000\000\000\000\000\000\t}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t}\t}\t}\016\006\000\000\000\000\000\000\000\000\000\000\t}\000\000\t}\t}\000\000\000\000\000\000\t}\t}\t}\t\145\000\000\t\145\t\145\000\000\000\000\000\000\t\145\000\000\000\000\000\000\000\000\000\000\t\145\000\000\t\145\000\000\000\000\t\145\000\000\t\145\000\000\000\000\000\000\000\000\t\145\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\145\000\000\000\000\000\000\000\000\t\145\000\000\t\145\000\000\000\000\000\000\000\000\t\145\000\000\000\000\000\000\t\145\000\000\t\145\t\145\000\000\000\000\000\000\000\000\t\145\000\000\000\000\000\000\t\145\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\145\t\145\t\145\016\014\000\000\000\000\000\000\000\000\000\000\t\145\000\000\t\145\t\145\000\000\000\000\000\000\t\145\t\145\t\145\ty\000\000\ty\ty\000\000\000\000\000\000\ty\000\000\000\000\000\000\000\000\000\000\ty\000\000\ty\000\000\000\000\ty\000\000\ty\000\000\000\000\000\000\000\000\ty\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ty\000\000\000\000\000\000\000\000\ty\000\000\ty\000\000\000\000\000\000\000\000\ty\000\000\000\000\000\000\ty\000\000\ty\ty\000\000\000\000\000\000\000\000\ty\000\000\000\000\000\000\ty\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ty\ty\ty\016\022\000\000\000\000\000\000\000\000\000\000\ty\000\000\ty\ty\000\000\000\000\000\000\ty\ty\ty\t\133\000\000\t\133\t\133\000\000\000\000\000\000\t\133\000\000\000\000\000\000\000\000\000\000\t\133\000\000\t\133\000\000\000\000\t\133\000\000\t\133\000\000\000\000\000\000\000\000\t\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\133\000\000\000\000\000\000\000\000\t\133\000\000\t\133\000\000\000\000\000\000\000\000\t\133\000\000\000\000\000\000\t\133\000\000\t\133\t\133\000\000\000\000\000\000\000\000\t\133\000\000\000\000\000\000\t\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\133\t\133\t\133\016\030\003B\000\000\001\022\001.\b\022\t\133\003\158\t\133\t\133\000\000\000\000\000\000\t\133\t\133\t\133\t-\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\030:\000\000\000\000\000\000\000\000\000\000\006R\0016\000\000\001\146\000\000\000\000\000\000\000\000\002:\002B\001\022\001.\001Z\000\000\002\246\000\000\000\000\000\000\002J\002*\000\000\022j\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\030\174\000\000\000\000\000\000\000\000\000\000\025\150\0016\000\000\001\146\000\000\000\000\000\000\000\000\002\250\002B\001\022\001.\001Z\000\000\006\206\000\000\000\000\000\000\002J\002*\000\000\025\194\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\018\007\014\002\"\000\000\001\178\000\000\000\000\000\000\000\000\023z\000\000\025\210\0016\000\000\001\146\007&\000\000\000\234\000\000\006\210\002B\000\000\007Z\001Z\007\166\000\000\007\174\007\182\000\000\002J\002*\007\214\000\000\000\000\001\186\002R\007v\007\226\000\000\007\238\000\000\000\000\007\246\000\254\b\006\000\000\000\000\000\000\000\000\b\026\021\246\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\002E\022\n\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\022:\000\000\b\190\000\000\006\021\b\202\000\000\001\006\000\000\001\n\003\218\000\000\000\000\000\000\006\021\022V\000\000\006\021\006\021\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006%\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006%\000\000\000\000\006%\006%\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\0059\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0059\000\000\000\000\0059\0059\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006A\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006A\000\000\000\000\006A\006A\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\0069\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0069\000\000\000\000\0069\0069\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006\005\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\005\000\000\000\000\006\005\006\005\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\253\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\253\000\000\000\000\005\253\005\253\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\001\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\001\000\000\000\000\005\001\005\001\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\025\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\025\000\000\000\000\005\025\005\025\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\004\249\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\249\000\000\000\000\004\249\004\249\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\0061\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0061\000\000\000\000\0061\0061\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\017\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\017\000\000\000\000\005\017\005\017\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006\017\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\017\000\000\000\000\006\017\006\017\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006\029\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\029\000\000\000\000\006\029\006\029\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\153\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\153\000\000\000\000\005\153\005\153\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\t\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\t\000\000\000\000\005\t\005\t\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005)\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005)\000\000\000\000\005)\005)\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005!\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005!\000\000\000\000\005!\005!\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006\r\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\r\000\000\000\000\006\r\006\r\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005I\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005I\000\000\000\000\005I\005I\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\004\241\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\241\000\000\000\000\004\241\004\241\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005E\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005E\000\000\000\000\005E\005E\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\229\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\229\000\000\000\000\005\229\005\229\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005A\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005A\000\000\000\000\005A\005A\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005=\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005=\000\000\000\000\005=\005=\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\225\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\225\000\000\000\000\005\225\005\225\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005Q\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Q\000\000\000\000\005Q\005Q\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005M\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005M\000\000\000\000\005M\005M\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\233\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\233\000\000\000\000\005\233\005\233\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\029\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\029\000\000\000\000\005\029\005\029\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\209\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\209\000\000\000\000\005\209\005\209\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\0051\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0051\000\000\000\000\0051\0051\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005-\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005-\000\000\000\000\005-\005-\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\217\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\217\000\000\000\000\005\217\005\217\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005%\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005%\000\000\000\000\005%\005%\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\213\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\213\000\000\000\000\005\213\005\213\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\005\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\005\000\000\000\000\005\005\005\005\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\197\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\197\000\000\000\000\005\197\005\197\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\149\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\149\000\000\000\000\005\149\005\149\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005a\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005a\000\000\000\000\005a\005a\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005]\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005]\000\000\000\000\005]\005]\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005y\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005y\000\000\000\000\005y\005y\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005u\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005u\000\000\000\000\005u\005u\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\185\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\185\000\000\000\000\005\185\005\185\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005Y\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Y\000\000\000\000\005Y\005Y\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005U\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005U\000\000\000\000\005U\005U\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005q\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005q\000\000\000\000\005q\005q\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005m\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005m\000\000\000\000\005m\005m\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\181\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\181\000\000\000\000\005\181\005\181\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005i\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005i\000\000\000\000\005i\005i\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005e\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005e\000\000\000\000\005e\005e\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\137\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\137\000\000\000\000\005\137\005\137\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\145\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\145\000\000\000\000\005\145\005\145\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\141\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\141\000\000\000\000\005\141\005\141\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\133\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\133\000\000\000\000\005\133\005\133\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\129\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\129\000\000\000\000\005\129\005\129\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005}\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005}\000\000\000\000\005}\005}\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\169\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\169\000\000\000\000\005\169\005\169\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\165\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\165\000\000\000\000\005\165\005\165\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\161\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\161\000\000\000\000\005\161\005\161\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\157\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\157\000\000\000\000\005\157\005\157\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\177\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\177\000\000\000\000\005\177\005\177\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\173\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\173\000\000\000\000\005\173\005\173\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\245\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\245\000\000\000\000\005\245\005\245\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\249\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\249\000\000\000\000\005\249\005\249\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\r\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\r\000\000\000\000\005\r\005\r\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\201\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\201\000\000\000\000\005\201\005\201\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006-\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006-\000\000\000\000\006-\006-\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006!\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006!\000\000\000\000\006!\006!\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\004\245\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\245\000\000\000\000\004\245\004\245\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\189\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\189\000\000\000\000\005\189\005\189\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\237\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\237\000\000\000\000\005\237\005\237\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\241\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\241\000\000\000\000\005\241\005\241\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\021\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\021\000\000\000\000\005\021\005\021\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\205\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\205\000\000\000\000\005\205\005\205\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\004\253\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\253\000\000\000\000\004\253\004\253\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\193\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\193\000\000\000\000\005\193\005\193\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006\001\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\001\000\000\000\000\006\001\006\001\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006\t\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\t\000\000\000\000\006\t\006\t\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\0065\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0065\000\000\000\000\0065\0065\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006=\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006=\000\000\000\000\006=\006=\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\0055\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0055\000\000\000\000\0055\0055\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\005\221\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\221\000\000\000\000\005\221\005\221\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006)\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006)\000\000\000\000\006)\006)\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\006\025\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\025\000\000\000\000\006\025\006\025\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\000\000\000\000\000\000\000\000\000\000\000\000\t\022\000\000\t*\tJ\000\000\000\000\000\000\t^\tj\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\000\000\000\000\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\016R\b\202\000\000\000\000\000\000\000\000\017\030\000\000\000\000\000\000\017\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\222\b\234\b\242\001\022\001.\b2\000\000\006z\000\000\t\022\000\000\t*\tJ\000\000\025\246\000\000\t^\tj\017\182\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\026\006\0016\000\000\001\146\000\000\000\000\000\000\000\000\006\174\002B\001\022\001.\001Z\000\000\006\246\000\000\000\000\000\000\002J\002*\000\000\004*\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\n\026\0016\000\000\001\146\000\000\000\000\000\000\000\000\015v\002B\001\022\001.\001Z\000\000\007\n\000\000\000\000\000\000\002J\002*\000\000\004n\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\r\138\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\004\150\004\190\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\t\225\000\000\001\186\002R\000\000\000\000\000\000\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\005\006\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\005\030\005^\000\000\000\000\000\000\t\225\004\230\005f\t\225\000\000\000\000\005n\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\005~\004\150\004\190\000\000\004\182\000\000\000\000\000\000\000\000\000\000\005\134\005v\t\221\000\000\000\000\005\022\005\142\000\000\000\000\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\005\006\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\005\030\005^\000\000\000\000\000\000\t\221\004\230\005f\t\221\000\000\000\000\005n\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\016Z\005\166\001\022\001.\b\186\004\182\007\194\000\000\000\000\000\000\000\000\005\134\005v\006Z\000\000\000\000\005\022\005\142\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\016j\001Z\001\022\001.\b\218\000\000\t\002\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\016\162\001Z\001\022\001.\b\230\000\000\t6\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\016\222\001Z\001\022\001.\t\018\000\000\012z\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\017*\001Z\001\022\001.\t&\000\000\014\238\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\017r\001Z\001\022\001.\tF\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\017\202\001Z\001\022\001.\tZ\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\018\018\001Z\001\022\001.\tf\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\018J\001Z\001\022\001.\t\150\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\018\186\001Z\001\022\001.\t\170\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\018\226\001Z\001\022\001.\t\190\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\019:\001Z\001\022\001.\t\238\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\019\150\001Z\001\022\001.\n\002\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\019\210\002B\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\n\"\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\020\014\001Z\001\022\001.\n:\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\020v\001Z\001\022\001.\nN\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\020\214\001Z\001\022\001.\nv\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\021\162\001Z\001\022\001.\n\166\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\030\n\001Z\001\022\001.\n\186\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\030r\001Z\001\022\001.\n\218\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\030\234\001Z\001\022\001.\n\254\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\031F\001Z\001\022\001.\011\"\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\031\130\001Z\001\022\001.\011:\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\031\190\001Z\001\022\001.\011N\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000 &\001Z\001\022\001.\011n\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000 \134\001Z\001\022\001.\011\130\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000 \230\001Z\001\022\001.\011\210\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\011\234\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\011\254\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012\022\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012*\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012:\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012R\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012f\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012\138\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012\170\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012\190\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012\210\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012\234\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\012\254\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\r2\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\rF\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\rj\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\r~\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\r\146\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\r\170\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\r\190\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\r\254\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\014B\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\014\134\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\014\170\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\014\218\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\015\026\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\021*\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\022N\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\023R\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\024Z\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\025Z\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\025\158\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\025\218\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\026\014\000\000\001\186\002R\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\0266\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\026N\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\000\000\000\000\001Z\001\022\001.\029\250\000\000\000\000\002J\002*\000\000\000\000\000\000\001\186\002R\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\002\n\000\000\000\000\000\000\000\000\001\138\002\018\002\026\000\000\000\000\002\"\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002B\004\150\004\190\001Z\000\000\000\000\000\000\000\000\000\000\002J\002*\000\000\ne\000\000\001\186\002R\000\000\000\000\ne\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\000\000\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ne\000\000\000\000\000\000\ne\004\230\000\000\ne\000\000\000\000\ne\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\ne\ne\004\150\004\190\004\182\000\000\000\000\000\000\000\000\000\000\ne\ne\000\000\n]\000\000\005\022\ne\000\000\000\000\n]\004\206\000\000\004\246\000\000\000\000\004\214\004\254\000\000\004\222\000\000\000\000\000\000\000\000\004\138\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n]\000\000\000\000\000\000\n]\004\230\000\000\n]\000\000\000\000\n]\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\158\000\000\004\238\000\000\000\000\000\000\000\000\n]\n]\000\000\000\000\004\182\007\166\000\000\007\174\007\182\000\000\n]\n]\007\214\000\000\000\000\005\022\n]\000\000\007\226\000\000\007\238\000\000\000\000\007\246\000\000\b\006\000\000\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\017\"\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017N\007\166\000\000\007\174\007\182\000\000\000\000\000\000\007\214\000\000\000\000\b\222\b\234\b\242\007\226\000\000\007\238\000\000\000\000\007\246\t\022\b\006\t*\tJ\000\000\000\000\b\026\t^\tj\000\000\000\000\000\000\000\000\000\000\000\000\b6\000\000\000\000\000\000\000\000\b:\000\000\bN\000\000\000\000\000\000\000\000\b\170\000\000\000\000\000\000\b\190\000\000\017\194\b\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\000\000\b\222\b\234\b\242\000\000\000\"\000\000\000\000\007\242\000\000\t\022\000\000\t*\tJ\000&\0002\0006\t^\tj\t1\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000.\000\000\000\000\000\000\000&\0002\0006\001\246\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000Z\000\000\000\000\000\000\000&\0002\0006\000n\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000&\0002\0006\003\n\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\001\"\000\000\000\000\000\000\000\000\000\000\002\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\134\002\166\002\170\002\186\000\000\004\209\000\000\002\190\000\154\000\158\000\174\000\178\000\186\000\000\002\230\000\202\002\234\000\206\000\000\000\000\000\000\002\238\000\000\003\006\000\000\000\000\000\000\003\022\003\026\000\000\000\000\000\000\000\000\000\000\003*\003Z\000\000\000\000\bf\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\003z\003~\003\142\003\146\003\170\000\"\000\000\003\186\000\000\003\190\000\018\007\014\000\000\000\000\000&\0002\0006\000\000\000\000\024\130\000\000\000F\000\000\000\026\000\000\007&\000\000\000\234\000^\000\"\001\242\001\250\007Z\000\000\002\142\000f\000\000\000j\000&\0002\0006\000r\000v\000\000\000\000\000F\007v\000\000\000\134\000\138\000\000\000\000\000^\000\254\000b\000\000\000\000\000\000\000\000\000f\021\246\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\002E\022\n\000\134\000\138\000\000\000\000\000\000\000\154\000\158\000\174\000\178\000\186\022:\000\000\000\202\000\000\000\206\000\000\000\000\001\006\000\000\001\n\003\218\000\000\000\000\000\000\000\000\022V\000\000\000\000\000\026\000\154\000\158\000\174\000\178\000\186\000\"\000\000\000\202\000\000\000\206\002\210\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\000\000\026\000\000\000\000\000\000\000\000\000^\000\"\000b\000\000\000\000\000\000\003f\000f\000\000\000j\000&\0002\0006\000r\000v\000\000\000\000\000F\000\000\000\000\000\134\000\138\000\000\000\000\000^\000\000\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\154\000\158\000\174\000\178\000\186\000\000\000\000\000\202\000\000\000\206\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\000\154\000\158\000\174\000\178\000\186\002\130\000\000\000\202\000\000\000\206\000\000\000\000\000\000\000\000\002\134\002\166\002\170\004\142\000\000\t\005\000\000\002\190\000\000\000\026\000\000\000\000\000\000\000\000\002\230\000\"\002\234\000\000\000\000\000\000\007\254\002\238\000\000\003\006\000&\0002\0006\003\022\003\026\000\000\000\000\000F\000\000\000\000\003*\003Z\000\000\000\000\000^\000\000\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\003z\003~\003\142\003\146\003\170\000\000\000\000\003\186\000\000\003\190\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\000\154\000\158\000\174\000\178\000\186\002\130\000\000\000\202\000\000\000\206\000\018\007\014\000\000\000\000\002\134\002\166\002\170\bv\000\000\025\130\000\000\002\190\000\000\000\026\000\000\007&\000\000\000\234\002\230\000\"\002\234\000\000\007Z\000\000\r\214\002\238\000\000\003\006\000&\0002\0006\003\022\003\026\000\000\000\000\000F\007v\000\000\003*\003Z\000\000\000\000\000^\000\254\000b\000\000\000\000\000\000\000\000\000f\021\246\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\002E\022\n\000\134\000\138\000\000\000\000\000\000\003z\003~\003\142\003\146\003\170\022:\000\000\003\186\000\000\003\190\000\000\000\000\001\006\000\000\001\n\003\218\000\000\000\000\000\000\000\000\022V\000\000\000\000\000\026\000\154\000\158\000\174\000\178\000\186\000\"\000\000\000\202\000\000\000\206\014^\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\000\000\026\000\000\000\000\000\000\000\000\000^\000\"\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000&\0002\0006\000r\000v\000\000\000\000\000\214\000\000\000\000\000\134\000\138\000\000\000\000\000^\000\000\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\0062\000\000\000\000\000\000\000\154\000\158\000\174\000\178\000\186\000\000\000\000\000\202\000\000\000\206\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\000\154\000\158\000\174\000\178\000\186\000\"\000\000\000\202\000\000\000\206\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\003\198\000\000\000\026\000\000\000\000\000\000\000\000\000^\000\"\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000&\0002\0006\000r\000v\000\000\000\000\003\230\000\000\000\000\000\134\004F\000\000\000\000\000^\000\000\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\004\006\000\000\000\000\000\000\000\154\000\158\000\174\000\178\000\186\000\000\000\000\000\202\000\000\000\206\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\000\154\000\158\000\174\000\178\000\186\000\"\000\000\000\202\000\000\000\206\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\tr\000\000\000\026\000\000\000\000\000\000\000\000\000^\000\"\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000&\0002\0006\000r\000v\000\000\000\000\r\014\000\000\000\000\000\134\t\210\000\000\000\000\000^\000\000\000b\000\000\000\000\000\000\000\000\000f\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\018\007\014\000\134\rN\000\000\000\000\000\000\000\154\000\158\000\174\000\178\000\186\000\000\000\000\000\202\007&\000\206\000\234\000\000\000\000\000\000\000\000\007Z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\154\000\158\000\174\000\178\000\186\007v\000\000\000\202\000\000\000\206\000\018\007\014\000\254\022\162\000\000\000\000\000\000\000\000\000\000\021\246\000\000\000\000\000\000\000\018\007\014\007&\000\000\000\234\000\000\002E\022\n\000\000\007Z\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\234\022:\000\000\000\000\000\000\007Z\007v\000\000\001\006\000\000\001\n\003\218\000\000\000\254\022\222\000\000\022V\000\018\007\014\007v\021\246\000\000\000\000\000\000\000\000\000\000\000\254\023\n\000\000\000\000\002E\022\n\007&\021\246\000\234\000\000\000\000\000\000\000\000\007Z\000\000\000\000\022:\002E\022\n\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\007v\000\000\022:\000\000\022V\000\018\007\014\000\254\0236\001\006\000\000\001\n\003\218\000\000\021\246\000\000\000\000\022V\000\018\007\014\007&\000\000\000\234\000\000\002E\022\n\000\000\007Z\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\234\022:\000\000\000\000\000\000\007Z\007v\000\000\001\006\000\000\001\n\003\218\000\000\000\254\023\186\000\000\022V\000\018\007\014\007v\021\246\000\000\000\000\000\000\000\000\000\000\000\254\023\230\000\000\000\000\002E\022\n\007&\021\246\000\234\000\000\000\000\000\000\000\000\007Z\000\000\000\000\022:\002E\022\n\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\007v\000\000\022:\000\000\022V\000\018\007\014\000\254\024\018\001\006\000\000\001\n\003\218\000\000\021\246\000\000\000\000\022V\000\018\007\014\007&\000\000\000\234\000\000\002E\022\n\000\000\007Z\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\234\022:\000\000\000\000\000\000\007Z\007v\000\000\001\006\000\000\001\n\003\218\000\000\000\254\024>\000\000\022V\000\018\007\014\007v\021\246\000\000\000\000\000\000\000\000\000\000\000\254\024\186\000\000\000\000\002E\022\n\007&\021\246\000\234\000\000\000\000\000\000\000\000\007Z\000\000\000\000\022:\002E\022\n\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\007v\000\000\022:\000\000\022V\000\018\007\014\000\254\024\230\001\006\000\000\001\n\003\218\000\000\021\246\000\000\000\000\022V\000\018\007\014\007&\000\000\000\234\000\000\002E\022\n\000\000\007Z\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\234\022:\000\000\000\000\000\000\007Z\007v\000\000\001\006\000\000\001\n\003\218\000\000\000\254\025\018\000\000\022V\000\018\007\014\007v\021\246\000\000\000\000\000\000\000\000\000\000\000\254\025>\000\000\000\000\002E\022\n\007&\021\246\000\234\000\000\000\000\000\000\000\000\007Z\000\000\000\000\022:\002E\022\n\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\007v\000\000\022:\000\000\022V\000\018\007\014\000\254\026\130\001\006\000\000\001\n\003\218\000\000\021\246\000\000\000\000\022V\000\018\007\014\007&\000\000\000\234\000\000\002E\022\n\000\000\007Z\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\234\022:\000\000\000\000\000\000\007Z\007v\000\000\001\006\000\000\001\n\003\218\000\000\000\254\026\174\000\000\022V\000\018\007\014\007v\021\246\000\000\000\000\000\000\000\000\000\000\000\254\027\018\000\000\000\000\002E\022\n\007&\021\246\000\234\000\000\000\000\000\000\000\000\007Z\000\000\000\000\022:\002E\022\n\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\007v\000\000\022:\000\000\022V\000\018\007\014\000\254\027\206\001\006\000\000\001\n\003\218\000\000\021\246\000\000\000\000\022V\000\018\007\014\007&\000\000\000\234\000\000\002E\022\n\000\000\007Z\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\234\022:\000\000\000\000\000\000\007Z\007v\000\000\001\006\000\000\001\n\003\218\000\000\000\254\027\250\000\000\022V\000\018\007\014\007v\021\246\000\000\000\000\000\000\000\000\000\000\000\254\028.\000\000\000\000\002E\022\n\007&\021\246\000\234\000\000\000\000\000\000\000\000\007Z\000\000\000\000\022:\002E\022\n\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\007v\000\000\022:\000\000\022V\000\018\007\014\000\254\028^\001\006\000\000\001\n\003\218\000\000\021\246\000\000\000\000\022V\000\018\007\014\007&\000\000\000\234\000\000\002E\022\n\000\000\007Z\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\234\022:\000\000\000\000\000\000\007Z\007v\000\000\001\006\000\000\001\n\003\218\000\000\000\254\028\138\000\000\022V\000\000\000\000\007v\021\246\000\000\000\000\000\000\000\000\000\000\000\254\028\218\000\000\000\000\002E\022\n\000\000\021\246\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\022:\002E\022\n\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\000\000\000\000\022:\000\000\022V\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\218\000\000\000\000\000\000\000\000\022V"))
  
  and lhs =
    (8, "\001\000\"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    \031\031\031\031\031\031\031\031\031\031\031\031\031\030\030\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\027\027\026\026\026\026\026\026\025\025\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\023\023\023\022\022\021\021\021\021\020\020\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\017\017\017\016\016\016\015\015\015\014\r\r\r\r\r\r\r\r\012\012\011\011\n\n\t\t\b\b\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\006\006\006\006\005\005\005\005\005\005\004\004\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\002\002\002\002\002\002\002\002\002\002\002\002\002")
  
  and goto =
    ((16, "\000\r\0003\000\000\000P\000\000\000+\000\000\001v\000\000\000\000\003\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004j\000\000\001\214\002\006\0026\004\128\000\000\000\000\000\000\000\000\000\000\000\000\003\n\000\000\000\000\004\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0030\000\000\000\000\000\000\000\000\003V\000\000\003\146\000\000\000\000\000\000\000\000\003\224\000\000\000\000\000\000\000\000\003\228\000\000\000\000\000\000\000\000\003\234\000\000\003\250\000\000\000R\000\000\004 \000\000\004v\000\000\000\000\004\166\000\000\000\000\004\240\000\000\000\000\000\000\000\000\005V\000\000\000\000\000\000\000\000\000\000\005X\000\000\005\\\000\000\005\168\000\000\b6\000\000\b>\000\000\bD\000\000\bF\000\000\b\152\000\000\b\156\000\000\b\158\000\000\b\164\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000J\002\006\000N\000\000\000z\000\000\000\000\b\166\000\000\b\176\000\000\b\178\000\000\b\180\000\000\b\182\000\000\b\184\000\000\000~\000\000\b\186\000\000\b\188\000\000\b\190\000\000\000\170\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\140\000\000\000\000\000\000\000\000\004\142\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\144\000\000\000\000\000\000\000\000\000\000\b\252\b\254\b\196\000\000\000\000\004\152\000\000\000\000\004\154\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\198\000\000\b\200\b\214\b\204\000\000\b\206\b\220\000\000\000\000\b\210\000\000\000\000\000\000\004\156\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\212\000\000\000\000\000\000\000\007\000\000\000\000\000\000\000\000\t\018\000\000\b\216\000\000\000\000\000\000\000\000\t\024\000\000\000\000\b\220\000\000\000\000\000\000\000\000\t\028\000\000\000\000\000\000\000\000\000\000\t\030\000\000\000\000\000\000\000\000\b\226\000\000\000\000\t\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t$\000\000\000\000\000\000\000\000\000\000\b\232\000\000\000\000\t(\000\000\000\000\000\000\000\000\000\000\000\174\000\000\000\000\t(\000\000\000\000\t\028\000\000\000\000\000\000\000\000\t,\000\000\t.\000\000\t0\000\000\t2\000\000\t4\000\000\t6\000\000\t8\000\000\t:\000\000\t<\000\000\t>\000\000\t@\000\000\tB\000\000\tD\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\174\000\000\000\000\000\000\000\000\000\000\000\000\tF\000\000\tH\000\000\tJ\000\000\tL\000\000\000\222\000\000\tN\000\000\tP\000\000\000\238\000\000\tR\000\000\001\014\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\000\000\000\000\000\000\001\024\000\000\001 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\tV\000\000\000\000\000\000\000\000\000\000\t\026\000\000\000\000\tZ\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\030\t,\000\000\t\"\000\000\000\000\000\000\000\000\000\000\004\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001@\t8\000\000\000\000\000\000\000\\\000\000\000\000\001L\000\000\000\000\000\000\000\000\001D\000\000\000\000\t:\003\136\000\000\000\000\001H\003\228\000\000\000\000\004\000\000\000\000\000\000\005\t(\000\000\000\000\000\000\000\024\000\000\002\222\000\000\004\150\000\000\t*\000\000\tZ\000\000\t.\000\000\004\152\000\000\000\000\004\154\000\000\000\000\004\164\t0\004\166\000\000\004\174\000\000\004\192\t`\000\000\t4\000\000\004\194\000\000\000\000\td\000\000\t8\000\000\004\196\000\000\004\184\000\000\000\000\000\000\000\000\004\220\000\000\000\000\000\000\000\000\001N\000\000\000\000\000\000\001~\000\000\000\000\000\000\000\000\th\000\000\000\000\000\000\000\000\004\222\000\000\000\000\000\000\tj\000\000\t>\000\000\004\204\000\000\000\000\004\206\tn\000\000\tB\000\000\004\210\tD\000\000\004\212\000\000\004\214\000\000\000\000\tF\000\000\000\000\000\000\tH\000\000\004\224\tx\000\000\tL\000\000\004\226\000\000\tN\000\000\t~\000\000\tR\000\000\004\232\t\130\000\000\tV\000\000\004\240\tX\000\000\004\242\000\000\tZ\000\000\000\000\000\000\000\000\t\154\t\140\000\000\t`\000\000\004\252\000\000\000\000\tb\000\000\004\254\000\000\000\000\td\000\000\005\002\000\000\000\000\005\004\000\000\000\000\000\000\t\164\t\150\000\000\tj\000\000\005\006\000\000\000\000\tl\000\000\005\012\000\000\000\000\005\014\000\000\000\000\tn\000\000\000\000\t\174\t\160\000\000\tt\000\000\005\016\000\000\000\000\tv\000\000\005\018\000\000\000\000\005\024\000\000\000\000\000\000\000\000\tx\000\000\005 \000\000\000\000\005\"\000\000\000\000\000\b\000\000\t\168\000\000\t|\000\000\005,\000\000\000\000\t~\000\000\005.\000\000\000\000\0052\000\000\000\000\t\128\000\000\0054\000\000\000\000\0056\000\000\000\000\000\000\t\130\000\000\005<\000\000\000\000\005>\000\000\000\000\000\000\t\132\000\000\005@\000\000\000\000\000\000\t\134\000\000\005B\000\000\000\000\t\136\000\000\005H\000\000\000\000\000\000\000\000\000\000\t\138\000\000\005P\000\000\000\000\t\140\000\000\005R\000\000\t\144\000\000\000\000\t\146\000\000\000\000\005p\000\000\000\000\000\000\005r\000\000\000\000\005v\000\000\000\000\t\146\000\000\005d\000\000\000\000\000\000\t\148\000\000\005f\000\000\000\000\t\150\000\000\005l\000\000\000\000\000\000\t\152\000\000\005n\000\000\000\000\t\154\000\000\005p\000\000\t\156\000\000\005v\000\000\000\000\000\000\t\158\000\000\005z\000\000\000\000\t\160\000\000\005\128\000\000\000\000\t\162\000\000\000\000\000\000\t\164\000\000\005\130\000\000\000\n\000\000\000\000\000\000\t\166\000\000\005\148\000\000\000\000\t\168\000\000\005\150\000\000\000\000\t\170\000\000\005\156\000\000\000\000\000\000\t\172\000\000\005\158\000\000\000\000\t\174\000\000\005\160\000\000\000\000\t\176\000\000\000\000\000\000\000\000\t\240\000\000\000\000\t\180\000\000\005\162\000\000\000\000\t\182\000\000\005\164\000\000\000\000\000\000\t\246\000\000\000\000\t\186\000\000\005\166\000\000\000\000\t\188\000\000\005\168\000\000\000\000\t\190\000\000\000\000\t\254\000\000\000\000\t\194\000\000\005\170\000\000\000\000\t\196\000\000\005\176\000\000\000\000\000\000\000\000\005\192\000\000\005\198\000\000\000\000\000\000\005\202\000\000\000\000\t\198\000\000\005\204\000\000\000\000\005\206\000\000\000\000\005\208\000\000\000\000\000\000\000\000\005\210\000\000\000\000\000\000\t\200\000\000\005\212\000\000\000\000\005\214\000\000\000\000\005\230\000\000\005\218\000\000\000\000\000\000\005\224\000\000\000\000\t\202\000\000\005\240\000\000\000\000\005\244\000\000\000\000\000\000\t\204\000\000\005\246\000\000\000\000\005\250\000\000\000\000\000\000\000\000\005\252\000\000\000\000\000\000\005\254\000\000\000\000\t\206\000\000\000\000\006\000\000\000\000\000\006\004\000\000\000\000\000\000\000\000\t\208\000\000\006\006\000\000\000\000\006\n\000\000\000\000\000\000\000\000\006\016\000\000\000\000\000\000\000\000\006\026\000\000\000\000\000\000\000\028\000\000\000\000\000 \t\210\000\000\006 \t\226\000$\000\000\000\000\t\214\000\000\t\216\000\000\000\000\000(\t\218\000\000\000\000\000\000\t\228\n\018\000\000\n\020\000\000\n\022\000\000\n\024\000\000\000\000\000\000\n\026\000\000\n\028\000\000\n\030\001\146\000\000\000\000\n \000\000\n\"\000\000\n$\000\000\n&\000\000\n(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006$\t\246\000\000\006&\n\b\t\250\000\000\006*\n\012\000\000\000\000\n\006\006,\n\b\000,\000\000\n\n\000\000\000\000\n\004\000\000\006.\n\022\000\000\000H\000\000\0060\000\000\000L\000\000\000P\000\000\000\000\000\000\n\b\000\000\0064\n\026\000\000\n\020\000\000\0066\000\000\n\022\000\000\n\024\000\000\000\000\006:\000\000\n\026\000\000\006@\n\020\000\000\006J\n&\000\000\n \000\000\006P\000\000\n\"\000\000\n$\000T\000\000\n&\000\000\000\000\000\000\n \000\000\006T\n2\000\000\n,\000\000\006V\000\000\n.\000\000\n0\000\000\n2\000X\000\000\n4\000\000\000\000\n.\000\000\006Z\n0\000\000\006\\\nB\000\000\n<\000\000\006^\000\000\n>\000\000\n@\000\\\000\000\nB\000\000\000\000\000\000\n<\000\000\006`\nN\000\000\nH\000\000\006d\000\000\nJ\000\000\nL\000\000\000\000\nF\000\000\006f\nX\000\000\nR\000\000\006j\000\000\nT\000\000\nV\000\000\000\000\000x\000\000\000\000\000|\000\000\nP\000\000\000\000\000\128\000\000\000\132\000\000\000\000\n`\nT\000\000\006p\nd\000\136\000\000\nf\000\000\000\000\000\000\nZ\000\000\006z\nl\000\000\nl\000\000\006\128\000\000\nn\000\000\np\000\000\000\140\006\132\000\168\000\172\000\000\000\176\000\000\000\000\000\000\nd\000\000\006\134\nv\000\000\000\180\000\000\006\138\000\000\000\184\000\000\000\188\000\000\000\000\000\216\006\140\000\220\000\224\000\000\000\228\000\000\000\000\000\000\nh\000\000\006\142\nz\000\000\000\232\000\000\006\144\000\000\000\236\000\000\001\b\000\000\000\000\n|\nn\000\000\006\148\n\128\000\000\n\128\001\012\006\150\001\016\001\020\000\000\001\024\000\000\000\000\000\000\nt\000\000\006\154\n\134\000\000\001\028\000\000\006\160\000\000\0018\000\000\001<\000\000\000\000\006\170\000\000\n\134\001@\006\176\001D\001H\000\000\001L\000\000\000\000\000\000\nz\000\000\006\180\n\140\000\000\001h\000\000\006\182\000\000\001l\000\000\001p\000\000\000\000\n\140\001t\006\186\001x\001|\000\000\001\152\000\000\000\000\000\000\n\128\000\000\006\188\n\146\000\000\001\156\000\000\006\190\000\000\001\160\000\000\001\164\000\000\000\000\000\000\006\192\000\000\001\168\000\000\000\000\000\000\n\132\000\000\000\000\001\172\000\000\000\000\000\000\000\000\000\000\000\000\n\158\n\136\000\000\n\162\001\200\000\000\n\164\000\000\000\000\000\000\006\196\000\000\001\204\000\000\000\000\001\208\000\000\001\212\000\000\000\000\n\142\000\000\006\198\n\160\000\000\000\000\001\216\000\000\006\202\000\000\000\000\001\220\000\000\000\000\001\248\000\000\001\252\000\000\000\000\002\000\000\000\000\000\001\160\n\166\004n\000\000\000\000\001\164\000\000\000\000\000\000\000\000\n\184\000\000\n\186\000\000\000\000\000\000\000\000\001\172\n\214\000\000\000\000\n\154\000\000\000\000\001\176\n\218\000\000\000\000\n\158\000\000\000\000\000\000\001\220\000\000\000\000\000\000\002\000\000\000\006\252\000\000\000\000\002\004\000\000\002\b\002\004\000\000\002\012\000\000\000\000\000\000\000\000\007\002\000\000\000\000\000\000\000\000\0020\000\000\002`\002\b\000\000\002h\000\000\000\000\007\006\000\000\000\000\002l\000\000\002p\002\012\000\000\002\144\000\000\000\000\000\000\000\000\000\000\002\152\000\000\002\192\002(\000\000\002\200\000\000\000\000\n\160\000\000\000\000\002\208\000\000\000\000\000\000\002\240\000\000\002,\000\000\004$\000\000\006\242\000\000\000\000\000\000\000\000\000\000\000\000\007\b\000\000\007\n\000\000\000\000\007\012\000\000\007\016\0020\000\000\007\018\000\000\000\000\000\000\000\000\000\000\007\022\000\000\007\026\0024\000\000\007\030\000\000\000\000\007 \000\000\000\000\007\"\000\000\007$\0028\000\000\007(\000\000\000\000\000\000\000\000\000\000\007*\000\000\007,\002<\000\000\007.\000\000\000\000\n\162\000\000\000\000\0070\000\000\000\000\000\000\0074\000\000\002X\000\000\0076\000\000\0078\000\000\000\000\000\000\000\000\007:\000\000\007>\000\000\000\000\007B\000\000\007H\002\\\000\000\007L\000\000\000\000\000\000\000\000\000\000\007T\000\000\007Z\002`\000\000\007f\000\000\000\000\007p\000\000\000\000\007r\000\000\007t\002d\000\000\007x\000\000\000\000\000\000\000\000\000\000\007z\000\000\007~\002h\000\000\007\132\000\000\000\000\n\164\000\000\000\000\007\134\000\000\000\000\000\000\007\138\000\000\002l\000\000\007\140\000\000\007\144\000\000\000\000\000\000\n\166\000\000\000\000\000\000\007\146\000\000\000\000\000\000\000\000\n\168\000\000\000\000\000\000\007\148\000\000\n\170\000\000\000\000\000\000\007\150\000\000\000\000\n\172\000\000\000\000\000\000\007\152\000\000\n\174\000\000\000\000\000\000\007\156\000\000\000\000\000\000\000\000\000\000\n\176\000\000\000\000\007\158\000\000\000\000\n\178\000\000\000\000\007\160\000\000\000\000\000\000\n\216\000\000\000\000\000\000\007\162\000\000\000\000\007\164\002\136\000\000\007\170\000\000\000\000\000\000\000\000\000\000\007\176\000\000\007\180\002\140\000\000\007\182\000\000\000\000\007\218\000\000\000\000\000\000\007\230\000\000\000\000\000\000\007\236\000\000\000\000\000\000\000\000\n\244\000\000\000\000\000\000\007\188\000\000\007\194\002\144\000\000\007\206\000\000\000\000\000\000\000\000\000\000\000\000\002\148\000\000\007\220\000\000\000\000\000\000\000\000\007\224\000\000\000\000\002\152\000\000\007\248\000\000\000\000\000\000\000\000\002\156\000\000\007\250\000\000\000\000\007\252\000\000\000\000\002\184\000\000\007\254\000\000\000\000\000\000\000\000\002\188\000\000\b\000\000\000\000\000\b\004\002\192\000\000\b\006\000\000\000\000\000\000\000\000\000\000\b\b\000\000\b\n\002\196\000\000\b\012\000\000\000\000\000\000\n\246\000\000\000\000\000\000\b\018\000\000\b\020\002\200\000\000\b\022\000\000\000\000\000\000\b\024\000\000\000\000\b\026\000\000\b\028\002\204\000\000\b\030\000\000\000\000\000\000\000\000\000\000\b \000\000\b\"\002\232\000\000\b$\000\000\000\000\000\000\002\212\000\000\000\000\000\000\b&\000\000\000\000\n\248\000\000\000\000\000\000\b(\000\000\b0\002\236\000\000\b6\000\000\000\000\000\000\000\000\004\006\000\000\000\000\bB\000\000\000\000\000\000\bD\000\000\n\250\000\000\000\000\bL\000\000\000\000\000\000\b`\000\000\000\000\bb\000\000\000\000\bf\000\000\n\252\000\000\000\000\bh\000\000\000\000\000\000\000\000\bT\000\000\002\238\n\192\000\000\000\000\000\000\002\242\000\000\002\244\000\000\000\000\002\252\000\000\000\000\000\000\000\000\000\000\n\218\000\000\bL\000\000\003\016\000\000\000\000\003\b\000\000\000\000\003\024\000\000\000\000\n\196\000\000\000\000\003\026\n\198\000\000\bN\n\214\003\030\000\000\n\216\003\"\000\000\000\000\n\204\000\000\n\206\000\000\000\000\003>\000\000\003*\n\208\000\000\000\000\000\000\n\218\000\000\003.\000\000\n\212\000\000\bP\n\230\000\000\003@\000\000\bT\000\000\003D\000\000\003H\000\000\000\000\000\000\n\216\000\000\000\000\003d\000\000\003P\000\000\bX\003T\003p\000\000\003j\000\000\000\000\000\000\n\218\000\000\bn\n\236\000\000\003v\000\000\bt\000\000\003z\000\000\003\134\000\000\000\000\003\138\bv\003\140\003\154\000\000\003\156\000\000\000\000\000\000\n\222\000\000\b|\n\240\000\000\003\160\000\000\b~\000\000\003\172\000\000\003\176\000\000\000\000\n\242\n\228\000\000\b\128\n\246\000\000\n\246\003\188\b\130\003\192\003\206\000\000\003\208\000\000\000\000\000\000\n\234\000\000\b\132\n\252\000\000\003\210\000\000\b\136\000\000\003\214\000\000\003\226\000\000\000\000\b\138\000\000\n\252\003\242\b\144\003\244\003\248\000\000\004\004\000\000\000\000\000\000\n\240\000\000\b\146\011\002\000\000\004\b\000\000\b\158\000\000\004\020\000\000\004\024\000\000\000\000\011\002\004\026\b\164\004*\004(\000\000\004.\000\000\000\000\000\000\n\246\000\000\b\166\011\b\000\000\004:\000\000\b\172\000\000\004>\000\000\004J\000\000\000\000\000\000\b\174\000\000\004N\000\000\000\000\000\000\004P\000\000\000\000\n\250\000\000\b\176\011\012\000\000\000\000\004`\000\000\b\178\000\000\000\000\004d\000\000\000\000\004l\000\000\004p\000\000\000\000\000\000\000\000"), (16, "\001%\001%\001n\001n\001%\000\003\001n\001%\001%\001n\001n\001%\001\194\001n\001r\001r\005|\004&\001r\001s\001\128\001r\001r\001\162\000\004\001q\002\165\003&\007]\002h\005y\004&\005N\004&\005G\004&\004\171\004&\004\161\004&\004#\004&\005\158\002h\001%\002h\001|\002h\001\207\002h\000\155\002h\000\153\002h\004-\004&\0041\004&\0043\004&\004V\004&\004j\004&\004~\004&\001\211\002h\007[\002h\000\130\002h\000\130\002h\000\129\002h\000\144\002h\004\160\004&\004\163\004&\004\168\004&\004\170\004&\004\178\004&\004\218\004&\001%\002h\001l\002h\000\130\002h\000\130\002h\000\152\002h\001R\002h\004\203\004&\004\200\004&\004\202\004&\004\211\004&\004\215\004&\004\217\004&\001%\002h\001a\002h\000\130\002h\000\130\002h\001%\002h\001g\002h\004\241\004&\004\226\004&\004\223\004&\004\225\004&\004\234\004&\004\238\004&\001%\002h\001k\002h\001\132\002h\001\135\002h\001\132\002h\001\134\002h\004\240\004&\005\015\004&\005\000\004&\004\253\004&\004\255\004&\005\b\004&\005\158\002h\005\158\002h\005\158\002h\001\207\002h\001%\002h\002\027\002h\005\012\004&\005\014\004&\005)\004&\005\026\004&\005\023\004&\005\025\004&\001\210\002h\007<\002h\007\017\002h\006\242\002h\001%\002h\002\031\002h\005\"\004&\005&\004&\005(\004&\005A\004&\0052\004&\005/\004&\005\158\002h\005\158\002h\003\254\002h\005\158\002h\005\158\002h\001\189\002h\0051\004&\005:\004&\005>\004&\005@\004&\005F\004&\005M\004&\000\130\002h\006\202\002h\006\159\002h\005\158\002h\006\151\002h\006\136\002h\005X\004&\005`\004&\005c\004&\005e\004&\005n\004&\005s\004&\005\158\002h\005\158\002h\005\158\002h\005\158\002h\006e\002h\001\184\002h\005v\004&\005x\004&\005{\004&\005\170\004&\005\185\004&\005\196\004&\005\158\002h\005\162\002h\005\167\002h\005\173\002h\005\172\002h\000\154\002h\005\207\004&\005\221\004&\005\240\004&\005\251\004&\006\006\004&\006\017\004&\005\158\002h\005\182\002h\005\158\002h\005\158\002h\005\158\002h\001\179\002h\006\031\004&\0060\004&\006;\004&\006F\004&\006Q\004&\006_\004&\005\158\002h\005\188\002h\005\158\002h\005\187\002h\005\193\002h\005\199\002h\006\162\004&\006\173\004&\006\198\004&\006\207\004&\006\217\004&\006\224\004&\005\158\002h\005\198\002h\005\158\002h\005\204\002h\005\158\002h\001\207\002h\006\232\004&\006\239\004&\006\245\004&\007\000\004&\007\r\004&\007\025\004&\005\158\002h\005\210\002h\007*\002h\005\209\002h\003\209\002h\005\215\002h\007$\004&\0078\004&\007\154\007f\004&\007\154\002h\bK\007k\004&\bJ\002h\005\219\002h\002h\007\154\002h\002h\007u\004&\b4\002h\007{\004&\007\154\007\134\004&\002h\007\154\b3\001\171\002h\007\154\007\198\007\154\002h\002h\007\169\002h\007\168\002h\007\145\004&\007\154\002h\007\154\002h\007\154\007\161\001\158\007\165\007\154\007\167\007\154\002h\002h\007\176\002h\007\183\002h\007\174\004&\005\174\002h\007\154\002h\007\180\004&\001\157\007\182\007\154\006\249\007\154\002h\001\187\007\191\002h\007\195\007\154\002h\007\154\007\154\002h\007\197\002h\007\221\007\206\007\203\004&\007\154\002h\007\154\002h\002h\007\205\000\167\007\214\007\154\001\148\007\154\002h\002h\007\218\002h\007\220\007\154\001\137\007\154\001\130\002h\007\251\002h\007\236\007\233\004&\007\154\007\154\002h\007\154\002h\007\235\007\244\005\174\007\248\007\154\007?\002h\002h\002h\007\250\002h\006\203\007\154\007\154\b\003\004&\002h\b\021\b\006\007C\005\158\007\154\000E\007\154\002h\002h\b\005\002h\b\014\007\154\000G\007\154\007\154\002h\b\018\002h\b\020\b-\b\027\004&\007\154\002h\007\154\002h\002h\b\030\005\226\b\029\007\154\000K\007\154\002h\002h\b&\002h\b*\007\154\005\174\007\154\007\154\002h\b,\002h\b2\b6\001\185\006\166\007\154\002h\007\154\002h\002h\b?\007\154\bD\007\154\001\177\001\169\bG\002h\bI\002h\000\165\000\169\000\182\002h\000\167\002h\000\192\000\196\000\219\001\182\000M\000T\003\204\003\195\003\194\000\167\000\167\003\177\002)\003\185\003\181\000\167\000\167\000\167\002h\002h\002h\000\167\000\167\000\167\000\167\002h\002h\003\176\003\167\003\150\002\022\002(\000\167\003\141\003\133\002\024\003t\003s\003r\002h\002h\002h\000S\002\197\002\188\002h\002h\002\163\002h\002h\002h\002\154\002\153\002\024\002\024\002h\002h\002g\002l\002h\002q\002t\002}\002h\002h\002\130\002\133\002\144\002\149\002h\002h\002\152\002h\002h\002h\002\159\002\162\002h\002h\002h\002h\002\171\002\176\002h\002\179\002\184\002\187\002h\002h\002\193\002\196\002\202\002\208\002h\002h\002\213\002h\002h\002h\002\221\002\226\002h\002h\002h\002h\002\234\002\238\002h\002\241\002\246\002\252\002h\002h\003\001\003\007\003\012\000X\000^\003\016\000`\003\022\002h\002h\003\027\003$\002h\002h\002h\002\236\002\236\002h\002\236\002h\003,\0031\002h\002h\0036\003<\003A\003N\003S\003\\\003a\003l\002h\002h\003q\003y\002h\002h\002h\002h\002h\002h\002h\002h\000b\003x\002h\003|\003\129\003\132\003\135\003\140\003\146\003\149\003\155\003\154\000\167\002h\003\158\002h\002h\002h\002h\002h\002h\002h\003\163\002h\003\166\003\172\002h\003\175\003\180\003\184\003\190\000\167\003\193\003\200\002h\003\203\002h\002h\003\208\002h\002h\002h\002h\003\213\002h\002h\004\242\002h\004\144\004\024\002h\004\028\0045\004*\004/\002h\0049\004>\002h\004E\002h\002h\004Z\002h\002h\002h\002h\004L\002h\002h\004Q\002h\004^\004c\002h\004\130\004t\004y\004\134\002h\004\139\004\148\002h\004\153\002h\002h\004\182\002h\002h\002h\002h\004\186\002h\002h\004\191\002h\004\204\004\208\002h\004\213\004\227\004\231\004\236\002h\004\246\005\001\002h\005\005\002h\002h\005\n\002h\002h\002h\002h\005\017\002h\002h\005\027\002h\005\031\005$\002h\0053\0057\005<\005D\002h\005f\005j\002h\005p\002h\002h\005\158\002h\002h\002h\002h\005\174\002h\002h\005\174\002h\005\174\005\158\005\174\005\158\005\178\005\158\005\158\005\177\005\158\005\200\005\158\005\244\005\158\005\174\005\158\005\158\005\225\005\158\005\158\005\158\005\158\005\158\006\n\005\158\005\158\005\158\005\158\005\232\005\174\005\237\005\158\005\243\005\242\005\158\005\248\005\158\005\254\0064\005\253\005\158\006\003\006\t\005\158\006\b\006\014\006\020\006\019\006\025\005\158\006\029\006$\006#\006(\005\174\005\158\005\158\006-\005\158\005\158\0063\005\158\0062\006J\005\158\005\158\0068\005\158\005\158\006>\005\158\005\158\005\158\005\158\005\158\006=\005\158\005\158\005\158\005\158\005\158\006C\006I\005\158\006H\006N\005\158\006T\005\158\005\158\006S\006Y\005\158\006]\006d\005\158\006c\006k\006t\006z\006\129\005\158\006\135\006\144\006\150\006\158\006\165\006\179\005\158\006\164\005\174\006\187\006\170\006\179\006\176\006\175\006\179\006\182\006\195\006\220\006\186\006\201\005\158\005\158\005\174\005\158\005\158\006\200\005\158\005\158\005\158\005\158\005\158\006\235\006\209\005\158\005\158\005\158\005\174\005\158\005\158\005\158\005\158\005\158\005\158\005\158\005\158\007\029\006\219\006\226\005\158\006\234\006\241\005\158\006\248\006\247\006\253\007\003\007\002\007?\005\158\007\n\007\016\007\015\005\158\007\022\007\028\007\027\007!\007'\007&\007.\0075\007B\005\158\007?\007;\005\158\005\158\007:\007_\b7\007\222\007\158\000d\007\163\007F\007\184\000f\007R\007K\000h\000j\002h\002h\002h\007`\002h\007\188\002h\007O\007\193\007\207\007U\007Z\007\211\007\216\007\226\007\237\007\241\002h\007\246\007\253\002h\002h\b\007\b\011\002h\002h\002h\002h\002h\b\016\002h\002h\b\031\b#\002h\002h\b(\b0\b;\bA\000l\002h\000n\000p\002h\002h\000r\000\132\002h\002h\002h\002h\000\134\000\136\000\138\000\140\000\142\000\146\000\148\000\150\001{\001z\000\189\000\204\000\206\000\212\000\208\000\210\000\211\000\214\000\231\001\"\001\025\001\014\001\b\000\255\001\005\001\n\001\r\001\021\001\027\001\030\001'\001+\001/\0011\0013\0015\0017\0019\001;\001=\001?\001A\001C\001E\001G\001Y\001[\001]\001_\001c\001e\001i\001\144\001\150\001\153\001\173\001\174\001\176\007/\007\004\001\230\001\240\003\201\001\244\003\182\003\173\002\005\003\164\002\012\002$\003\147\002.\003\130\0026\0029\002@\002D\002\194\002I\002M\002\185\002Q\002\160\002V\002Y\002\134\002b\002r\002e\002j\002o\002x\002\131\002{\002\128\002\136\002\139\002\150\002\142\002\147\002\157\002\177\002\169\002\174\002\182\002\191\002\200\002\206\002\211\002\219\002\224\002\239\002\232\002\244\002\250\002\255\003\005\003\n\003\014\003\020\003\025\003\030\003\"\003*\003/\0034\003:\003?\003b\003I\003L\003Q\003W\003Z\003_\003d\003g\003j\003o\003\127\003\144\003\161\003\170\003\187\003\198\003\221\004\219\003\228\003\230\003\234\004\158\004\020\004\019\004\018\004\017\004\016\004\015\004\014\004\r\004\012\004\011\004\n\004\t\004\022\004\030\004\026\004\029\004C\0044\004%\004(\004+\0047\004:\004<\004@\004B\004G\004J\004M\004O\004S\004Y\004X\004\\\004_\004a\004e\004g\004m\004l\004o\004r\004u\004w\004{\004\129\004\128\004\132\004\135\004\137\004\141\004\143\004\146\004\149\004\151\004\155\004\157\004\165\004\196\004\174\004\181\004\180\004\184\004\187\004\189\004\193\004\195\004\206\004\209\004\229\004\232\005B\004\244\004\247\004\249\005\003\005\006\005\019\005\029\005 \005+\0055\0058\005J\005\\\005U\005[\005Z\005h\005k\006\189\005\139\005\138\005\144\005\147\005\151\005\154\005\212\006\022\006V\006g\006p\006v\006}\006\131\006\141\006\147\006\154\006\191\007\006\0071\007H\007W\007b\007q\007~\007\130\007\199\007\136\007\140\007\142\007\148\007\152\007\156\007\159\007\171\007\186\007\189\007\209\007\212\b.\007\224\007\227\007\229\007\239\007\242\007\255\b\t\b\012\b\023\b!\b$\b9\b<"))
  
  and semantic_action =
    [|
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.decl option list) = Obj.magic x in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x = 
# 207 "asllib/Parser0.mly"
                      ( List.filter_map Fun.id x )
# 783 "asllib/Parser0.ml"
           in
          (
# 196 "<standard.mly>"
    ( x )
# 788 "asllib/Parser0.ml"
           : (AST.t))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 828 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 64 "asllib/Parser0.mly"
       (bool)
# 849 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 369 "asllib/Parser0.mly"
                       AST.L_Bool        
# 861 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 867 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 876 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 62 "asllib/Parser0.mly"
       (Z.t)
# 898 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 370 "asllib/Parser0.mly"
                       AST.L_Int         
# 910 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 916 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 925 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 63 "asllib/Parser0.mly"
       (Q.t)
# 947 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 371 "asllib/Parser0.mly"
                       AST.L_Real        
# 959 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 965 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 974 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 61 "asllib/Parser0.mly"
       (Bitvector.t)
# 996 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 372 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 1008 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1014 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1023 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 1045 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 373 "asllib/Parser0.mly"
                       AST.L_String      
# 1057 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1063 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1072 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 1106 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 1112 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1124 "asllib/Parser0.ml"
              
            in
            
# 339 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1130 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1139 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 1161 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 339 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1172 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1181 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 1209 "asllib/Parser0.ml"
             in
            
# 339 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1214 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1223 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 1271 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 1277 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 1287 "asllib/Parser0.ml"
             in
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 1293 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1298 "asllib/Parser0.ml"
              
            in
            let qualident =
              let _2 = _2_inlined1 in
              let i = _1 in
              
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1307 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 1314 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1323 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 1378 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 1384 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 1394 "asllib/Parser0.ml"
             in
            let _2 =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1402 "asllib/Parser0.ml"
              
            in
            let qualident =
              let _2 = _2_inlined1 in
              let i = _1 in
              
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1411 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 1418 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1427 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 1463 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 1473 "asllib/Parser0.ml"
             in
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 1479 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1484 "asllib/Parser0.ml"
              
            in
            let qualident = _1 in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 1492 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1501 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 1544 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 1554 "asllib/Parser0.ml"
             in
            let _2 =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1562 "asllib/Parser0.ml"
              
            in
            let qualident = _1 in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 1570 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1579 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 1621 "asllib/Parser0.ml"
             in
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 1627 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1632 "asllib/Parser0.ml"
              
            in
            let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 1638 "asllib/Parser0.ml"
             in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 1644 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1653 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 1702 "asllib/Parser0.ml"
             in
            let _2 =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1710 "asllib/Parser0.ml"
              
            in
            let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 1716 "asllib/Parser0.ml"
             in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 1722 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1731 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 661 "asllib/Parser0.mly"
            ( AST.BNOT )
# 1766 "asllib/Parser0.ml"
             in
            
# 341 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1771 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1780 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 662 "asllib/Parser0.mly"
            ( AST.NEG )
# 1815 "asllib/Parser0.ml"
             in
            
# 341 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1820 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1829 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 663 "asllib/Parser0.mly"
            ( AST.NOT )
# 1864 "asllib/Parser0.ml"
             in
            
# 341 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1869 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1878 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 668 "asllib/Parser0.mly"
                 ( AST.AND    )
# 1920 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 1925 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1934 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 669 "asllib/Parser0.mly"
                 ( AST.BAND   )
# 1976 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 1981 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 1990 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 670 "asllib/Parser0.mly"
                 ( AST.BOR    )
# 2032 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2037 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2046 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 671 "asllib/Parser0.mly"
                 ( AST.DIV    )
# 2088 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2093 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2102 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 672 "asllib/Parser0.mly"
                 ( AST.EOR    )
# 2144 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2149 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2158 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 673 "asllib/Parser0.mly"
                 ( AST.EQ_OP  )
# 2200 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2205 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2214 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 674 "asllib/Parser0.mly"
                 ( AST.NEQ    )
# 2256 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2261 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2270 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 675 "asllib/Parser0.mly"
                 ( AST.GEQ    )
# 2312 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2317 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2326 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 676 "asllib/Parser0.mly"
                 ( AST.IMPL   )
# 2368 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2373 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2382 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 677 "asllib/Parser0.mly"
                 ( AST.LEQ    )
# 2424 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2429 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2438 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 678 "asllib/Parser0.mly"
                 ( AST.PLUS   )
# 2480 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2485 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2494 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 679 "asllib/Parser0.mly"
                 ( AST.MINUS  )
# 2536 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2541 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2550 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 680 "asllib/Parser0.mly"
                 ( AST.MOD    )
# 2592 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2597 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2606 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 681 "asllib/Parser0.mly"
                 ( AST.MUL    )
# 2648 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2653 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2662 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 682 "asllib/Parser0.mly"
                 ( AST.OR     )
# 2704 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2709 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2718 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 683 "asllib/Parser0.mly"
                 ( AST.RDIV   )
# 2760 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2765 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2774 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 684 "asllib/Parser0.mly"
                 ( AST.SHL    )
# 2816 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2821 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2830 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 685 "asllib/Parser0.mly"
                 ( AST.SHR    )
# 2872 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2877 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2886 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 665 "asllib/Parser0.mly"
                                  ( AST.PLUS )
# 2928 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2933 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2942 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 693 "asllib/Parser0.mly"
                 ( AST.LT     )
# 2984 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2989 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 2998 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 694 "asllib/Parser0.mly"
                 ( AST.GT     )
# 3040 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3045 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3054 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 274 "asllib/Parser0.mly"
                                           ( h::t )
# 3114 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 3120 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 343 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 3127 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3136 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 361 "asllib/Parser0.mly"
                                                build_expr_conds  
# 3209 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 344 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 3215 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3224 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 3258 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 345 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 3271 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3280 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 3330 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3335 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 346 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 3342 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3351 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3409 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 346 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 3416 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3425 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 3468 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3473 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 347 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 3480 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3489 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3540 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 347 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 3547 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3556 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 3592 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3597 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 348 "asllib/Parser0.mly"
                                                        AST.E_Concat     
# 3604 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3613 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3657 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 348 "asllib/Parser0.mly"
                                                        AST.E_Concat     
# 3664 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3673 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern = 
# 631 "asllib/Parser0.mly"
             ( AST.Pattern_All )
# 3715 "asllib/Parser0.ml"
             in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 3720 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3729 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 60 "asllib/Parser0.mly"
       (Bitvector.mask)
# 3763 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1_1 = _1 in
              
# 632 "asllib/Parser0.mly"
                    AST.Pattern_Mask  
# 3777 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 3783 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3792 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 64 "asllib/Parser0.mly"
       (bool)
# 3826 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 369 "asllib/Parser0.mly"
                       AST.L_Bool        
# 3843 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 3849 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3858 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 3865 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 3871 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3880 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 62 "asllib/Parser0.mly"
       (Z.t)
# 3914 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 370 "asllib/Parser0.mly"
                       AST.L_Int         
# 3931 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 3937 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3946 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 3953 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 3959 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 3968 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 63 "asllib/Parser0.mly"
       (Q.t)
# 4002 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 371 "asllib/Parser0.mly"
                       AST.L_Real        
# 4019 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 4025 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4034 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 4041 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 4047 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4056 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 61 "asllib/Parser0.mly"
       (Bitvector.t)
# 4090 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 372 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 4107 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 4113 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4122 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 4129 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 4135 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4144 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 4178 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 373 "asllib/Parser0.mly"
                       AST.L_String      
# 4195 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 4201 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4210 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 4217 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 4223 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4232 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 4278 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 4284 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _2 = _2_inlined1 in
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 4302 "asllib/Parser0.ml"
                    
                  in
                  
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 4308 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4317 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 4324 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 4330 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4339 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 4373 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 4389 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4398 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 4405 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 4411 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4420 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 4465 "asllib/Parser0.ml"
                   in
                  
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 4470 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4479 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 4486 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 4492 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4501 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let pattern =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 641 "asllib/Parser0.mly"
                                           AST.Pattern_Any  
# 4561 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 4567 "asllib/Parser0.ml"
              
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 4573 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4582 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 4618 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4626 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4633 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4642 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 4678 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4686 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4693 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4702 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 4738 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4746 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4753 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4762 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 4791 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 4804 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4813 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4820 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4829 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 4870 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 4876 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 4891 "asllib/Parser0.ml"
                  
                in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 4897 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4906 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4913 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4922 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 4958 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4966 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4973 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 4982 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 5040 "asllib/Parser0.ml"
                 in
                
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 5045 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5054 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 5061 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5070 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 5152 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 5158 "asllib/Parser0.ml"
                 in
                
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 5163 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5172 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 5179 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5188 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 5247 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5254 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5263 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 5270 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5279 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 5341 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 5362 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5370 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5379 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 5386 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5395 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 5469 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 5475 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 5497 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 5505 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5513 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5522 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 5529 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5538 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 5632 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5640 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5649 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 5656 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5665 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5701 "asllib/Parser0.ml"
               in
              let _1 = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 5706 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5713 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5722 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 5756 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5769 "asllib/Parser0.ml"
               in
              let _1 = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 5774 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5781 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5790 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5826 "asllib/Parser0.ml"
               in
              let _1 = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 5831 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5838 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5847 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 5881 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5894 "asllib/Parser0.ml"
               in
              let _1 = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 5899 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5906 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5915 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5951 "asllib/Parser0.ml"
               in
              let _1 = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 5956 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5963 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 5972 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 6006 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6019 "asllib/Parser0.ml"
               in
              let _1 = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 6024 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6031 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6040 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 6069 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6080 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 6087 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6095 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6104 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 6138 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 6144 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6155 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 6162 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6170 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6179 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 6220 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 6226 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6237 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6246 "asllib/Parser0.ml"
                  
                in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 6252 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6260 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6269 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 6315 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 6321 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 6327 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6338 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6347 "asllib/Parser0.ml"
                  
                in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 6353 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6361 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6370 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6406 "asllib/Parser0.ml"
               in
              let _1 = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 6411 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6418 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6427 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 6461 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6474 "asllib/Parser0.ml"
               in
              let _1 = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 6479 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6486 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6495 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6552 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6558 "asllib/Parser0.ml"
                 in
                
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 6563 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6571 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6580 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 6632 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 6650 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6657 "asllib/Parser0.ml"
                 in
                
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 6662 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6670 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6679 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6757 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 6766 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6772 "asllib/Parser0.ml"
                 in
                
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 6777 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6785 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6794 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 6864 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 6885 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 6895 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6901 "asllib/Parser0.ml"
                 in
                
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 6906 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6914 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 6923 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6980 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 6987 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6994 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7002 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7011 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 7063 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 7081 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 7089 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7096 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7104 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7113 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 7175 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7188 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7202 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7210 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7218 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7227 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 7291 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 7300 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7313 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7327 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7335 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7343 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7352 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 7426 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 7432 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7445 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 7459 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7467 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7475 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7483 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7492 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 7568 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 7577 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 7583 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7596 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 7610 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7618 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7626 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7634 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7643 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7728 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7742 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7750 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7758 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7767 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 7843 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7863 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7877 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7885 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7893 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7902 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc = 
# 332 "asllib/Parser0.mly"
          ( AST.E_Concat [ e1; e2 ] )
# 7943 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 7951 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v : (AST.local_decl_item) = 
# 580 "asllib/Parser0.mly"
            ( AST.LDI_Discard )
# 7977 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 7998 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 581 "asllib/Parser0.mly"
                          ( AST.LDI_Var x )
# 8008 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 8035 "asllib/Parser0.ml"
           in
          (
# 581 "asllib/Parser0.mly"
                          ( AST.LDI_Var x )
# 8040 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.local_decl_item list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let ldis =
            let x =
              let _1 = _1_inlined1 in
              let t = _1 in
              
# 274 "asllib/Parser0.mly"
                                           ( h::t )
# 8099 "asllib/Parser0.ml"
              
            in
            
# 205 "<standard.mly>"
    ( x )
# 8105 "asllib/Parser0.ml"
            
          in
          (
# 584 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 8111 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 558 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 8138 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8146 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 8180 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 8186 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 8198 "asllib/Parser0.ml"
              
            in
            
# 557 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8204 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8213 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 8235 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 557 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8246 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8255 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 8283 "asllib/Parser0.ml"
             in
            
# 557 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8288 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8297 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 8340 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 8345 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 568 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8352 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8361 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 8412 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 568 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8419 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8428 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 8470 "asllib/Parser0.ml"
             in
            let _3_1 = _3 in
            
# 569 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8476 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8485 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = _1 in
            let _3_1 = _3 in
            
# 569 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8536 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8545 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 8589 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 570 "asllib/Parser0.mly"
                                                 AST.LE_Destructuring  
# 8596 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8605 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 8639 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 571 "asllib/Parser0.mly"
                                                 AST.LE_SetField     
# 8652 "asllib/Parser0.ml"
             (lexpr, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8661 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = l;
                MenhirLib.EngineTypes.startp = _startpos_l_;
                MenhirLib.EngineTypes.endp = _endpos_l_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 8711 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 8716 "asllib/Parser0.ml"
              
            in
            
# 572 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 8722 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8731 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = l;
                  MenhirLib.EngineTypes.startp = _startpos_l_;
                  MenhirLib.EngineTypes.endp = _endpos_l_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 8789 "asllib/Parser0.ml"
              
            in
            
# 572 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 8795 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8804 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 = 
# 558 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 8846 "asllib/Parser0.ml"
             in
            let _1 =
              let _1 =
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 8854 "asllib/Parser0.ml"
                
              in
              ()
            in
            _2
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 8867 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (unit list) = 
# 216 "<standard.mly>"
    ( [] )
# 8886 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let x : unit = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (unit list) = 
# 219 "<standard.mly>"
    ( x :: xs )
# 8918 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.case_alt list) = 
# 216 "<standard.mly>"
    ( [] )
# 8936 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 9010 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 624 "asllib/Parser0.mly"
    ( None )
# 9016 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 9024 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9030 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9039 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9045 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 9145 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9152 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9161 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9167 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9176 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9184 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9190 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9199 "asllib/Parser0.ml"
                
              in
              let where = 
# 624 "asllib/Parser0.mly"
    ( None )
# 9205 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 9213 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9219 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9228 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9234 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9353 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 9359 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9367 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9376 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9382 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9391 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9399 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9405 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9414 "asllib/Parser0.ml"
                
              in
              let where = 
# 624 "asllib/Parser0.mly"
    ( None )
# 9420 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 9428 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9434 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9443 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9449 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9510 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 9516 "asllib/Parser0.ml"
                
              in
              let where = 
# 624 "asllib/Parser0.mly"
    ( None )
# 9522 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 9530 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9536 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9545 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9551 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 9603 "asllib/Parser0.ml"
                
              in
              let where = 
# 624 "asllib/Parser0.mly"
    ( None )
# 9609 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 9617 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9623 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9632 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9638 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 9720 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9726 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 9734 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9740 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9749 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9755 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 9862 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9869 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9878 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9884 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9893 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9901 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9907 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9916 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9922 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 9930 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9936 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 9945 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9951 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10077 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 10083 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10091 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10100 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10106 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10115 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10123 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10129 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10138 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10144 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 10152 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10158 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10167 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10173 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10241 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 10247 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10253 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 10261 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10267 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10276 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10282 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 10341 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10347 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 10355 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10361 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10370 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10376 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 10472 "asllib/Parser0.ml"
                 _3_1
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10482 "asllib/Parser0.ml"
                
              in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 10491 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10497 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10506 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10512 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 10633 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10640 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10649 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10655 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10664 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10672 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10678 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10687 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10697 "asllib/Parser0.ml"
                
              in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 10706 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10712 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10721 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10727 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10867 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 10873 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10881 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10890 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10896 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10905 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10913 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10919 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10928 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10938 "asllib/Parser0.ml"
                
              in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 10947 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10953 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 10962 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10968 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11050 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 11056 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11066 "asllib/Parser0.ml"
                
              in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 11075 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11081 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11090 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11096 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 11169 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11179 "asllib/Parser0.ml"
                
              in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 11188 "asllib/Parser0.ml"
                 _1_1
              in
              
# 616 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11194 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11203 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11209 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11299 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11306 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11315 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11321 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11330 "asllib/Parser0.ml"
                
              in
              let where = 
# 624 "asllib/Parser0.mly"
    ( None )
# 11336 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 11344 "asllib/Parser0.ml"
                 _1_1
              in
              
# 618 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11350 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11359 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11365 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11474 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 11480 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11488 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11497 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11503 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11512 "asllib/Parser0.ml"
                
              in
              let where = 
# 624 "asllib/Parser0.mly"
    ( None )
# 11518 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 11526 "asllib/Parser0.ml"
                 _1_1
              in
              
# 618 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11532 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11541 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11547 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11644 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11651 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11660 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11666 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11675 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 11681 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 11689 "asllib/Parser0.ml"
                 _1_1
              in
              
# 618 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11695 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11704 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11710 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11826 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 11832 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11840 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11849 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11855 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11864 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 11870 "asllib/Parser0.ml"
               in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 11878 "asllib/Parser0.ml"
                 _1_1
              in
              
# 618 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11884 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 11893 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11899 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 12010 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12017 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12026 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12032 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12041 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 12051 "asllib/Parser0.ml"
                
              in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 12060 "asllib/Parser0.ml"
                 _1_1
              in
              
# 618 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12066 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12075 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12081 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12211 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 12217 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12225 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12234 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12240 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12249 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 12259 "asllib/Parser0.ml"
                
              in
              let pattern =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 629 "asllib/Parser0.mly"
                                         AST.Pattern_Any  
# 12268 "asllib/Parser0.ml"
                 _1_1
              in
              
# 618 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12274 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12283 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12289 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 12357 "asllib/Parser0.ml"
                 _3_1
              in
              
# 620 "asllib/Parser0.mly"
        ( AST.{ pattern = Pattern_All; where = None; stmt } )
# 12363 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12372 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12378 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 12471 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12478 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12487 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12493 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12502 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12510 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 12516 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12525 "asllib/Parser0.ml"
                
              in
              
# 620 "asllib/Parser0.mly"
        ( AST.{ pattern = Pattern_All; where = None; stmt } )
# 12531 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12540 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12546 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12658 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 12664 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12672 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12681 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12687 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12696 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12704 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 12710 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12719 "asllib/Parser0.ml"
                
              in
              
# 620 "asllib/Parser0.mly"
        ( AST.{ pattern = Pattern_All; where = None; stmt } )
# 12725 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12734 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12740 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12794 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 12800 "asllib/Parser0.ml"
                
              in
              
# 620 "asllib/Parser0.mly"
        ( AST.{ pattern = Pattern_All; where = None; stmt } )
# 12806 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12815 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12821 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 12866 "asllib/Parser0.ml"
                
              in
              
# 620 "asllib/Parser0.mly"
        ( AST.{ pattern = Pattern_All; where = None; stmt } )
# 12872 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 12881 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12887 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.decl option list) = 
# 216 "<standard.mly>"
    ( [] )
# 12906 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 12980 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 12986 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13007 "asllib/Parser0.ml"
                    
                  in
                  let _1 = 
# 123 "<standard.mly>"
    ( None )
# 13013 "asllib/Parser0.ml"
                   in
                  
# 383 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Constant;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13023 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 13032 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 13038 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13044 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13050 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 13113 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  let _1 = 
# 123 "<standard.mly>"
    ( None )
# 13132 "asllib/Parser0.ml"
                   in
                  
# 383 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Constant;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13142 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 13151 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 13157 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13163 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13169 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : unit = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 13246 "asllib/Parser0.ml"
                   in
                  let _1 = 
# 123 "<standard.mly>"
    ( None )
# 13251 "asllib/Parser0.ml"
                   in
                  
# 383 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Constant;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13261 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 13270 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 13276 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13282 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13288 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 13369 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 13375 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_inlined1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13397 "asllib/Parser0.ml"
                    
                  in
                  let _1 =
                    let x = x_inlined1 in
                    
# 126 "<standard.mly>"
    ( Some x )
# 13405 "asllib/Parser0.ml"
                    
                  in
                  
# 383 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Constant;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13416 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_x_inlined1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 13425 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 13431 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13437 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13443 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 13512 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_inlined1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  let _1 =
                    let x = x_inlined1 in
                    
# 126 "<standard.mly>"
    ( Some x )
# 13534 "asllib/Parser0.ml"
                    
                  in
                  
# 383 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Constant;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13545 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_x_inlined1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 13554 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 13560 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13566 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13572 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : unit = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_inlined1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 13656 "asllib/Parser0.ml"
                   in
                  let _1 =
                    let x = x_inlined1 in
                    
# 126 "<standard.mly>"
    ( Some x )
# 13663 "asllib/Parser0.ml"
                    
                  in
                  
# 383 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Constant;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13674 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_x_inlined1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 13683 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 13689 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13695 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13701 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 13762 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 13768 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13789 "asllib/Parser0.ml"
                    
                  in
                  
# 390 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 13800 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 13809 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 13815 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13821 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13827 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 13876 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  
# 390 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 13900 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 13909 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 13915 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13921 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13927 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 13990 "asllib/Parser0.ml"
                   in
                  
# 390 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 14000 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 14009 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 14015 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14021 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14027 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 14115 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 14121 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14144 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14153 "asllib/Parser0.ml"
                    
                  in
                  
# 397 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty) |> ASTUtils.add_dummy_pos);
            initial_value = None;
          }))
# 14164 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 14173 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 14179 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14185 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14191 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 14293 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 14299 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let (_2_inlined1, _2) = (_2_inlined2, _2_inlined1) in
              let x =
                let desc =
                  let e =
                    let (_2, _1_inlined1) = (_2_inlined1, _1_inlined3) in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14325 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14334 "asllib/Parser0.ml"
                    
                  in
                  
# 397 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty) |> ASTUtils.add_dummy_pos);
            initial_value = None;
          }))
# 14345 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 14354 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 14360 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14366 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14372 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 14448 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14470 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 397 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty) |> ASTUtils.add_dummy_pos);
            initial_value = None;
          }))
# 14482 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 14491 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 14497 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14503 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14509 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 14599 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14625 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 397 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty) |> ASTUtils.add_dummy_pos);
            initial_value = None;
          }))
# 14637 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 14646 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 14652 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14658 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14664 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14758 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 322 "asllib/Parser0.mly"
              ( "record" )
# 14766 "asllib/Parser0.ml"
                    
                  in
                  
# 397 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty) |> ASTUtils.add_dummy_pos);
            initial_value = None;
          }))
# 14777 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 14786 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 14792 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14798 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14804 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14916 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 322 "asllib/Parser0.mly"
              ( "record" )
# 14924 "asllib/Parser0.ml"
                    
                  in
                  
# 397 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty) |> ASTUtils.add_dummy_pos);
            initial_value = None;
          }))
# 14935 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 14944 "asllib/Parser0.ml"
                
              in
              
# 208 "asllib/Parser0.mly"
                      Some  
# 14950 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14956 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14962 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 15051 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 15057 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15074 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 15081 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15086 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15094 "asllib/Parser0.ml"
                  
                in
                
# 408 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15100 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 15109 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 15115 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15121 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 15217 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 15223 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15240 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15249 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15257 "asllib/Parser0.ml"
                  
                in
                
# 408 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15263 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 15272 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 15278 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15284 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 15361 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15378 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 15385 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15390 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 408 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15397 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 15406 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 15412 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15418 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 15502 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15519 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15528 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 408 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15535 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 15544 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 15550 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15556 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15646 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 15653 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15658 "asllib/Parser0.ml"
                  
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 15664 "asllib/Parser0.ml"
                 in
                
# 408 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15669 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 15678 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 15684 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15690 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15787 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15796 "asllib/Parser0.ml"
                  
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 15802 "asllib/Parser0.ml"
                 in
                
# 408 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15807 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 15816 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 15822 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15828 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 15923 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 15929 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15947 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 15954 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15959 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15968 "asllib/Parser0.ml"
                  
                in
                
# 412 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 15974 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 15983 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 15989 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15995 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 16097 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 16103 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined2, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16121 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16130 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16139 "asllib/Parser0.ml"
                  
                in
                
# 412 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16145 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 16154 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 16160 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16166 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 16249 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16267 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 16274 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16279 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 412 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16286 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 16295 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 16301 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16307 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 16397 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16415 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16424 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 412 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16431 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 16440 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 16446 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16452 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16549 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 16556 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16561 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 322 "asllib/Parser0.mly"
              ( "record" )
# 16569 "asllib/Parser0.ml"
                  
                in
                
# 412 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16575 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 16584 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 16590 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16596 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16700 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16709 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 322 "asllib/Parser0.mly"
              ( "record" )
# 16717 "asllib/Parser0.ml"
                  
                in
                
# 412 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16723 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 16732 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 16738 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16744 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 16812 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 16818 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 16830 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 16836 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 16841 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16849 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 16855 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 16862 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16868 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 16943 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 16949 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 16963 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 16970 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 16975 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16983 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 16989 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 16996 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17002 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 17077 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 17083 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17095 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17103 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17111 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17117 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17124 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17130 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = x;
                            MenhirLib.EngineTypes.startp = _startpos_x_;
                            MenhirLib.EngineTypes.endp = _endpos_x_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 17212 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 17218 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17232 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17241 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17249 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17255 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17262 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17268 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 17324 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17336 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 17342 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17347 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17354 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17361 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17367 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 17430 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17444 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 17451 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17456 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17463 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17470 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17476 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 17539 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17551 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17559 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17566 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17573 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17579 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 17649 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17663 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17672 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17679 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17686 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17692 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17756 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 17762 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17767 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 17773 "asllib/Parser0.ml"
               in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17778 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17785 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17791 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17864 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 17871 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17876 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 17882 "asllib/Parser0.ml"
               in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17887 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17894 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17900 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17971 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17979 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 17985 "asllib/Parser0.ml"
               in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 17990 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 17997 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18003 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18083 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18092 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 18098 "asllib/Parser0.ml"
               in
              let _1 = 
# 208 "asllib/Parser0.mly"
                      Some  
# 18103 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 18110 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18116 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 18199 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 18205 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18221 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 18228 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18233 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18241 "asllib/Parser0.ml"
                  
                in
                
# 475 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type }
        )
# 18254 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 18263 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 18269 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18275 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 18365 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 18371 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18387 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 18396 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18404 "asllib/Parser0.ml"
                  
                in
                
# 475 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type }
        )
# 18417 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 18426 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 18432 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18438 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 18509 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18525 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 18532 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18537 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 475 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type }
        )
# 18551 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 18560 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 18566 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18572 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 18650 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18666 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 18675 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 475 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type }
        )
# 18689 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 18698 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 18704 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18710 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18793 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 18800 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18805 "asllib/Parser0.ml"
                  
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 18811 "asllib/Parser0.ml"
                 in
                
# 475 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type }
        )
# 18823 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 18832 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 18838 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18844 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18934 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 18943 "asllib/Parser0.ml"
                  
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 18949 "asllib/Parser0.ml"
                 in
                
# 475 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type }
        )
# 18961 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 18970 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 18976 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18982 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 19044 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 19050 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19061 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 19067 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19072 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19081 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19089 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19095 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 19164 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 19170 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19181 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 19187 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19192 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19201 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19209 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19215 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 19284 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 19290 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19301 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19309 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19318 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19326 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19332 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 19408 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 19414 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19425 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19433 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19442 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19450 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19456 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 19506 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19517 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 19523 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19528 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19536 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19542 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 19599 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19610 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 19616 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19621 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19629 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19635 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 19692 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19703 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19711 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19719 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19725 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 19789 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19800 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19808 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19816 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19822 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19879 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 19885 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19890 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 19896 "asllib/Parser0.ml"
               in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19903 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19909 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19973 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 19979 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19984 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 19990 "asllib/Parser0.ml"
               in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 19997 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20003 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20067 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20075 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 20081 "asllib/Parser0.ml"
               in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 20088 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20094 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20165 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20173 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 20179 "asllib/Parser0.ml"
               in
              _4
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 20186 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20192 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 20267 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 20273 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20290 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20298 "asllib/Parser0.ml"
                  
                in
                
# 421 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 20312 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 20321 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 20327 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20333 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 20396 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20413 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 421 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 20428 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 20437 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 20443 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20449 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20525 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 20531 "asllib/Parser0.ml"
                 in
                
# 421 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 20544 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 20553 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 20559 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20565 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 20654 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 20660 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20677 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20685 "asllib/Parser0.ml"
                  
                in
                
# 431 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 20699 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 20708 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 20714 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20720 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 20788 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 20794 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 20809 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20817 "asllib/Parser0.ml"
                  
                in
                
# 431 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 20831 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 20840 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 20846 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20852 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 20929 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20946 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 431 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 20961 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 20970 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 20976 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20982 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 21038 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 21053 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 431 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 21068 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 21077 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 21083 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21089 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21179 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 21185 "asllib/Parser0.ml"
                 in
                
# 431 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 21198 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 21207 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 21213 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21219 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 21286 "asllib/Parser0.ml"
                  
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 21292 "asllib/Parser0.ml"
                 in
                
# 431 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_Getter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 21305 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 21314 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 21320 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21326 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 21415 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 21421 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21438 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 21445 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 21450 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21458 "asllib/Parser0.ml"
                  
                in
                
# 441 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 21471 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 21480 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 21486 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21492 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 21588 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 21594 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21611 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 21620 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21628 "asllib/Parser0.ml"
                  
                in
                
# 441 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 21641 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 21650 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 21656 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21662 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 21739 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21756 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 21763 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 21768 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 441 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 21782 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 21791 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 21797 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21803 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 21887 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21904 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 21913 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 441 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 21927 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 21936 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 21942 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21948 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22038 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 22045 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 22050 "asllib/Parser0.ml"
                  
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 22056 "asllib/Parser0.ml"
                 in
                
# 441 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 22068 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 22077 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 22083 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22089 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22186 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 22195 "asllib/Parser0.ml"
                  
                in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 22201 "asllib/Parser0.ml"
                 in
                
# 441 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 22213 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 22222 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 22228 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22234 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 22302 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 22308 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 22320 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 22326 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22331 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22340 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 22348 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22354 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 22429 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 22435 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 22447 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 22453 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22458 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22467 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 22475 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22481 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 22556 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 22562 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 22574 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 22582 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22591 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 22599 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22605 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 22687 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 22693 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 22705 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 22713 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22722 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 22730 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22736 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 22792 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 22804 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 22810 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22815 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 22824 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22830 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 22893 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 22905 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 22911 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22916 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 22925 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22931 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 22994 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23006 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23014 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 23023 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23029 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 23099 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23111 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23119 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 23128 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23134 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23198 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 23204 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23209 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 322 "asllib/Parser0.mly"
              ( "record" )
# 23217 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 23225 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23231 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23302 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 23308 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23313 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 322 "asllib/Parser0.mly"
              ( "record" )
# 23321 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 23329 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23335 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23406 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23414 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 322 "asllib/Parser0.mly"
              ( "record" )
# 23422 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 23430 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23436 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23514 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23522 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 322 "asllib/Parser0.mly"
              ( "record" )
# 23530 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 23538 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23544 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = q;
                                MenhirLib.EngineTypes.startp = _startpos_q_;
                                MenhirLib.EngineTypes.endp = _endpos_q_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 23637 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 23645 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 23651 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23667 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args = _1_inlined1 in
                let name =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23677 "asllib/Parser0.ml"
                  
                in
                
# 458 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 23691 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 23700 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 23706 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23712 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 23793 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 23801 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23817 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args = _1_inlined1 in
                let name = _1 in
                
# 458 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 23834 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 23843 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 23849 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23855 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 23936 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23956 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args = _1_inlined1 in
                let name = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 23964 "asllib/Parser0.ml"
                 in
                
# 458 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type }
      )
# 23977 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 23986 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 23992 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23998 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24070 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24078 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 24084 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 24095 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 = _1_inlined1 in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24105 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 24113 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24119 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24198 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24206 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 24212 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 24223 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 = _1_inlined1 in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24233 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 24241 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24247 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24307 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24315 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 24326 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 = _1_inlined1 in
              _7
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 24335 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24341 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24408 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24416 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 24427 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 = _1_inlined1 in
              _7
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 24436 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24442 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24502 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 24517 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 = _1_inlined1 in
              let _1 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 24524 "asllib/Parser0.ml"
               in
              _7
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 24531 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24537 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24604 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 24619 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 = _1_inlined1 in
              let _1 = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 24626 "asllib/Parser0.ml"
               in
              _7
            in
            
# 237 "asllib/Parser0.mly"
                                ( None )
# 24633 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24639 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24702 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let x = _1_inlined1 in
                  
# 246 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 24721 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 24727 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 24736 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 24742 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24748 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24823 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 24829 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 263 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 24851 "asllib/Parser0.ml"
                    
                  in
                  
# 246 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 24857 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 24863 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 24872 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 24878 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24884 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 24954 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 24976 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 24985 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 248 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 24992 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 24998 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25007 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 25013 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25019 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 25101 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 25107 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 25130 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25139 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 263 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 25148 "asllib/Parser0.ml"
                    
                  in
                  
# 248 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 25154 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 25160 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25169 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 25175 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25181 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 25251 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 25271 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25279 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 250 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 25286 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 25292 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25301 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 25307 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25313 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 25395 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 25401 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 25422 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25430 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 263 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 25439 "asllib/Parser0.ml"
                    
                  in
                  
# 250 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 25445 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 25451 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25460 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 25466 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25472 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 25521 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 25543 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25552 "asllib/Parser0.ml"
                    
                  in
                  let t = _1_inlined1 in
                  
# 253 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 25559 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 25565 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25574 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 25580 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25586 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 25647 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 25653 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 25676 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25685 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 263 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 25694 "asllib/Parser0.ml"
                    
                  in
                  
# 253 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 25700 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 25706 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25715 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 25721 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25727 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 25797 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 25812 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25820 "asllib/Parser0.ml"
                  
                in
                let x = _1_inlined1 in
                
# 257 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 25827 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25836 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 25842 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25848 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 25930 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 25936 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 25951 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25959 "asllib/Parser0.ml"
                  
                in
                let x =
                  let _1 = _1_inlined1 in
                  let i = _1 in
                  
# 263 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 25968 "asllib/Parser0.ml"
                  
                in
                
# 257 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 25974 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 25983 "asllib/Parser0.ml"
              
            in
            
# 208 "asllib/Parser0.mly"
                      Some  
# 25989 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25995 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.expr) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 26014 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = c;
                MenhirLib.EngineTypes.startp = _startpos_c_;
                MenhirLib.EngineTypes.endp = _endpos_c_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic xs in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = (c, e) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26073 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26079 "asllib/Parser0.ml"
           : ((AST.expr * AST.expr) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 26098 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 26179 "asllib/Parser0.ml"
                 _3_1
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26190 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26196 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26303 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 26310 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26319 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 26325 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26334 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26342 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 26348 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26357 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26368 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26374 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26500 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 26506 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 26514 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26523 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 26529 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26538 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26546 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 26552 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26561 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26572 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26578 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26646 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 26652 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26663 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26669 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 26728 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26739 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26745 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 26764 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26823 "asllib/Parser0.ml"
                 _1_1
              in
              (expr, simple_stmt_list)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26834 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26840 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.stmt list) = 
# 216 "<standard.mly>"
    ( [] )
# 26859 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26941 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 26948 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26957 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 26963 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26972 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 26980 "asllib/Parser0.ml"
                 _1_1
              in
              
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 26986 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 26995 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27001 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27103 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 27109 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 27117 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27126 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 27132 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 27141 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27149 "asllib/Parser0.ml"
                 _1_1
              in
              
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 27155 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 27164 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27170 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27214 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 27220 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27226 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 27313 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 27320 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 27330 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 27336 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 27345 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27351 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 27479 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 27485 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 27493 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 27503 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 27509 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 27518 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27524 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 27677 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 27684 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27693 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 27699 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 27708 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27716 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 27722 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 27731 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 27737 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 27745 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 27755 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 27761 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 27770 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27776 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27948 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 27954 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 27962 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27971 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 27977 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 27986 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 27994 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 28000 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28009 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 28015 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 28023 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 28033 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 28039 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28048 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28054 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 28168 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 28174 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 28180 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 28188 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 28198 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 28204 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28213 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28219 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 28324 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 28330 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 28338 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 28348 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 28354 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28363 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28369 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28477 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 28484 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28498 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 28505 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 28514 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 28520 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28529 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 28537 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 28543 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28552 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 28558 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28567 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28573 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 28722 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 28728 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 28736 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28750 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 28757 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 28766 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 28772 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28781 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 28789 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 28795 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28804 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 28810 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 28819 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28825 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28999 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29006 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29015 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29021 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29030 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29038 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29044 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29053 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 29059 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 29067 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 29081 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29088 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29097 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29103 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29112 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29120 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29126 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29135 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 29141 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29150 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29156 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29349 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 29355 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29363 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29372 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29378 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29387 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29395 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29401 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29410 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 29416 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 29424 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 29438 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29445 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29454 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29460 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29469 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29477 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29483 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29492 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 29498 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29507 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29513 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29648 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 29654 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 29660 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 29668 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 29682 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29689 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29698 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29704 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29713 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29721 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29727 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29736 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 29742 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29751 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29757 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 29883 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 29889 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 29897 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 29911 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29918 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29927 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29933 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29942 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29950 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29956 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29965 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 29971 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 29980 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29986 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 30108 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30115 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30134 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 30140 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30148 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30157 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30163 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30172 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30180 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30186 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30195 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30201 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30210 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30216 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30379 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30385 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30393 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30412 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 30418 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30426 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30435 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30441 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30450 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30458 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30464 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30473 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30479 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30488 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30494 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 30682 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30689 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30698 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30704 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30713 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30721 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30727 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30736 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30742 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30750 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30769 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 30775 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30783 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30792 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30798 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30807 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30815 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30821 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30830 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30836 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 30845 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30851 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31058 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 31064 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31072 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31081 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31087 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31096 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31104 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31110 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31119 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31125 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31133 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31152 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 31158 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31166 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31175 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31181 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31190 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31198 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31204 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31213 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31219 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31228 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31234 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31383 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 31389 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31395 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31403 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31422 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 31428 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31436 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31445 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31451 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31460 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31468 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31474 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31483 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31489 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31498 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31504 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 31644 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31650 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31658 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31677 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 31683 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31691 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31700 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31706 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31715 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31723 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31729 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31738 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31744 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31753 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31759 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31832 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31839 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31849 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 31855 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31861 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 31870 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31876 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31990 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31996 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32004 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32014 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 32020 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32026 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32035 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32041 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32180 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32187 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32196 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32202 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32211 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32219 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32225 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32234 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32240 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32248 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32258 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 32264 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32270 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32279 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32285 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32443 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 32449 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32457 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32466 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32472 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32481 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32489 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32495 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32504 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32510 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32518 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32528 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 32534 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32540 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32549 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32555 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32655 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 32661 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32667 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32675 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32685 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 32691 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32697 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32706 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32712 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 32803 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32809 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32817 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32827 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 32833 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32839 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32848 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32854 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32920 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32927 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 32935 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32941 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 32950 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32956 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 33063 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33069 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33077 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 33085 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33091 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33100 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33106 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33238 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33245 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33254 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33260 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33269 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33277 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33283 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33292 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33298 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33306 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 33314 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33320 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33329 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33335 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33486 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 33492 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33500 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33509 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33515 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33524 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33532 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33538 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33547 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33553 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33561 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 33569 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33575 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33584 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33590 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33683 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 33689 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33695 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33703 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 33711 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33717 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33726 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33732 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 33816 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33822 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33830 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 33838 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33844 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33853 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33859 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33951 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 208 "asllib/Parser0.mly"
                      Some  
# 33957 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 592 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33965 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33974 "asllib/Parser0.ml"
                 _1_1
              in
              
# 607 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33980 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 33989 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33995 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 608 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 34074 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 34083 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34089 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = e2;
                    MenhirLib.EngineTypes.startp = _startpos_e2_;
                    MenhirLib.EngineTypes.endp = _endpos_e2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = e1;
                        MenhirLib.EngineTypes.startp = _startpos_e1_;
                        MenhirLib.EngineTypes.endp = _endpos_e1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 34180 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34196 "asllib/Parser0.ml"
                 _3_1
              in
              let direction =
                let _1 = _1_inlined2 in
                
# 653 "asllib/Parser0.mly"
                       ( AST.Up )
# 34204 "asllib/Parser0.ml"
                
              in
              let ident = _1_inlined1 in
              
# 649 "asllib/Parser0.mly"
                                                                        AST.S_For 
# 34211 "asllib/Parser0.ml"
               (ident, e1, direction, e2, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 34220 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34226 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = e2;
                    MenhirLib.EngineTypes.startp = _startpos_e2_;
                    MenhirLib.EngineTypes.endp = _endpos_e2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = e1;
                        MenhirLib.EngineTypes.startp = _startpos_e1_;
                        MenhirLib.EngineTypes.endp = _endpos_e1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 34317 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34333 "asllib/Parser0.ml"
                 _3_1
              in
              let direction =
                let _1 = _1_inlined2 in
                
# 653 "asllib/Parser0.mly"
                                            ( AST.Down )
# 34341 "asllib/Parser0.ml"
                
              in
              let ident = _1_inlined1 in
              
# 649 "asllib/Parser0.mly"
                                                                        AST.S_For 
# 34348 "asllib/Parser0.ml"
               (ident, e1, direction, e2, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 34357 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34363 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34445 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                          AST.S_While 
# 34451 "asllib/Parser0.ml"
               (expr, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 34460 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34466 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _5;
              MenhirLib.EngineTypes.startp = _startpos__5_;
              MenhirLib.EngineTypes.endp = _endpos__5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34562 "asllib/Parser0.ml"
                 _3_1
              in
              
# 651 "asllib/Parser0.mly"
                                                              AST.S_Repeat 
# 34568 "asllib/Parser0.ml"
               (indented_block, expr)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 34577 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34583 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 34676 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 34695 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34706 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 34716 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 34725 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34731 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 34859 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34885 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 34894 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 34900 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34912 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 34922 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 34931 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34937 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 35086 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 35116 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35123 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35132 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35138 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35147 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35155 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35161 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35170 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35179 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 35185 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 35197 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 35207 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35216 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35222 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 35385 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35420 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 35426 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35434 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35443 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35449 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35458 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35466 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35472 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35481 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35490 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 35496 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 35508 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 35518 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35527 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35533 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 35647 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35673 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 35679 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35688 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 35694 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 35706 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 35716 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35725 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35731 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 35838 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35862 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35871 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 35877 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 35889 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 35899 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 35908 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35914 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.typed_identifier list) = 
# 145 "<standard.mly>"
    ( [] )
# 35933 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let x =
            let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 35967 "asllib/Parser0.ml"
             in
            
# 205 "<standard.mly>"
    ( x )
# 35972 "asllib/Parser0.ml"
            
          in
          (
# 148 "<standard.mly>"
    ( x )
# 35978 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.typed_identifier list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let x =
            let x = _1_inlined1 in
            
# 205 "<standard.mly>"
    ( x )
# 36021 "asllib/Parser0.ml"
            
          in
          (
# 148 "<standard.mly>"
    ( x )
# 36027 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.bitfield list) = 
# 145 "<standard.mly>"
    ( [] )
# 36046 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.bitfield list) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.bitfield list) = 
# 148 "<standard.mly>"
    ( x )
# 36071 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 36137 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 36145 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36189 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 36197 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 36271 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 36279 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36330 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 36338 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 36373 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 266 "asllib/Parser0.mly"
                               ( (x, t) )
# 36386 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 36392 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 36398 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.field list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 36440 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 266 "asllib/Parser0.mly"
                               ( (x, t) )
# 36453 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 36459 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 36465 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = le;
                MenhirLib.EngineTypes.startp = _startpos_le_;
                MenhirLib.EngineTypes.endp = _endpos_le_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 545 "asllib/Parser0.mly"
                              ( AST.S_Assign (le,e,V0) )
# 36517 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 36523 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36532 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 36538 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 36587 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 36604 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36612 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 36618 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 36624 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 36630 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36639 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 36645 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 36707 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 36714 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36722 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 36728 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 36734 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 36740 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36749 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 36755 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 36804 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 36821 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36829 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 36835 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 36841 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 36847 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36856 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 36862 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 36924 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 36931 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36939 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 36945 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 36951 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 36957 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 36966 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 36972 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37021 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 37038 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37046 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 37052 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 37058 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 37064 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37073 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 37079 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 37141 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 37148 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37156 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 37162 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 37168 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 37174 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37183 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 37189 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37238 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37243 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 37261 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37270 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 37276 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 37282 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 37288 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37297 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 37303 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37353 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 37369 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 37378 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37387 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 37393 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 37399 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 37405 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37414 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 37420 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37481 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37486 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 37492 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 37512 "asllib/Parser0.ml"
                        
                      in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 37518 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37527 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 37533 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 37539 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 37545 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37554 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 37560 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37622 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 37628 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 37645 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 37655 "asllib/Parser0.ml"
                        
                      in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 37661 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37670 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 37676 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 37682 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 37688 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37697 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 37703 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37752 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 37769 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37777 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 37783 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 37789 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 37795 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37804 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 37810 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 37872 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 37879 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37887 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 37893 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 37899 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 37905 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 37914 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 37920 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 37987 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 38009 "asllib/Parser0.ml"
                       in
                      
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 38014 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38023 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 38029 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 38035 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 38041 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38050 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 38056 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 38139 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 38148 "asllib/Parser0.ml"
                       in
                      
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 38153 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38162 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 38168 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 38174 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 38180 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38189 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 38195 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (
# 59 "asllib/Parser0.mly"
       (string)
# 38280 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 38308 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 38314 "asllib/Parser0.ml"
                       in
                      
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 38319 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38328 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 38334 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 38340 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 38346 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38355 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 38361 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined4 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 38465 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 38477 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 38483 "asllib/Parser0.ml"
                       in
                      
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 38488 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38497 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 38503 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 38509 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 38515 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38524 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 38530 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 38597 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 38620 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 38627 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38636 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 38642 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 38648 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 38654 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38663 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 38669 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 38752 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 38762 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 38769 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38778 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 38784 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 38790 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 38796 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38805 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 38811 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 38890 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 38898 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 38924 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 38932 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38941 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 38947 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 38953 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 38959 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 38968 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 38974 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 39057 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 39075 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 39090 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 39098 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39107 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39113 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 39119 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39125 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39134 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39140 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 39231 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 39239 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 39245 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 39272 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 39280 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 39288 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39297 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39303 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 39309 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39315 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39324 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39330 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 39425 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 39431 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 39450 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 39465 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 39473 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 39481 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39490 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39496 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 39502 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39508 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39517 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39523 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 39614 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 39647 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 39655 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39664 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39670 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 39676 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39682 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39691 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39697 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 39809 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 39824 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 39832 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39841 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39847 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 39853 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39859 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39868 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39874 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 39929 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 39947 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39955 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39961 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 39967 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39973 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 39982 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39988 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 40057 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 40064 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40072 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40078 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 40084 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40090 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40099 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40105 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 40160 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 40178 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40186 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40192 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 40198 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40204 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40213 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40219 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 40288 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 40295 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40303 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40309 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 40315 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40321 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40330 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40336 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 40391 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 40409 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40417 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40423 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 40429 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40435 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40444 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40450 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 40519 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 40526 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40534 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40540 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 40546 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40552 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40561 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40567 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 40622 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 40627 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 40646 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40655 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40661 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 40667 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40673 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40682 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40688 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 40744 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 40761 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 40770 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40779 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40785 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 40791 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40797 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40806 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40812 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 40879 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 40884 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 40890 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 40911 "asllib/Parser0.ml"
                        
                      in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 40917 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40926 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40932 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 40938 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40944 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 40953 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40959 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 41027 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 41033 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 41051 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 41061 "asllib/Parser0.ml"
                        
                      in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 41067 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41076 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41082 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 41088 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41094 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41103 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41109 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 41164 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 41182 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41190 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41196 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 41202 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41208 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41217 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41223 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 41292 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 41299 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41307 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41313 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 41319 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41325 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41334 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41340 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 41413 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41436 "asllib/Parser0.ml"
                       in
                      
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 41441 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41450 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41456 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 41462 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41468 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41477 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41483 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 41573 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41582 "asllib/Parser0.ml"
                       in
                      
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 41587 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41596 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41602 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 41608 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41614 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41623 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41629 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : (
# 59 "asllib/Parser0.mly"
       (string)
# 41720 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 41749 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41755 "asllib/Parser0.ml"
                       in
                      
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 41760 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41769 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41775 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 41781 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41787 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41796 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41802 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined4 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 41913 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 41925 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41931 "asllib/Parser0.ml"
                       in
                      
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 41936 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41945 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41951 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 41957 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41963 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 41972 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41978 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 42051 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 42075 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42082 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42091 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42097 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 42103 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42109 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42118 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42124 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 42214 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 42224 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42231 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42240 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42246 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 42252 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42258 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42267 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42273 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 59 "asllib/Parser0.mly"
       (string)
# 42358 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 42366 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42393 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42401 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42410 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42416 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 42422 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42428 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42437 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42443 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 42532 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 42551 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42566 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42574 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42583 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42589 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 42595 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42601 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42610 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42616 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 59 "asllib/Parser0.mly"
       (string)
# 42713 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 42721 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 42727 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 42755 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42763 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42771 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42780 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42786 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 42792 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42798 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42807 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42813 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 42914 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 42920 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 42940 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 42955 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42963 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42971 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 42980 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42986 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 42992 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42998 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43007 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43013 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 59 "asllib/Parser0.mly"
       (string)
# 43110 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 43144 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43152 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43161 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43167 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43173 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43179 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43188 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43194 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 43313 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 43328 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43336 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43345 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43351 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43357 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43363 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43372 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43378 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 43427 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 551 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some expr)) )
# 43441 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43447 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43456 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43462 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = h;
                      MenhirLib.EngineTypes.startp = _startpos_h_;
                      MenhirLib.EngineTypes.endp = _endpos_h_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.local_decl_item list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let _1_inlined1 = _1_inlined2 in
                  let ldis =
                    let x =
                      let _1 = _1_inlined1 in
                      let t = _1 in
                      
# 274 "asllib/Parser0.mly"
                                           ( h::t )
# 43555 "asllib/Parser0.ml"
                      
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 43561 "asllib/Parser0.ml"
                    
                  in
                  
# 584 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 43567 "asllib/Parser0.ml"
                  
                in
                
# 553 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, ldi, Some e) )
# 43573 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43579 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43588 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43594 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 43640 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43648 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 43654 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 43660 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43669 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43675 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 43721 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43729 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 43735 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 43741 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43750 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43756 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 43802 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43810 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 43816 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 43822 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43831 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43837 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 43873 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 43889 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43898 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 43904 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 43910 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 43919 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43925 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 43973 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 43979 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 43997 "asllib/Parser0.ml"
                      
                    in
                    
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 44003 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44012 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 44018 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 44024 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44033 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44039 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 44085 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44093 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 44099 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 44105 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44114 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44120 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 44188 "asllib/Parser0.ml"
                     in
                    
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 44193 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44202 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 44208 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 44214 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44223 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44229 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 44321 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 44327 "asllib/Parser0.ml"
                     in
                    
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 44332 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44341 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 44347 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 44353 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44362 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44368 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 44437 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 44444 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44453 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 44459 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 44465 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44474 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44480 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 44549 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 44573 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 44581 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44590 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 44596 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 44602 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44611 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44617 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 44698 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 44704 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 44729 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 44737 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 44745 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44754 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 44760 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 44766 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44775 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44781 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 44885 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 44893 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44902 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 44908 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 44914 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 44923 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44929 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 44984 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 44990 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 45002 "asllib/Parser0.ml"
                 in
                let _2 =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 45008 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 45013 "asllib/Parser0.ml"
                  
                in
                let qualident =
                  let _2 = _2_inlined1 in
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 45022 "asllib/Parser0.ml"
                  
                in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 45029 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 45035 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45044 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45050 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 45112 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 45118 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 45130 "asllib/Parser0.ml"
                 in
                let _2 =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 45138 "asllib/Parser0.ml"
                  
                in
                let qualident =
                  let _2 = _2_inlined1 in
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 45147 "asllib/Parser0.ml"
                  
                in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 45154 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 45160 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45169 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45175 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 45218 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 45230 "asllib/Parser0.ml"
                 in
                let _2 =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 45236 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 45241 "asllib/Parser0.ml"
                  
                in
                let qualident = _1 in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 45249 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 45255 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45264 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45270 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 45320 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 45332 "asllib/Parser0.ml"
                 in
                let _2 =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 45340 "asllib/Parser0.ml"
                  
                in
                let qualident = _1 in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 45348 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 45354 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45363 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45369 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 45420 "asllib/Parser0.ml"
                 in
                let _2 =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 45426 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 45431 "asllib/Parser0.ml"
                  
                in
                let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 45437 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 45443 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 45449 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45458 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45464 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 45522 "asllib/Parser0.ml"
                 in
                let _2 =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 45530 "asllib/Parser0.ml"
                  
                in
                let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 45536 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 45542 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 45548 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45557 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45563 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 45600 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 525 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 45606 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 45612 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45621 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45627 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 45671 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 525 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 45677 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 45683 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45692 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45698 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 526 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 45741 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 45746 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45755 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45761 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 527 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; debug = true } )
# 45804 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 45809 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45818 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45824 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 45862 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 45869 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45875 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45884 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45890 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 45945 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 45951 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 45959 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45965 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 45974 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45980 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46018 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46024 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46033 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46039 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 46087 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 46105 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46113 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46119 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46128 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46134 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 46172 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46179 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46185 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46194 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46200 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 46255 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 46261 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46269 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46275 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46284 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46290 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 46328 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46335 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46341 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46350 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46356 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 46391 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 46405 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46412 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46418 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46427 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46433 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 46492 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46499 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46505 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46514 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46520 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 46555 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46570 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46576 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46585 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46591 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 46626 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46643 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46649 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46658 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46664 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 46699 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 46716 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46722 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46731 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46737 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = le;
                  MenhirLib.EngineTypes.startp = _startpos_le_;
                  MenhirLib.EngineTypes.endp = _endpos_le_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 545 "asllib/Parser0.mly"
                              ( AST.S_Assign (le,e,V0) )
# 46796 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46802 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46811 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 46817 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 46873 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 46890 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46898 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46904 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 46910 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46916 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 46925 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 46931 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 47000 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 47007 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47015 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 47021 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 47027 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47033 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47042 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 47048 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 47104 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 47121 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47129 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 47135 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 47141 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47147 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47156 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 47162 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 47231 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 47238 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47246 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 47252 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 47258 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47264 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47273 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 47279 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 47335 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 47352 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47360 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 47366 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 47372 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47378 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47387 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 47393 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 47462 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 47469 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47477 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 47483 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 47489 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47495 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47504 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 47510 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 47566 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 47571 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 47589 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47598 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 47604 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 47610 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47616 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47625 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 47631 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 47688 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 47704 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 47713 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47722 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 47728 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 47734 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47740 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47749 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 47755 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 47823 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 47828 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 47834 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 47854 "asllib/Parser0.ml"
                        
                      in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 47860 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47869 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 47875 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 47881 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47887 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 47896 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 47902 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 47971 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 47977 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 47994 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 48004 "asllib/Parser0.ml"
                        
                      in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 48010 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48019 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 48025 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 48031 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48037 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48046 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 48052 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 48108 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 48125 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48133 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 48139 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 48145 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48151 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48160 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 48166 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 48235 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 48242 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48250 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 48256 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 48262 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48268 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48277 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 48283 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 48357 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 48379 "asllib/Parser0.ml"
                       in
                      
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 48384 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48393 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 48399 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 48405 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48411 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48420 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 48426 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 48516 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 48525 "asllib/Parser0.ml"
                       in
                      
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 48530 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48539 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 48545 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 48551 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48557 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48566 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 48572 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (
# 59 "asllib/Parser0.mly"
       (string)
# 48664 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 48692 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 48698 "asllib/Parser0.ml"
                       in
                      
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 48703 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48712 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 48718 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 48724 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48730 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48739 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 48745 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined4 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 48856 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 48868 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 48874 "asllib/Parser0.ml"
                       in
                      
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 48879 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48888 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 48894 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 48900 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48906 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 48915 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 48921 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 48995 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 49018 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49025 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49034 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 49040 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 49046 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49052 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49061 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 49067 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 49157 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 49167 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49174 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49183 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 49189 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 49195 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49201 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49210 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 49216 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 49302 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 49310 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 49336 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49344 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49353 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 49359 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 49365 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49371 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49380 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 49386 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 49476 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 49494 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 49509 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49517 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49526 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 49532 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 49538 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49544 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49553 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 49559 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 49657 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 49665 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 49671 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 49698 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 49706 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49714 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49723 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 49729 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 49735 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49741 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49750 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 49756 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 49858 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 49864 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 49883 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 49898 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 49906 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49914 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49923 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 49929 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 49935 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49941 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 49950 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 49956 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 50054 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 50087 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 50095 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50104 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50110 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50116 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50122 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50131 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50137 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 50256 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 50271 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 50279 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50288 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50294 "asllib/Parser0.ml"
                  
                in
                
# 547 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50300 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50306 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50315 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50321 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 50383 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 50401 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50409 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50415 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 50421 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50427 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50436 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50442 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 50518 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 50525 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50533 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50539 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 50545 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50551 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50560 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50566 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 50628 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 50646 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50654 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50660 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 50666 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50672 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50681 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50687 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 50763 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 50770 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50778 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50784 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 50790 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50796 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50805 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50811 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 50873 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 50891 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50899 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50905 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 50911 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50917 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 50926 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50932 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 51008 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 51015 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51023 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51029 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 51035 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51041 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51050 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51056 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 51118 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 51123 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 51142 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51151 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51157 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 51163 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51169 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51178 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51184 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 51247 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 51264 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 51273 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51282 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51288 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 51294 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51300 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51309 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51315 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 51389 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 51394 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 51400 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 51421 "asllib/Parser0.ml"
                        
                      in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 51427 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51436 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51442 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 51448 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51454 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51463 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51469 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 51544 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 51550 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 51568 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 51578 "asllib/Parser0.ml"
                        
                      in
                      
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 51584 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51593 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51599 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 51605 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51611 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51620 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51626 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 51688 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 51706 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51714 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51720 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 51726 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51732 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51741 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51747 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 51823 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 51830 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51838 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51844 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 51850 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51856 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51865 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51871 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 51951 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 51974 "asllib/Parser0.ml"
                       in
                      
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 51979 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 51988 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51994 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 52000 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52006 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52015 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52021 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 52118 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 52127 "asllib/Parser0.ml"
                       in
                      
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 52132 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52141 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52147 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 52153 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52159 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52168 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52174 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : (
# 59 "asllib/Parser0.mly"
       (string)
# 52272 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 52301 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 52307 "asllib/Parser0.ml"
                       in
                      
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 52312 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52321 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52327 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 52333 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52339 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52348 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52354 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined4 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 52472 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 52484 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 52490 "asllib/Parser0.ml"
                       in
                      
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 52495 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52504 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52510 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 52516 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52522 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52531 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52537 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 52617 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 52641 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52648 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52657 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52663 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 52669 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52675 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52684 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52690 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 52787 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 52797 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52804 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52813 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52819 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 52825 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52831 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52840 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52846 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 59 "asllib/Parser0.mly"
       (string)
# 52938 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 52946 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 52973 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52981 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 52990 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52996 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53002 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53008 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53017 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53023 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 53119 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 53138 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53153 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53161 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53170 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53176 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53182 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53188 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53197 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53203 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 59 "asllib/Parser0.mly"
       (string)
# 53307 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 53315 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 53321 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 53349 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53357 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53365 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53374 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53380 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53386 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53392 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53401 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53407 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 53515 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 53521 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 53541 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 53556 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53564 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53572 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53581 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53587 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53593 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53599 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53608 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53614 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 59 "asllib/Parser0.mly"
       (string)
# 53718 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53752 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53760 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53769 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53775 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53781 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53787 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53796 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53802 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 317 "asllib/Parser0.mly"
                                         ( "record" )
# 53928 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53943 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53951 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53960 "asllib/Parser0.ml"
                    
                  in
                  
# 562 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53966 "asllib/Parser0.ml"
                  
                in
                
# 549 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53972 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53978 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 53987 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53993 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 54049 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 551 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some expr)) )
# 54063 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54069 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54078 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54084 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = h;
                        MenhirLib.EngineTypes.startp = _startpos_h_;
                        MenhirLib.EngineTypes.endp = _endpos_h_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.local_decl_item list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let _1_inlined1 = _1_inlined2 in
                  let ldis =
                    let x =
                      let _1 = _1_inlined1 in
                      let t = _1 in
                      
# 274 "asllib/Parser0.mly"
                                           ( h::t )
# 54184 "asllib/Parser0.ml"
                      
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 54190 "asllib/Parser0.ml"
                    
                  in
                  
# 584 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 54196 "asllib/Parser0.ml"
                  
                in
                
# 553 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, ldi, Some e) )
# 54202 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54208 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54217 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54223 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 54276 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54284 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 54290 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 54296 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54305 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54311 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 54364 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54372 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 54378 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 54384 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54393 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54399 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 54452 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54460 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 54466 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 54472 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54481 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54487 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 54530 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 54546 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54555 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 54561 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 54567 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54576 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54582 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 54637 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 54643 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 54661 "asllib/Parser0.ml"
                      
                    in
                    
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 54667 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54676 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 54682 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 54688 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54697 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54703 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 54756 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54764 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 54770 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 54776 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54785 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54791 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 54866 "asllib/Parser0.ml"
                     in
                    
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 54871 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54880 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 54886 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 54892 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 54901 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54907 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 55006 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 55012 "asllib/Parser0.ml"
                     in
                    
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 55017 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55026 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 55032 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 55038 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55047 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55053 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 55129 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55136 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55145 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 55151 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 55157 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55166 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55172 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 55248 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 55272 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55280 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55289 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 55295 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 55301 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55310 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55316 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 55404 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 55410 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 55435 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 55443 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55451 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55460 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 55466 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 55472 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55481 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55487 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 55598 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55606 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55615 "asllib/Parser0.ml"
                  
                in
                
# 554 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 55621 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 55627 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55636 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55642 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 55704 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 55710 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 55722 "asllib/Parser0.ml"
                 in
                let _2 =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 55728 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 55733 "asllib/Parser0.ml"
                  
                in
                let qualident =
                  let _2 = _2_inlined1 in
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 55742 "asllib/Parser0.ml"
                  
                in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 55749 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 55755 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55764 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55770 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 55839 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 55845 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 55857 "asllib/Parser0.ml"
                 in
                let _2 =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 55865 "asllib/Parser0.ml"
                  
                in
                let qualident =
                  let _2 = _2_inlined1 in
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 55874 "asllib/Parser0.ml"
                  
                in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 55881 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 55887 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55896 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55902 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 55952 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 55964 "asllib/Parser0.ml"
                 in
                let _2 =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 55970 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 55975 "asllib/Parser0.ml"
                  
                in
                let qualident = _1 in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 55983 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 55989 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 55998 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56004 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 56061 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 56073 "asllib/Parser0.ml"
                 in
                let _2 =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 56081 "asllib/Parser0.ml"
                  
                in
                let qualident = _1 in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 56089 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 56095 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56104 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56110 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 56168 "asllib/Parser0.ml"
                 in
                let _2 =
                  let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 56174 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 56179 "asllib/Parser0.ml"
                  
                in
                let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 56185 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 56191 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 56197 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56206 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56212 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 56277 "asllib/Parser0.ml"
                 in
                let _2 =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 56285 "asllib/Parser0.ml"
                  
                in
                let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 56291 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 524 "asllib/Parser0.mly"
                                                    AST.S_Call  
# 56297 "asllib/Parser0.ml"
                 (qualident, _2_1, nargs)
              in
              
# 196 "<standard.mly>"
    ( x )
# 56303 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56312 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56318 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 56362 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 525 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 56368 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 56374 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56383 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56389 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 56440 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 525 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 56446 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 56452 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56461 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56467 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 526 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 56517 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 56522 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56531 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56537 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 527 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; debug = true } )
# 56587 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 56592 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56601 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56607 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 56652 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 56659 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56665 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56674 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56680 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 56742 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 56748 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 56756 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56762 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56771 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56777 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 56822 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56828 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56837 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56843 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 56898 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 56916 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 56924 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56930 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 56939 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56945 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 56990 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 56997 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57003 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57012 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57018 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 57080 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 57086 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 57094 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57100 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57109 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57115 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 57160 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 57167 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57173 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57182 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57188 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 57230 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 57244 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 57251 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57257 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57266 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57272 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 57338 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 57345 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57351 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57360 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57366 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 57408 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 57423 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57429 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57438 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57444 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 57486 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 57503 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57509 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57518 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57524 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 57566 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 57583 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57589 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57598 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57604 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 57680 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 57687 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 57696 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 57702 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57711 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 57719 "asllib/Parser0.ml"
                 _1_1
              in
              
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 57725 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57734 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 57740 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 57835 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 57841 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 57849 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 57858 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 57864 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57873 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 57881 "asllib/Parser0.ml"
                 _1_1
              in
              
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 57887 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 57896 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 57902 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 57939 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 57945 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 57951 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined3;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined3_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 58031 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 58038 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 58048 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 58054 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58063 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 58069 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 58190 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 58196 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 58204 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 58214 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 58220 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58229 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 58235 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4;
                            MenhirLib.EngineTypes.startp = _startpos__4_;
                            MenhirLib.EngineTypes.endp = _endpos__4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 58381 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 58388 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 58397 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 58403 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58412 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 58420 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 58426 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58435 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 58441 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 58449 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 58459 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 58465 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58474 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 58480 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4;
                                MenhirLib.EngineTypes.startp = _startpos__4_;
                                MenhirLib.EngineTypes.endp = _endpos__4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 58645 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 58651 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 58659 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 58668 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 58674 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58683 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 58691 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 58697 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58706 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 58712 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 58720 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 58730 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 58736 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58745 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 58751 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 58858 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 58864 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 58870 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 58878 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 58888 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 58894 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 58903 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 58909 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 59007 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 59013 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 59021 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 59031 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 59037 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59046 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 59052 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 59153 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 59160 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 59174 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 59181 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 59190 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 59196 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59205 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 59213 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 59219 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59228 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 59234 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59243 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 59249 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 59391 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 59397 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 59405 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 59419 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 59426 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 59435 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 59441 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59450 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 59458 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 59464 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59473 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 59479 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59488 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 59494 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 59661 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 59668 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 59677 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 59683 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59692 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 59700 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 59706 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59715 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 59721 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 59729 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 59743 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 59750 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 59759 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 59765 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59774 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 59782 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 59788 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59797 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 59803 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 59812 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 59818 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60004 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 60010 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 60018 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60027 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 60033 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60042 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60050 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 60056 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60065 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 60071 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 60079 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60093 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 60100 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60109 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 60115 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60124 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60132 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 60138 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60147 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 60153 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60162 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 60168 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60296 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 60302 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 60308 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 60316 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60330 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 60337 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60346 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 60352 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60361 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60369 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 60375 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60384 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 60390 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60399 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 60405 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 60524 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 60530 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 60538 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60552 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 60559 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60568 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 60574 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60583 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60591 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 60597 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60606 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 60612 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60621 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 60627 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60742 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 60749 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60768 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 60774 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 60782 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60791 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 60797 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60806 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60814 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 60820 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60829 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 60835 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 60844 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 60850 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61006 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61012 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61020 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61039 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 61045 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61053 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61062 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61068 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61077 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61085 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61091 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61100 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61106 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61115 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61121 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined10;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined9;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 61302 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61309 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61318 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61324 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61333 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61341 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61347 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61356 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61362 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61370 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61389 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 61395 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61403 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61412 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61418 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61427 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61435 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61441 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61450 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61456 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61465 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61471 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined14;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined13;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined12;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined11;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined10;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined9;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined8;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined7;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined6;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined5;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined4;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _3;
                                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = expr;
                                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _menhir_s;
                                                      MenhirLib.EngineTypes.semv = _1;
                                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61671 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 61677 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61685 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61694 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61700 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61709 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61717 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61723 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61732 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61738 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61746 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61765 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 61771 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61779 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61788 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61794 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61803 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61811 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61817 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61826 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61832 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 61841 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61847 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61989 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 61995 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62001 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62009 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62028 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 62034 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62042 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62051 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62057 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62066 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62074 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62080 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62089 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62095 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62104 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62110 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined9;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined9_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 62243 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62249 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62257 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62276 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 62282 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62290 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62299 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62305 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62314 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62322 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62328 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62337 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62343 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62352 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62358 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62424 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62431 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62441 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 62447 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62453 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62462 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62468 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 62575 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62581 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62589 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62599 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 62605 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62611 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62620 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62626 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62758 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62765 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62774 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62780 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62789 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62797 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62803 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62812 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62818 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62826 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62836 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 62842 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62848 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 62857 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62863 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63014 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 63020 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63028 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63037 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63043 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63052 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63060 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63066 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63075 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63081 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63089 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63099 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 63105 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63111 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63120 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63126 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63219 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 63225 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63231 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63239 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63249 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 63255 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63261 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63270 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63276 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 63360 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63366 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63374 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63384 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 63390 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63396 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63405 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63411 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63470 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63477 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 63485 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63491 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63500 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63506 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 63606 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63612 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63620 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 63628 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63634 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63643 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63649 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63774 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63781 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63790 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63796 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63805 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63813 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63819 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63828 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63834 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63842 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 63850 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63856 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 63865 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63871 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64015 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 64021 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64029 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64038 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64044 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64053 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64061 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64067 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64076 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64082 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64090 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 64098 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64104 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64113 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64119 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64205 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 64211 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64217 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64225 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 64233 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64239 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64248 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64254 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 64331 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64337 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64345 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 64353 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64359 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64368 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64374 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64459 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 208 "asllib/Parser0.mly"
                      Some  
# 64465 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 592 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64473 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64482 "asllib/Parser0.ml"
                 _1_1
              in
              
# 607 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64488 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64497 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64503 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _5;
              MenhirLib.EngineTypes.startp = _startpos__5_;
              MenhirLib.EngineTypes.endp = _endpos__5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 608 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 64575 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64584 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64590 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = e2;
                  MenhirLib.EngineTypes.startp = _startpos_e2_;
                  MenhirLib.EngineTypes.endp = _endpos_e2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = e1;
                      MenhirLib.EngineTypes.startp = _startpos_e1_;
                      MenhirLib.EngineTypes.endp = _endpos_e1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 64674 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64690 "asllib/Parser0.ml"
                 _3_1
              in
              let direction =
                let _1 = _1_inlined2 in
                
# 653 "asllib/Parser0.mly"
                       ( AST.Up )
# 64698 "asllib/Parser0.ml"
                
              in
              let ident = _1_inlined1 in
              
# 649 "asllib/Parser0.mly"
                                                                        AST.S_For 
# 64705 "asllib/Parser0.ml"
               (ident, e1, direction, e2, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64714 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64720 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = e2;
                  MenhirLib.EngineTypes.startp = _startpos_e2_;
                  MenhirLib.EngineTypes.endp = _endpos_e2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = e1;
                      MenhirLib.EngineTypes.startp = _startpos_e1_;
                      MenhirLib.EngineTypes.endp = _endpos_e1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 64804 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64820 "asllib/Parser0.ml"
                 _3_1
              in
              let direction =
                let _1 = _1_inlined2 in
                
# 653 "asllib/Parser0.mly"
                                            ( AST.Down )
# 64828 "asllib/Parser0.ml"
                
              in
              let ident = _1_inlined1 in
              
# 649 "asllib/Parser0.mly"
                                                                        AST.S_For 
# 64835 "asllib/Parser0.ml"
               (ident, e1, direction, e2, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64844 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64850 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64925 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                          AST.S_While 
# 64931 "asllib/Parser0.ml"
               (expr, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 64940 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64946 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65035 "asllib/Parser0.ml"
                 _3_1
              in
              
# 651 "asllib/Parser0.mly"
                                                              AST.S_Repeat 
# 65041 "asllib/Parser0.ml"
               (indented_block, expr)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65050 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65056 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 65142 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 65161 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65172 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 65182 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65191 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65197 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _5;
                          MenhirLib.EngineTypes.startp = _startpos__5_;
                          MenhirLib.EngineTypes.endp = _endpos__5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 65318 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65344 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65353 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 65359 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65371 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 65381 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65390 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65396 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _5;
                                MenhirLib.EngineTypes.startp = _startpos__5_;
                                MenhirLib.EngineTypes.endp = _endpos__5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _4_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _2;
                                          MenhirLib.EngineTypes.startp = _startpos__2_;
                                          MenhirLib.EngineTypes.endp = _endpos__2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 65538 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65568 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65575 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65584 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65590 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65599 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65607 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65613 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65622 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65631 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 65637 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65649 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 65659 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65668 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65674 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _5;
                                    MenhirLib.EngineTypes.startp = _startpos__5_;
                                    MenhirLib.EngineTypes.endp = _endpos__5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _4_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _2;
                                              MenhirLib.EngineTypes.startp = _startpos__2_;
                                              MenhirLib.EngineTypes.endp = _endpos__2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 65830 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65865 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 65871 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65879 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65888 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65894 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65903 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65911 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65917 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65926 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65935 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 65941 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65953 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 65963 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 65972 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65978 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 66085 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66111 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 66117 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66126 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 66132 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 66144 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 66154 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66163 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66169 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _5;
                    MenhirLib.EngineTypes.startp = _startpos__5_;
                    MenhirLib.EngineTypes.endp = _endpos__5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _4_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 66269 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66293 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66302 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 66308 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 66320 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 66330 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66339 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66345 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66428 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66435 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66444 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66450 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66459 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66467 "asllib/Parser0.ml"
                 _1_1
              in
              
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66473 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66482 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 66488 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66590 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 66596 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66604 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66613 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66619 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66628 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66636 "asllib/Parser0.ml"
                 _1_1
              in
              
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66642 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66651 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 66657 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66701 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 66707 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 66713 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66800 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66807 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 66817 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66823 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 66832 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 66838 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 66966 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66972 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66980 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 66990 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66996 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67005 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 67011 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 67164 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67171 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67180 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67186 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67195 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67203 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67209 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67218 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67224 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67232 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 67242 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67248 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67257 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 67263 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67435 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 67441 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67449 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67458 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67464 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67473 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67481 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67487 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67496 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67502 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67510 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 67520 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67526 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67535 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 67541 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67655 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 67661 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67667 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67675 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 67685 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67691 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67700 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 67706 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67811 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67817 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67825 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 67835 "asllib/Parser0.ml"
                 _3_1
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67841 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 67850 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 67856 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 67964 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67971 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 67985 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67992 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68001 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68007 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68016 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68024 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68030 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68039 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68045 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68054 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 68060 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68209 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68215 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68223 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 68237 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68244 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68253 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68259 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68268 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68276 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68282 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68291 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68297 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68306 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 68312 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 68486 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68493 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68502 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68508 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68517 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68525 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68531 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68540 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68546 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68554 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 68568 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68575 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68584 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68590 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68599 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68607 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68613 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68622 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68628 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68637 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 68643 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68836 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 68842 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68850 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68859 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68865 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68874 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68882 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68888 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68897 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68903 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68911 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 68925 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68932 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68941 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68947 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68956 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68964 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68970 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68979 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68985 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 68994 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 69000 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69135 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 69141 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69147 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69155 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69169 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69176 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69185 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69191 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69200 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69208 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69214 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69223 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69229 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69238 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 69244 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69370 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69376 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69384 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69398 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69405 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69414 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69420 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69429 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69437 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69443 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69452 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69458 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69467 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 69473 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69595 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69602 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69621 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 69627 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69635 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69644 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69650 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69659 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69667 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69673 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69682 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69688 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69697 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 69703 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69866 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69872 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69880 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69899 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 69905 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69913 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69922 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69928 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69937 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69945 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69951 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69960 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69966 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 69975 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 69981 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 70169 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70176 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70185 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70191 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70200 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70208 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70214 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70223 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70229 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70237 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70256 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 70262 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70270 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70279 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70285 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70294 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70302 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70308 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70317 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70323 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70332 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70338 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70545 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 70551 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70559 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70568 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70574 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70583 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70591 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70597 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70606 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70612 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70620 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70639 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 70645 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70653 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70662 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70668 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70677 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70685 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70691 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70700 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70706 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70715 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70721 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70870 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 70876 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70882 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70890 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70909 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 70915 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70923 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70932 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70938 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70947 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70955 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70961 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70970 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70976 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 70985 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70991 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 71131 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71137 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71145 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71164 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 71170 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71178 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71187 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71193 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71202 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71210 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 71216 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71225 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71231 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71240 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71246 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 71319 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71326 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71336 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 71342 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71348 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71357 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71363 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71477 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71483 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71491 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71501 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 71507 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71513 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71522 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71528 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 71667 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71674 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71683 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71689 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71698 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71706 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 71712 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71721 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71727 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71735 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71745 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 71751 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71757 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71766 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71772 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71930 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 71936 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71944 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71953 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71959 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71968 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71976 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 71982 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 71991 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71997 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72005 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72015 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 72021 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72027 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 72036 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72042 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72142 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 72148 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72154 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72162 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72172 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 72178 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72184 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 72193 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72199 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 72290 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72296 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72304 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72314 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 72320 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72326 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 72335 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72341 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72407 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72414 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 72422 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72428 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 72437 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72443 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72550 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72556 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72564 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 72572 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72578 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 72587 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72593 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72725 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72732 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72741 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72747 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 72756 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72764 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72770 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 72779 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72785 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72793 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 72801 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72807 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 72816 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72822 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72973 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 72979 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72987 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72996 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73002 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73011 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73019 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73025 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73034 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73040 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73048 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 73056 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73062 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73071 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73077 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73170 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 73176 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73182 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73190 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 73198 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73204 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73213 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73219 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 73303 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73309 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 611 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73317 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 73325 "asllib/Parser0.ml"
                
              in
              
# 606 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73331 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73340 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73346 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73438 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 208 "asllib/Parser0.mly"
                      Some  
# 73444 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 592 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73452 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73461 "asllib/Parser0.ml"
                 _1_1
              in
              
# 607 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73467 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73476 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73482 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 608 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 73561 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73570 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73576 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = e2;
                    MenhirLib.EngineTypes.startp = _startpos_e2_;
                    MenhirLib.EngineTypes.endp = _endpos_e2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = e1;
                        MenhirLib.EngineTypes.startp = _startpos_e1_;
                        MenhirLib.EngineTypes.endp = _endpos_e1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 73667 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73683 "asllib/Parser0.ml"
                 _3_1
              in
              let direction =
                let _1 = _1_inlined2 in
                
# 653 "asllib/Parser0.mly"
                       ( AST.Up )
# 73691 "asllib/Parser0.ml"
                
              in
              let ident = _1_inlined1 in
              
# 649 "asllib/Parser0.mly"
                                                                        AST.S_For 
# 73698 "asllib/Parser0.ml"
               (ident, e1, direction, e2, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73707 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73713 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = e2;
                    MenhirLib.EngineTypes.startp = _startpos_e2_;
                    MenhirLib.EngineTypes.endp = _endpos_e2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = e1;
                        MenhirLib.EngineTypes.startp = _startpos_e1_;
                        MenhirLib.EngineTypes.endp = _endpos_e1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 73804 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73820 "asllib/Parser0.ml"
                 _3_1
              in
              let direction =
                let _1 = _1_inlined2 in
                
# 653 "asllib/Parser0.mly"
                                            ( AST.Down )
# 73828 "asllib/Parser0.ml"
                
              in
              let ident = _1_inlined1 in
              
# 649 "asllib/Parser0.mly"
                                                                        AST.S_For 
# 73835 "asllib/Parser0.ml"
               (ident, e1, direction, e2, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73844 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73850 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73932 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                          AST.S_While 
# 73938 "asllib/Parser0.ml"
               (expr, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 73947 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73953 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _5;
              MenhirLib.EngineTypes.startp = _startpos__5_;
              MenhirLib.EngineTypes.endp = _endpos__5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74049 "asllib/Parser0.ml"
                 _3_1
              in
              
# 651 "asllib/Parser0.mly"
                                                              AST.S_Repeat 
# 74055 "asllib/Parser0.ml"
               (indented_block, expr)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74064 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74070 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 74163 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 74182 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74193 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 74203 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74212 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74218 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 74346 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74372 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74381 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 74387 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74399 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 74409 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74418 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74424 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 74573 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74603 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74610 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74619 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74625 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74634 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74642 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74648 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74657 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74666 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 74672 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74684 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 74694 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74703 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74709 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 74872 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74907 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 74913 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 591 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74921 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74930 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 588 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74936 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74945 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74953 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 515 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74959 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74968 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 74977 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 74983 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74995 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 75005 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 75014 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75020 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75134 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 519 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75160 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 75166 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 75175 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 75181 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 75193 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 75203 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 75212 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75218 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75325 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 491 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 75349 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 75358 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 75364 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 498 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 75376 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 506 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 75386 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 75395 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75401 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75429 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75439 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 289 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 75447 "asllib/Parser0.ml"
            
          in
          (
# 278 "asllib/Parser0.mly"
                                ( [ x ]  )
# 75453 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75488 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 75498 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 289 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 75506 "asllib/Parser0.ml"
            
          in
          (
# 278 "asllib/Parser0.mly"
                                ( [ x ]  )
# 75512 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.bitfield list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75554 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 289 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 75567 "asllib/Parser0.ml"
            
          in
          (
# 279 "asllib/Parser0.mly"
                                ( x :: t )
# 75573 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75601 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75611 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 266 "asllib/Parser0.mly"
                               ( (x, t) )
# 75618 "asllib/Parser0.ml"
            
          in
          (
# 278 "asllib/Parser0.mly"
                                ( [ x ]  )
# 75624 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75659 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 75669 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 266 "asllib/Parser0.mly"
                               ( (x, t) )
# 75676 "asllib/Parser0.ml"
            
          in
          (
# 278 "asllib/Parser0.mly"
                                ( [ x ]  )
# 75682 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_t_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_t_inlined1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.field list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75724 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t_inlined1 : (AST.ty) = Obj.magic t_inlined1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_inlined1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let t = t_inlined1 in
            let x = _1 in
            
# 266 "asllib/Parser0.mly"
                               ( (x, t) )
# 75737 "asllib/Parser0.ml"
            
          in
          (
# 279 "asllib/Parser0.mly"
                                ( x :: t )
# 75743 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75765 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75774 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 278 "asllib/Parser0.mly"
                                ( [ x ]  )
# 75780 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75809 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 75818 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 278 "asllib/Parser0.mly"
                                ( [ x ]  )
# 75824 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let t : (string list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 75860 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x = _1 in
          (
# 279 "asllib/Parser0.mly"
                                ( x :: t )
# 75870 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = body;
            MenhirLib.EngineTypes.startp = _startpos_body_;
            MenhirLib.EngineTypes.endp = _endpos_body_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let body : (AST.stmt list) = Obj.magic body in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.t) = 
# 213 "asllib/Parser0.mly"
    (
      let body = ASTUtils.stmt_from_list body in
      AST.[
        D_Func {
          name = "main";
          args = [];
          parameters = [];
          body = SB_ASL body;
          return_type = None;
          subprogram_type = ST_Procedure;
        } |> ASTUtils.add_pos_from body
      ]
    )
# 75922 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let x = 
# 643 "asllib/Parser0.mly"
              AST.Pattern_Single  
# 75948 "asllib/Parser0.ml"
           expr in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 75953 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 644 "asllib/Parser0.mly"
                                 AST.Pattern_Range  
# 75994 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 75999 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 645 "asllib/Parser0.mly"
           ( AST.Pattern_All )
# 76026 "asllib/Parser0.ml"
           in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76031 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 60 "asllib/Parser0.mly"
       (Bitvector.mask)
# 76053 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1_1 = _1 in
            
# 646 "asllib/Parser0.mly"
                  AST.Pattern_Mask  
# 76064 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76070 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 643 "asllib/Parser0.mly"
              AST.Pattern_Single  
# 76111 "asllib/Parser0.ml"
           expr in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 76116 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 644 "asllib/Parser0.mly"
                                 AST.Pattern_Range  
# 76173 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 76179 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 645 "asllib/Parser0.mly"
           ( AST.Pattern_All )
# 76220 "asllib/Parser0.ml"
           in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 76225 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 60 "asllib/Parser0.mly"
       (Bitvector.mask)
# 76261 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1_1 = _1 in
            
# 646 "asllib/Parser0.mly"
                  AST.Pattern_Mask  
# 76272 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 76278 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.expr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 76304 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.expr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.expr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 76343 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 76370 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            
# 489 "asllib/Parser0.mly"
                             ( (x, t) )
# 76382 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76388 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 76430 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            
# 489 "asllib/Parser0.mly"
                             ( (x, t) )
# 76442 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 76448 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 76470 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76480 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 76516 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = _1 in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 76526 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.local_decl_item) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.local_decl_item list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 76552 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.local_decl_item list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.local_decl_item) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.local_decl_item list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 76591 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.lexpr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 76616 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.lexpr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.lexpr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 76655 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 631 "asllib/Parser0.mly"
             ( AST.Pattern_All )
# 76681 "asllib/Parser0.ml"
           in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76686 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 60 "asllib/Parser0.mly"
       (Bitvector.mask)
# 76708 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1_1 = _1 in
            
# 632 "asllib/Parser0.mly"
                    AST.Pattern_Mask  
# 76719 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76725 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 64 "asllib/Parser0.mly"
       (bool)
# 76747 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 369 "asllib/Parser0.mly"
                       AST.L_Bool        
# 76761 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 76767 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 76776 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 76783 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76789 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 62 "asllib/Parser0.mly"
       (Z.t)
# 76811 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 370 "asllib/Parser0.mly"
                       AST.L_Int         
# 76825 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 76831 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 76840 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 76847 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76853 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 63 "asllib/Parser0.mly"
       (Q.t)
# 76875 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 371 "asllib/Parser0.mly"
                       AST.L_Real        
# 76889 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 76895 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 76904 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 76911 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76917 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 61 "asllib/Parser0.mly"
       (Bitvector.t)
# 76939 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 372 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 76953 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 76959 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 76968 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 76975 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 76981 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 77003 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 373 "asllib/Parser0.mly"
                       AST.L_String      
# 77017 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 77023 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77032 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77039 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 77045 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 77079 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 77085 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let qualident =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 77099 "asllib/Parser0.ml"
                  
                in
                
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 77105 "asllib/Parser0.ml"
                 qualident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77114 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77121 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 77127 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 77149 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let qualident = _1 in
                
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 77162 "asllib/Parser0.ml"
                 qualident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77171 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77178 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 77184 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 77214 "asllib/Parser0.ml"
                 in
                
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 77219 "asllib/Parser0.ml"
                 qualident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77228 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77235 "asllib/Parser0.ml"
             _1_1
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 77241 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let x =
            let x =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 641 "asllib/Parser0.mly"
                                           AST.Pattern_Any  
# 77286 "asllib/Parser0.ml"
               _1_1
            in
            
# 205 "<standard.mly>"
    ( x )
# 77292 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 77298 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 631 "asllib/Parser0.mly"
             ( AST.Pattern_All )
# 77339 "asllib/Parser0.ml"
           in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77344 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 60 "asllib/Parser0.mly"
       (Bitvector.mask)
# 77380 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1_1 = _1 in
            
# 632 "asllib/Parser0.mly"
                    AST.Pattern_Mask  
# 77391 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77397 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 64 "asllib/Parser0.mly"
       (bool)
# 77433 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 369 "asllib/Parser0.mly"
                       AST.L_Bool        
# 77447 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 77453 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77462 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77469 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77475 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 62 "asllib/Parser0.mly"
       (Z.t)
# 77511 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 370 "asllib/Parser0.mly"
                       AST.L_Int         
# 77525 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 77531 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77540 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77547 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77553 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 63 "asllib/Parser0.mly"
       (Q.t)
# 77589 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 371 "asllib/Parser0.mly"
                       AST.L_Real        
# 77603 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 77609 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77618 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77625 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77631 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 61 "asllib/Parser0.mly"
       (Bitvector.t)
# 77667 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 372 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 77681 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 77687 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77696 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77703 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77709 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 77745 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let literal_expression =
                  let _1_1 = _1 in
                  
# 373 "asllib/Parser0.mly"
                       AST.L_String      
# 77759 "asllib/Parser0.ml"
                   _1_1
                in
                
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 77765 "asllib/Parser0.ml"
                 literal_expression
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77774 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77781 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77787 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 77835 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 77841 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let _1 =
              let desc =
                let qualident =
                  let i = _1 in
                  
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 77856 "asllib/Parser0.ml"
                  
                in
                
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 77862 "asllib/Parser0.ml"
                 qualident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77871 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77878 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77884 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 77920 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let qualident = _1 in
                
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 77933 "asllib/Parser0.ml"
                 qualident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 77942 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 77949 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 77955 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let desc =
                let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 77999 "asllib/Parser0.ml"
                 in
                
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 78004 "asllib/Parser0.ml"
                 qualident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 78013 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 78020 "asllib/Parser0.ml"
             _1_1
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 78026 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 641 "asllib/Parser0.mly"
                                           AST.Pattern_Any  
# 78085 "asllib/Parser0.ml"
               _1_1
            in
            
# 205 "<standard.mly>"
    ( x )
# 78091 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 78097 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 78125 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 78137 "asllib/Parser0.ml"
             in
            
# 488 "asllib/Parser0.mly"
                                            ( (x, t) )
# 78142 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 78148 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x_inlined1;
            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 78182 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 78197 "asllib/Parser0.ml"
              
            in
            
# 488 "asllib/Parser0.mly"
                                            ( (x, t) )
# 78203 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 78209 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 78251 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 78263 "asllib/Parser0.ml"
             in
            
# 488 "asllib/Parser0.mly"
                                            ( (x, t) )
# 78268 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 78274 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = t;
                  MenhirLib.EngineTypes.startp = _startpos_t_;
                  MenhirLib.EngineTypes.endp = _endpos_t_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 78322 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 78337 "asllib/Parser0.ml"
              
            in
            
# 488 "asllib/Parser0.mly"
                                            ( (x, t) )
# 78343 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 78349 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = sexpr;
          MenhirLib.EngineTypes.startp = _startpos_sexpr_;
          MenhirLib.EngineTypes.endp = _endpos_sexpr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_sexpr_ in
        let _v =
          let x = 
# 364 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 78376 "asllib/Parser0.ml"
           sexpr in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 78381 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 365 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 78422 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 78427 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 366 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 78468 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 78473 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = sexpr;
              MenhirLib.EngineTypes.startp = _startpos_sexpr_;
              MenhirLib.EngineTypes.endp = _endpos_sexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 364 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 78514 "asllib/Parser0.ml"
           sexpr in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 78519 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 365 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 78576 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 78582 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 366 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 78639 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 78645 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.ty list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 78671 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.ty list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.ty list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 78710 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 78749 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 64 "asllib/Parser0.mly"
       (bool)
# 78770 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 369 "asllib/Parser0.mly"
                       AST.L_Bool        
# 78782 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 78788 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 78797 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 62 "asllib/Parser0.mly"
       (Z.t)
# 78819 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 370 "asllib/Parser0.mly"
                       AST.L_Int         
# 78831 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 78837 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 78846 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 63 "asllib/Parser0.mly"
       (Q.t)
# 78868 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 371 "asllib/Parser0.mly"
                       AST.L_Real        
# 78880 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 78886 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 78895 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 61 "asllib/Parser0.mly"
       (Bitvector.t)
# 78917 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 372 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 78929 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 78935 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 78944 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 78966 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 373 "asllib/Parser0.mly"
                       AST.L_String      
# 78978 "asllib/Parser0.ml"
               _1_1
            in
            
# 338 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 78984 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 78993 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 79027 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 79033 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 79045 "asllib/Parser0.ml"
              
            in
            
# 339 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 79051 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79060 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 79082 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 339 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 79093 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79102 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 79130 "asllib/Parser0.ml"
             in
            
# 339 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 79135 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79144 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 79192 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 79198 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 79208 "asllib/Parser0.ml"
             in
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 79214 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 79219 "asllib/Parser0.ml"
              
            in
            let qualident =
              let _2 = _2_inlined1 in
              let i = _1 in
              
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 79228 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 79235 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79244 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 79299 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 79305 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 79315 "asllib/Parser0.ml"
             in
            let _2 =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 79323 "asllib/Parser0.ml"
              
            in
            let qualident =
              let _2 = _2_inlined1 in
              let i = _1 in
              
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 79332 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 79339 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79348 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 79384 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 79394 "asllib/Parser0.ml"
             in
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 79400 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 79405 "asllib/Parser0.ml"
              
            in
            let qualident = _1 in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 79413 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79422 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 79465 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 79475 "asllib/Parser0.ml"
             in
            let _2 =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 79483 "asllib/Parser0.ml"
              
            in
            let qualident = _1 in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 79491 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79500 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 79542 "asllib/Parser0.ml"
             in
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 79548 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 79553 "asllib/Parser0.ml"
              
            in
            let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 79559 "asllib/Parser0.ml"
             in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 79565 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79574 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let nargs = 
# 325 "asllib/Parser0.mly"
             ( [] )
# 79623 "asllib/Parser0.ml"
             in
            let _2 =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 79631 "asllib/Parser0.ml"
              
            in
            let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 79637 "asllib/Parser0.ml"
             in
            let _2_1 = _2 in
            
# 340 "asllib/Parser0.mly"
                                                        AST.E_Call       
# 79643 "asllib/Parser0.ml"
             (qualident, _2_1, nargs)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79652 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 661 "asllib/Parser0.mly"
            ( AST.BNOT )
# 79687 "asllib/Parser0.ml"
             in
            
# 341 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 79692 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79701 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 662 "asllib/Parser0.mly"
            ( AST.NEG )
# 79736 "asllib/Parser0.ml"
             in
            
# 341 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 79741 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79750 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 663 "asllib/Parser0.mly"
            ( AST.NOT )
# 79785 "asllib/Parser0.ml"
             in
            
# 341 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 79790 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79799 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 668 "asllib/Parser0.mly"
                 ( AST.AND    )
# 79841 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 79846 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79855 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 669 "asllib/Parser0.mly"
                 ( AST.BAND   )
# 79897 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 79902 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79911 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 670 "asllib/Parser0.mly"
                 ( AST.BOR    )
# 79953 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 79958 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 79967 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 671 "asllib/Parser0.mly"
                 ( AST.DIV    )
# 80009 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80014 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80023 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 672 "asllib/Parser0.mly"
                 ( AST.EOR    )
# 80065 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80070 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80079 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 673 "asllib/Parser0.mly"
                 ( AST.EQ_OP  )
# 80121 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80126 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80135 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 674 "asllib/Parser0.mly"
                 ( AST.NEQ    )
# 80177 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80182 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80191 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 675 "asllib/Parser0.mly"
                 ( AST.GEQ    )
# 80233 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80238 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80247 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 676 "asllib/Parser0.mly"
                 ( AST.IMPL   )
# 80289 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80294 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80303 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 677 "asllib/Parser0.mly"
                 ( AST.LEQ    )
# 80345 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80350 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80359 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 678 "asllib/Parser0.mly"
                 ( AST.PLUS   )
# 80401 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80406 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80415 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 679 "asllib/Parser0.mly"
                 ( AST.MINUS  )
# 80457 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80462 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80471 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 680 "asllib/Parser0.mly"
                 ( AST.MOD    )
# 80513 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80518 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80527 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 681 "asllib/Parser0.mly"
                 ( AST.MUL    )
# 80569 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80574 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80583 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 682 "asllib/Parser0.mly"
                 ( AST.OR     )
# 80625 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80630 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80639 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 683 "asllib/Parser0.mly"
                 ( AST.RDIV   )
# 80681 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80686 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80695 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 684 "asllib/Parser0.mly"
                 ( AST.SHL    )
# 80737 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80742 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80751 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 685 "asllib/Parser0.mly"
                 ( AST.SHR    )
# 80793 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80798 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80807 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 665 "asllib/Parser0.mly"
                                  ( AST.PLUS )
# 80849 "asllib/Parser0.ml"
             in
            
# 342 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 80854 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80863 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 274 "asllib/Parser0.mly"
                                           ( h::t )
# 80923 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 80929 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 343 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 80936 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 80945 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 361 "asllib/Parser0.mly"
                                                build_expr_conds  
# 81018 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 344 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 81024 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81033 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 81067 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 345 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 81080 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81089 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 81139 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 81144 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 346 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 81151 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81160 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 81218 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 346 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 81225 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81234 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 81277 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 81282 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 347 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 81289 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81298 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 81349 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 347 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 81356 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81365 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 271 "asllib/Parser0.mly"
                ( [] )
# 81401 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 81406 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 348 "asllib/Parser0.mly"
                                                        AST.E_Concat     
# 81413 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81422 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 81466 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 348 "asllib/Parser0.mly"
                                                        AST.E_Concat     
# 81473 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81482 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern = 
# 631 "asllib/Parser0.mly"
             ( AST.Pattern_All )
# 81524 "asllib/Parser0.ml"
             in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 81529 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81538 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 60 "asllib/Parser0.mly"
       (Bitvector.mask)
# 81572 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1_1 = _1 in
              
# 632 "asllib/Parser0.mly"
                    AST.Pattern_Mask  
# 81586 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 81592 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81601 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 64 "asllib/Parser0.mly"
       (bool)
# 81635 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 369 "asllib/Parser0.mly"
                       AST.L_Bool        
# 81652 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 81658 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81667 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 81674 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 81680 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81689 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 62 "asllib/Parser0.mly"
       (Z.t)
# 81723 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 370 "asllib/Parser0.mly"
                       AST.L_Int         
# 81740 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 81746 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81755 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 81762 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 81768 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81777 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 63 "asllib/Parser0.mly"
       (Q.t)
# 81811 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 371 "asllib/Parser0.mly"
                       AST.L_Real        
# 81828 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 81834 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81843 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 81850 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 81856 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81865 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 61 "asllib/Parser0.mly"
       (Bitvector.t)
# 81899 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 372 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 81916 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 81922 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81931 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 81938 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 81944 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 81953 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 81987 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 373 "asllib/Parser0.mly"
                       AST.L_String      
# 82004 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 635 "asllib/Parser0.mly"
                                AST.E_Literal  
# 82010 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82019 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 82026 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 82032 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82041 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 82087 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 82093 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _2 = _2_inlined1 in
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 320 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 82111 "asllib/Parser0.ml"
                    
                  in
                  
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 82117 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82126 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 82133 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 82139 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82148 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 82182 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 82198 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82207 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 82214 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 82220 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82229 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern =
              let _1 =
                let desc =
                  let qualident = 
# 322 "asllib/Parser0.mly"
              ( "record" )
# 82274 "asllib/Parser0.ml"
                   in
                  
# 636 "asllib/Parser0.mly"
                       AST.E_Var  
# 82279 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82288 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 637 "asllib/Parser0.mly"
         AST.Pattern_Single  
# 82295 "asllib/Parser0.ml"
               _1_1
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 82301 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82310 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let pattern =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 641 "asllib/Parser0.mly"
                                           AST.Pattern_Any  
# 82370 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 82376 "asllib/Parser0.ml"
              
            in
            
# 349 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 82382 "asllib/Parser0.ml"
             (e, pattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82391 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 82427 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82435 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 82442 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82451 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 82487 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82495 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 82502 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82511 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 82547 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82555 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 82562 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82571 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 82600 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 82613 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82622 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 82629 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82638 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 82679 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 82685 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 82700 "asllib/Parser0.ml"
                  
                in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 82706 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82715 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 82722 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82731 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 82767 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82775 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 82782 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82791 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 82849 "asllib/Parser0.ml"
                 in
                
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 82854 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82863 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 82870 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82879 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 82961 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 82967 "asllib/Parser0.ml"
                 in
                
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 82972 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82981 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 82988 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 82997 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 83056 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 83063 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83072 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 83079 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83088 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 83150 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 83171 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 83179 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83188 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 83195 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83204 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 83278 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 83284 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 83306 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 83314 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 83322 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83331 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 83338 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83347 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 83441 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 83449 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83458 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 350 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 83465 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83474 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 83510 "asllib/Parser0.ml"
               in
              let _1 = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 83515 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 83522 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83531 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 83565 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 83578 "asllib/Parser0.ml"
               in
              let _1 = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 83583 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 83590 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83599 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 83635 "asllib/Parser0.ml"
               in
              let _1 = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 83640 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 83647 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83656 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 83690 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 83703 "asllib/Parser0.ml"
               in
              let _1 = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 83708 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 83715 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83724 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 83760 "asllib/Parser0.ml"
               in
              let _1 = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 83765 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 83772 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83781 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 83815 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 83828 "asllib/Parser0.ml"
               in
              let _1 = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 83833 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 83840 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83849 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 83878 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 83889 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 83896 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 83904 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83913 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 83947 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 83953 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 83964 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 83971 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 83979 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 83988 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 84029 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 84035 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 84046 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 84055 "asllib/Parser0.ml"
                  
                in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 84061 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84069 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84078 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 84124 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 84130 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 84136 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 84147 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 84156 "asllib/Parser0.ml"
                  
                in
                
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 84162 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84170 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84179 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 84215 "asllib/Parser0.ml"
               in
              let _1 = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 84220 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84227 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84236 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 84270 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 84283 "asllib/Parser0.ml"
               in
              let _1 = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 84288 "asllib/Parser0.ml"
               in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84295 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84304 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 84361 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 84367 "asllib/Parser0.ml"
                 in
                
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 84372 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84380 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84389 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 84441 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 84459 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 84466 "asllib/Parser0.ml"
                 in
                
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 84471 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84479 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84488 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 84566 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 84575 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 84581 "asllib/Parser0.ml"
                 in
                
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 84586 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84594 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84603 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 84673 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 84694 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 84704 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 84710 "asllib/Parser0.ml"
                 in
                
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 84715 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84723 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84732 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 84789 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 84796 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 84803 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84811 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84820 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 84872 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 84890 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 84898 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 84905 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 84913 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 84922 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 84984 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 84997 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 85011 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 85019 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 85027 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85036 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 85100 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 85109 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 85122 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 85136 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 85144 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 85152 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85161 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 85235 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 85241 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 85254 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 85268 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 85276 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 85284 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 85292 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85301 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 85377 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 85386 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 85392 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 85405 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 85419 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 85427 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 85435 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 85443 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85452 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 85537 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 85551 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 85559 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 85567 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85576 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 59 "asllib/Parser0.mly"
       (string)
# 85652 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 85672 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 85686 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 85694 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 324 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 85702 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85711 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 292 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 85738 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85746 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 293 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 85773 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85781 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 294 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 85808 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85816 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 85838 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident = _1 in
            
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 85849 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85858 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 59 "asllib/Parser0.mly"
       (string)
# 85892 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 85898 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident =
              let i = _1 in
              
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 85910 "asllib/Parser0.ml"
              
            in
            
# 295 "asllib/Parser0.mly"
                            AST.T_Named                
# 85916 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85925 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 296 "asllib/Parser0.mly"
                          ( t_bit                     )
# 85952 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 85960 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let e = 
# 205 "<standard.mly>"
    ( x )
# 86009 "asllib/Parser0.ml"
             in
            
# 297 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 86014 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 86023 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let b =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 86096 "asllib/Parser0.ml"
              
            in
            let e = 
# 205 "<standard.mly>"
    ( x )
# 86102 "asllib/Parser0.ml"
             in
            
# 298 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 86107 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 86116 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let _2 = 
# 205 "<standard.mly>"
    ( x )
# 86166 "asllib/Parser0.ml"
               in
              ()
            in
            
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 86173 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 86182 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 86237 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 86256 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 86264 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 86273 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 59 "asllib/Parser0.mly"
       (string)
# 86340 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 65 "asllib/Parser0.mly"
       (string)
# 86346 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  let _1 =
                    let i = _1 in
                    
# 312 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 86365 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 86373 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 86381 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 86390 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let (_3, _1) = (_3_inlined1, _1_inlined1) in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 86474 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 238 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 86482 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 86491 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.ty list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.ty) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 274 "asllib/Parser0.mly"
                                           ( h::t )
# 86551 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 86557 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 285 "asllib/Parser0.mly"
                              AST.T_Tuple  
# 86564 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 235 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos })
# 86573 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
    |]
  
  and trace =
    None
  
end

module MenhirInterpreter = struct
  
  module ET = MenhirLib.TableInterpreter.MakeEngineTable (Tables)
  
  module TI = MenhirLib.Engine.Make (ET)
  
  include TI
  
end

let opn =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 1885 lexer lexbuf)

and ast =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 0 lexer lexbuf)

module Incremental = struct
  
  let opn =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 1885 initial_position)
  
  and ast =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 0 initial_position)
  
end
